-- usdLua.lua

plg.lib1version = 60

if tonumber('zzzzzzzz',36)~=2821109907455 then plg.msg('Old lua5.1.dll !') end
local _h,_e = io.open(usd.workdir..[[Lua\base64.lua]]);
if _h then _h:close(); usd.savetolog('Deleting base64.lua ...'); os.remove(usd.workdir..[[Lua\base64.lua]]) end

--usd.savetolog( ('os.setlocale: %s'):format(os.setlocale("")) ) --    
usd.savetolog( ('os.setlocale: %s'):format(os.setlocale("", 'ctype')) )

function debugLog(str) if usd.fdebug then usd.savetolog(str) end end

--package.cpath = usd.workdir .. [[Lua\?.dll;]] .. package.cpath	--   dll  Lua\
package.cpath = usd.workdir..[[Lua\?51.dll;]] .. usd.workdir..[[Lua\?.dll;?51.dll;]] .. package.cpath	--   dll  Lua\

bit = require("bit")	--    http://bitop.luajit.org/

zlib = require("zlib")	-- http://luaforge.net/projects/lzlib/

lpeg = require'lpeg'	-- Parsing Expression Grammars For Lua
debugLog('LPeg v'..lpeg.version())

re   = require're'		-- http://www.inf.puc-rio.br/~roberto/lpeg/lpeg.html
lpeg.setmaxstack(150)
lpeg.locale(lpeg)

ascii85 = require'ascii85'	-- http://www.tecgraf.puc-rio.br/~lhf/ftp/lua/  http://luarocks.org/repositories/rocks/

struct = require 'struct'	-- http://www.inf.puc-rio.br/~roberto/struct/
--buffer = require 'buffer'	-- https://github.com/starwing/lbuffer

--openssl = require 'openssl' -- https://github.com/zhaozg/lua-openssl/ --    >40 
ltn12ce = require 'ltn12ce.core'	-- https://github.com/mkottman/ltn12ce/

require("base64")	-- http://webserver2.tecgraf.puc-rio.br/~lhf/ftp/lua/#lbase64 + RFC 3548 URL mod + no padding mod
base64.dec, base64.enc = base64.decode, base64.encode
debugLog(base64.version or '<no base64.version>')


if plg.filesize(usd.workdir..[[\Lua\iuplua51.dll]]) then
	plg.currentdirectory(usd.workdir..[[\Lua]])	-- iupluaim51.dll  imlua51.dll  iuplua51.dll
	require "iuplua"
	require "iupluaim"
	debugLog('IUP v'..iup._VERSION..' '..iup._VERSION_NUMBER..' '..iup._VERSION_DATE)
	plg.currentdirectory(usd.workdir)
end

--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------

USD_SETCOOKIE_APPEND = 0
USD_SETCOOKIE_OVERWRITE = 1

--plg.msg
-- 
MB_OK               = 0x0
MB_OKCANCEL         = 0x1
MB_ABORTRETRYIGNORE = 0x2
MB_YESNOCANCEL      = 0x3
MB_YESNO            = 0x4
MB_RETRYCANCEL      = 0x5
-- 
MB_ICONHAND         = 0x10
MB_ICONSTOP         = MB_ICONHAND
MB_ICONERROR        = MB_ICONHAND
MB_ICONQUESTION     = 0x20
MB_ICONEXCLAMATION  = 0x30
MB_ICONWARNING      = MB_ICONEXCLAMATION
MB_ICONASTERISK     = 0x40
MB_ICONINFORMATION  = MB_ICONASTERISK
-- 
IDOK                = 1
IDCANCEL            = 2
IDABORT             = 3
IDRETRY             = 4
IDIGNORE            = 5
IDYES               = 6
IDNO                = 7
IDCLOSE             = 8
IDHELP              = 9

--plg.recode
CP_ACP				= 0
CP_OEMCP			= 1
CP_UTF8				= 65001
CP_WINUNICODE		= 1200

MAX_PATH			= 260


SW_HIDE             = 0
SW_SHOWNORMAL       = 1
SW_NORMAL           = 1
SW_SHOWMINIMIZED    = 2
SW_SHOWMAXIMIZED    = 3
SW_MAXIMIZE         = 3
SW_SHOWNOACTIVATE   = 4
SW_SHOW             = 5
SW_MINIMIZE         = 6
SW_SHOWMINNOACTIVE  = 7
SW_SHOWNA           = 8
SW_RESTORE          = 9
SW_SHOWDEFAULT      = 10
SW_MAX              = 10
SW_FORCEMINIMIZE    = 11

SND_ALIAS       = 0x10000
SND_ALIAS_ID    = 0x110000
SND_ALIAS_START = 0x0
SND_APPLICATION = 0x80
SND_ASYNC       = 0x1
SND_FILENAME    = 0x20000
SND_LOOP        = 0x8
SND_MEMORY      = 0x4
SND_NODEFAULT   = 0x2
SND_NOSTOP      = 0x10
SND_PURGE       = 0x40
SND_RESOURCE    = 0x40004
SND_SYNC        = 0x0
SND_TYPE_MASK   = 0x170007
SND_VALID       = 0x1F
SND_VALIDFLAGS  = 0x17201F

SND_ALIAS_START				= 0
SND_ALIAS_SYSTEMASTERISK	= 0x00002A53
SND_ALIAS_SYSTEMDEFAULT		= 0x00004453
SND_ALIAS_SYSTEMEXCLAMATION	= 0x00002153
SND_ALIAS_SYSTEMEXIT		= 0x00004553
SND_ALIAS_SYSTEMHAND		= 0x00004853
SND_ALIAS_SYSTEMQUESTION	= 0x00003F53
SND_ALIAS_SYSTEMSTART		= 0x00005353
SND_ALIAS_SYSTEMWELCOME		= 0x00005753

WM_USER 		= 0x400
CCM_FIRST 		= 0x2000
CCM_SETBKCOLOR	= CCM_FIRST+1
PBM_SETBARCOLOR	= WM_USER+9
PBM_SETBKCOLOR	= CCM_SETBKCOLOR
PBM_SETMARQUEE	= WM_USER+10
PBM_SETPOS		= WM_USER+2
PBM_SETRANGE32	= WM_USER+6
PBM_SETSTEP		= WM_USER+4
PBM_STEPIT		= WM_USER+5
PBS_MARQUEE		= 8
PBS_SMOOTH		= 1

CLR_DEFAULT		= 0xFF000000

function tableCopy(tbl)
	local r = {}
	for k, v in pairs(tbl) do
		r[k] = type(v)=='table' and tableCopy(v) or v
	end
	return r
end

function tableCombine(base, new)
	local r = tableCopy(base)
	for k, v in pairs(new) do
		r[k] = type(v)=='table' and tableCombine(type(r[k])=='table' and r[k] or {}, v) or v
	end
	return r
end

function tableKeys(...)
	local tbl = {}
	for k,v in pairs({...}) do tbl[v] = v end
	return tbl
end

function tableConcat(tbl, sepKV, sepPairs, encode)
	sepKV = sepKV or ''
	sepPairs = sepPairs or ''
	local r = {}
	for k, v in pairs(tbl) do
		if encode then
			k = encode(k)
			v = encode(v)
		end
		table.insert(r, tostring(k)..sepKV..tostring(v))
	end
	return table.concat(r, sepPairs)
end

function tableGetKeys(tbl)
	local tmp = {}
	for k, v in pairs(tbl) do table.insert(tmp,k) end
	return tmp
end

function tableGetValues(tbl)
	local tmp = {}
	for k, v in pairs(tbl) do table.insert(tmp,v) end
	return tmp
end

function tableCompare(t1, t2)
	local count1, count2 = 0, 0
	for k, v in pairs(t1) do
		count1 = count1+1
		if type(v)=='table' then
			if type(t2[k])~='table' or not tableCompare(v, t2[k]) then return false end
		else
			if v~= t2[k] then return false end
		end
	end
	for _ in pairs(t2) do count2 = count2+1 end
	return count1==count2
end

function tableContains(tbl, ...)
	local tmp = {...}
	if #tmp==0 then return nil end
	for k, v in pairs(tbl) do
		for kk, vv in pairs(tmp) do
			if v==vv then return k end
		end
	end
	return nil
end

function tableReverse(tbl)
	local tmp={}
	for i=#tbl,1,-1 do tmp[#tmp+1]=tbl[i] end
	return tmp
end

Storage = Storage or {}
__Storage__Old__ = tableCopy(Storage)

local tmpData = {
	getLstInfoCache = nil
    , getMirrorUrl = nil
    , cacheHosts = nil
    , IP
}


local function readIni()
	local tbl, section = {}
	local ln = 0
	for line in io.lines(usd.workdir .. plg.exename .. '.ini') do if not line:find('^%s*$') and not line:find('^%s*;') then
		ln = ln+1
		if line:find('^%[(.-)%]$') then
			local tmp = line:match('^%[(.-)%]$'):lower()
			local s1, s2 = tmp:match('^(plugin)_(.+)$')
			s1 = s1 or tmp
			tbl[s1] = tbl[s1] or {}
			section = tbl[s1]
	        if s2 then
				tbl[s1][s2] = tbl[s1][s2] or {}
				section = tbl[s1][s2]
	        end
		else
			--local name, value = line:match('^([^=]+)=(.*)$')
			local name, value = line:match('^%s*([^=]-)%s*=%s*(.-)%s*$')
			if not (name and value) then
				usd.savetolog('Bad line '..ln..' in '.. plg.exename ..'.ini: >'..line..'<')
			else
				name = name:lower()
				local n1, n2 = name:match('^item(%d+)_?(.-)$')
				n1 = n1 and tonumber(n1)
				n2 = n2 or (value:find('^http') and 'url' or '_')
				value = value ~= '' and value --   = false
				if n1 then
					section[n1] = section[n1] or {}
					section[n1][n2] = value
				else
					section[name] = value
				end
			end
		end
	end end
	return tbl
end


local tmpUsd = usd
tmpUsd.ini = readIni()

--local tmpHttp = http

--usdIni = readIni()
--if tmpHttp then
--tmpHttp.USERAGENT = usd.ini.main.useragent
--tmpHttp.PROXY = usd.ini.proxy.usehttpproxy == '1' and ('http://'..usd.ini.httpproxy.address..':'..usd.ini.httpproxy.port..'/')
--end

math.randomseed(os.time()); math.random(); math.random(); math.random(); -- skip first numbers

function utf8ToAnsi(str)
	return plg.recode(CP_UTF8, CP_ACP, str)
end

--       (  ).
function pad(str, len, symb, right)
	str = tostring(str)
	symb = symb or '0'
	if right then return str..symb:rep(len-#str) end
	return symb:rep(len-#str) .. str
end

function pad2(str, width, padChar3, padChar2)
	width = type(width)=='number' and width or (plg.gettextextent(width))
	padChar2 = padChar2 or 'l' -- 2px
	padChar3 = padChar3 or '.' -- 3px
	local widthPC2, widthPC3 = plg.gettextextent(padChar2), plg.gettextextent(padChar3)
	local diff = width - plg.gettextextent(str)
	if diff < widthPC2 then return '' end
	local add2 = ''
	if (diff-widthPC2)%widthPC3==0 then
		add2 = padChar2
		diff = diff-widthPC2
	elseif (diff-widthPC2*2)%widthPC3==0 then
		add2 = padChar2..padChar2
		diff = diff-widthPC2*2
	end
	return add2..padChar3:rep(diff/widthPC3)
end


function randomPairs(tbl)
	local keys = tableGetKeys(tbl)
	return function()
		if #keys==0 then return nil end
		local r = math.random(#keys)
		local k = keys[r]
		local v = tbl[k]
		table.remove(keys, r)
		return k, v
	end
end



---       
--- t1 = counters.test;  t2 = counters.test;  counters.set('test',123);  t3 = counters.test;  counters.reset();  t4 = counters.test;  t5 = counters.test
--- plg.msg('t1='..t1..', t2='..t2..', t3='..t3..', t4='..t4..', t5='..t5) -- t1=1, t2=2, t3=123, t4=1, t5=2
counters = (function(tbl)
		local proxy = {} -- http://www.lua.org/pil/13.4.5.html
		proxy.reset = function() for k,v in pairs(tbl) do tbl[k]=nil end end
		proxy.set = function(cnt, val)
			if (type(cnt)~='string' or cnt=='set' or cnt=='reset') then
				error("Invalid counter name: '"..tostring(cnt).."'")
			elseif (type(val)~='number' and val~=nil) then
				error("Invalid type '"..type(val).."' for counter '"..tostring(cnt).."'")
			else
				tbl[cnt]=val
			end
		end
		local mt = {
			__index = function(t,k)
				local a = tbl[k] or 1
				--if type(a)=='number' then tbl[k] = a+1 end
				tbl[k] = a+1
				return a
			end
			--,__newindex = function(t,k,v)  tbl[k]=v  end
		}
		setmetatable(proxy, mt)
		return proxy
	end){};

--    
-- fname -    ;     
-- cnt -    counters
-- digs -    digs 
----
-- getNextName('for_debug.html', counters.debugSave) --> 'for_debug_01.html'
-- getNextName('for_debug.html', counters.debugSave, 4) --> 'for_debug_0002.html'
function getNextName(fname, cnt, digs)
	digs = digs or 2
	local name, ext = string.match(fname, '^(.+)(%.[^%.]+)$')
	name = name or fname
	ext = ext or ''
	return name .. '_' .. pad(cnt,digs) .. ext
end


function debugSave(fName, data, str, addinfo)
	--local tf, td = type(fName), type(data)
	if type(fName) ~= 'string' or #fName==0 then error('debugSave: invalid fName: '..tostring(fName)..' ('..type(fName)..')') end
	if type(data) ~= 'string' then error('debugSave: invalid data: '..tostring(data)..' ('..type(data)..')') end
	if usd.fdebug then
		usd.savetolog('debugSave: '..fName)
		if str then
			str = tostring(str)
			if #str<137 then
				usd.savetolog(str)
			elseif str:find('^{') or str:find('^[^\r\n]*[\r\n]+{') then
				usd.savetolog( (str:match('^([^\r\n]*[\r\n]+){') or '') .. '[long string]')
			else
				usd.savetolog(str:sub(1,130)..'... [cut]')
			end
			--usd.savetolog(#str<137 and str or str:sub(1,130)..'...[cut]')
		end
		local info = (addinfo or addinfo==nil) and ('<pre>\r\nsize: '..#data..'\r\n\r\n'..(str and str..'\r\n\r\n' or '')..usd.getheaders() .. '\r\nCookie: '..usd.getcookie()..'\r\n</pre>\r\n\r\n') or ''
		--usd.savetofile(usd.workdir .. fName, info .. data)
		fileWrite(usd.workdir .. filterName(fName), info .. data)
	end
end

function debugSaveInc(fName, data, str, addinfo)
	debugSave(getNextName(fName, counters.debugSave), data, str, addinfo)
	return
end


-- http://lua-list.2524044.n2.nabble.com/JSON-module-td5473516.html
function n2utf8 (n)
	local char,floor = string.char, math.floor
	if n < 0x80 then
		return char (n)
	elseif n < 0x800 then
		return char (0xC0+floor (n/0x40)
			, 0x80+n%0x40)
	elseif n <= 0x10000 then
		return char (0xE0+floor (n/0x1000)
			, 0x80+floor ((n%0x1000)/0x40)
			, 0x80+n%0x40)
	elseif n <= 0x110000 then
		return char (0xF0+floor (n/0x40000)
			,0x80+floor ((n%0x40000)/0x1000)
			,0x80+floor ((n%0x1000)/0x40)
			,0x80+n%0x40)
	end
end



function unescape(s)	-- LuaSocket \socket\url.lua
    return (string.gsub(s, "%%(%x%x)", function(hex)
        return string.char(tonumber(hex, 16))
    end))  -- http://www.luafaq.org/gotchas.html 8.1
end


--  encodeURI -- javascript:prompt('',encodeURI('`-=~!@#$%^&*()_+[]{};\':",./<>?\\|'))
-- %60-=~!@#$%25%5E&*()_+%5B%5D%7B%7D;':%22,./%3C%3E?%5C%7C
function escapeU(s)
    return (string.gsub(s, "([^A-Za-z0-9=~!@#$&*()_+;:,./?-])", function(c)
        return string.format("%%%02X", string.byte(c))
    end)) -- http://www.luafaq.org/gotchas.html 8.1
end

--  encodeURIComponent -- javascript:prompt('',encodeURIComponent('`-=~!@#$%^&*()_+[]{};\':",./<>?\\|'))
function escapeUC(s)
    return (string.gsub(s, "([^A-Za-z0-9%-%.%*_!~()])", function(c)
        return string.format("%%%02X", string.byte(c))
    end)) -- http://www.luafaq.org/gotchas.html 8.1
end


function escapeLua(s,encode)
	local s2 = (s:gsub ('([()%%%[%].?*+-])','%%%1'):gsub('^^','%%^'):gsub('$$','%%$'))
	if encode then s2 = s2:gsub('[^_^ !@#$&=`~{}:;"\'|<,>/\\%da-zA-Z()%%%[%].?*+-]',function(c)return '\\'..pad(c:byte(),3)end) end
	return s2
end

do
	local function setKeys(tbl, value, keys)	for _,v in ipairs(keys) do tbl[v]=value end end

	local entities = {	--   UTF-8
		  --nbsp = ' ', [160] = ' ' --   --   utf8
		  nbsp	= n2utf8(160), iexcl	= n2utf8(161), cent		= n2utf8(162), pound	= n2utf8(163), curren	= n2utf8(164)
		, yen	= n2utf8(165), brvbar	= n2utf8(166), sect		= n2utf8(167), uml		= n2utf8(168), copy		= n2utf8(169)
		, ordf	= n2utf8(170), laquo	= n2utf8(171), ['not']	= n2utf8(172), shy		= n2utf8(173), reg		= n2utf8(174)
		, macr	= n2utf8(175), deg		= n2utf8(176), plusmn	= n2utf8(177), sup2		= n2utf8(178), sup3		= n2utf8(179)
		, acute	= n2utf8(180), micro	= n2utf8(181), para		= n2utf8(182), middot	= n2utf8(183), cedil	= n2utf8(184)
		, sup1	= n2utf8(185), ordm		= n2utf8(186), raquo	= n2utf8(187), frac14	= n2utf8(188), frac12	= n2utf8(189)
		, frac34= n2utf8(190), iquest	= n2utf8(191), Agrave	= n2utf8(192), Aacute	= n2utf8(193), Acirc	= n2utf8(194)
		, Atilde= n2utf8(195), Auml		= n2utf8(196), Aring	= n2utf8(197), AElig	= n2utf8(198), Ccedil	= n2utf8(199)
		, Egrave= n2utf8(200), Eacute	= n2utf8(201), Ecirc	= n2utf8(202), Euml		= n2utf8(203), Igrave	= n2utf8(204)
		, Iacute= n2utf8(205), Icirc	= n2utf8(206), Iuml		= n2utf8(207), ETH		= n2utf8(208), Ntilde	= n2utf8(209)
		, Ograve= n2utf8(210), Oacute	= n2utf8(211), Ocirc	= n2utf8(212), Otilde	= n2utf8(213), Ouml		= n2utf8(214)
		, times	= n2utf8(215), Oslash	= n2utf8(216), Ugrave	= n2utf8(217), Uacute	= n2utf8(218), Ucirc	= n2utf8(219)
		, Uuml	= n2utf8(220), Yacute	= n2utf8(221), THORN	= n2utf8(222), szlig	= n2utf8(223), agrave	= n2utf8(224)
		, aacute= n2utf8(225), acirc	= n2utf8(226), atilde	= n2utf8(227), auml		= n2utf8(228), aring	= n2utf8(229)
		, aelig	= n2utf8(230), ccedil	= n2utf8(231), egrave	= n2utf8(232), eacute	= n2utf8(233), ecirc	= n2utf8(234)
		, euml	= n2utf8(235), igrave	= n2utf8(236), iacute	= n2utf8(237), icirc	= n2utf8(238), iuml		= n2utf8(239)
		, eth	= n2utf8(240), ntilde	= n2utf8(241), ograve	= n2utf8(242), oacute	= n2utf8(243), ocirc	= n2utf8(244)
		, otilde= n2utf8(245), ouml		= n2utf8(246), divide	= n2utf8(247), oslash	= n2utf8(248), ugrave	= n2utf8(249)
		, uacute= n2utf8(250), ucirc	= n2utf8(251), uuml		= n2utf8(252), yacute	= n2utf8(253), thorn	= n2utf8(254)
		, yuml	= n2utf8(255)
		, quot  = '"'
		, rdquo = '"'
		, ldquo = '"'
		, bdquo = '"'
		, apos   = "'"
		, rsquo  = "'"
		, lsquo  = "'"
		, sbquo  = "'"
		, amp = '&'
		, lt = '<'
		, gt = '>'
		, lsaquo = '<'
		, rsaquo = '>'
		, bull = '*', [8226] = '*'
		, [9679] = '*'
		, ndash = '-', [8211] = '-'
		, mdash = '-', [8212] = '-'
		, hellip = '...'
		, [8203] = ''	-- Zero Width Space
	}
	setKeys(entities, ' ', {'emsp', 8195, 'ensp', 8194, 8196, 8197, 8198, 'thinsp', 8201, 8202})
	setKeys(entities, '/', {'frasl', 8260, 8725})

	local _toAnsi
	local function decode(n,x,w)
			local num = tonumber(w, x=='x' and 16 or 10)
			local tmp
			if n == '#' and num then
				tmp = entities[num] or n2utf8(num)
			else
				tmp = entities[x..w] or '&'..n..x..w..';'
			end
			return _toAnsi and utf8ToAnsi(tmp) or tmp
		end
	function entityDecode(str, toAnsi)
		_toAnsi = toAnsi
		return (string.gsub(str,'&(#?)(x?)([%w]+);', decode))
	end
end

do
	--http://lua-users.org/wiki/RandomStrings
	local Chars = {}
	for Loop = 0, 255 do
	   Chars[Loop+1] = string.char(Loop)
	end
	local String = table.concat(Chars)
	local Built = {['.'] = Chars}
	local AddLookup = function(CharSet)
	   local Substitute = string.gsub(String, '[^'..CharSet..']', '')
	   local Lookup = {}
	   for Loop = 1, string.len(Substitute) do
	       Lookup[Loop] = string.sub(Substitute, Loop, Loop)
	   end
	   Built[CharSet] = Lookup
	   return Lookup
	end
	function randomString(Length, CharSet)
	   -- Length (number)
	   -- CharSet (string, optional); e.g. %l%d for lower case letters and digits
	   local CharSet = CharSet or '.'
	   if CharSet == '' then
	      return ''
	   else
	      local Result = {}
	      local Lookup = Built[CharSet] or AddLookup(CharSet)
	      local Range = #Lookup
	      for Loop = 1,Length do
	         Result[Loop] = Lookup[math.random(1, Range)]
	      end
	      return table.concat(Result)
	   end
	end
end

do
	local p = re.compile([[
		pattern  <- ( {b} / {escaped} / brackets / other)+
		b        <- "%b" . .
		escaped  <- "%" .
		brackets <- { "[" ([^]%]+ / escaped)* "]" }
		other	 <- [^[%]+ -> cases
	]], {
		cases = function(str) return (str:gsub('%a',function(a) return '['..a:lower()..a:upper()..']' end)) end
	})
	local pb = re.compile([[
		pattern  <- ( {b} / {escaped} / brackets / other)+
		b        <- "%b" . .
		escaped  <- "%" .
		brackets <- {: {"["} ({escaped} / bcases)* {"]"} :}
		bcases   <- [^]%]+ -> bcases
		other	 <- [^[%]+ -> cases
	]], {
		cases = function(str) return (str:gsub('%a',function(a) return '['..a:lower()..a:upper()..']' end)) end
		, bcases = function(str) return (str:gsub('%a',function(a) return a:lower()..a:upper() end)) end
	})
	function iPattern(pattern,brackets)
		('sanity check'):find(pattern)
		return table.concat({re.match(pattern, brackets and pb or p)})
	end
end
function iFind (s, pattern, init, plain)
	if plain then pattern = escapeLua(pattern) end
	return string.find(s, iPattern(pattern, true), init)
end
function iGmatch (s, pattern) return string.gmatch (s, iPattern(pattern, true)) end
function iGsub (s, pattern, repl, n) return string.gsub (s, iPattern(pattern, true), repl, n) end
function iMatch (s, pattern, init) return string.match (s, iPattern(pattern, true), init) end



plg.tHosts     = {}	--     PlgInit -     
--  - ,  - 
plg.tDirLink   = {}	--      
plg.tOnSuccess = {}
plg.tSkipUrl   = {} --     
plg.tOnCheck   = {}
plg.tOnError   = {}
plg.tDestroy   = {}

--[[
regDirSuccess    
urlPart -  , 
fnDirLink -    , 
fnOnSuccess -     , ;      
]]
function regDirSuccess(urlPart, fnDirLink, fnOnSuccess, fnSkipUrl)
	if type(urlPart) == 'table' then
		for k, v in pairs(urlPart) do regDirSuccess(v, fnDirLink, fnOnSuccess, fnSkipUrl) end
		return
	end

	if type(urlPart) ~= 'string' or #urlPart < 5 then
		error("regDirSuccess error: urlPart must be a string of at least 5 characters: '" .. (urlPart or '') .. "'", 2) end
	if type(fnDirLink) ~= 'function' or type(fnOnSuccess) ~= 'function' and fnOnSuccess~=nil then
		error('regDirSuccess error: fnDirLink must be a function, fnOnSuccess must be a function or nil', 2) end
	if not plg.tDirLink[urlPart] then table.insert(plg.tHosts, urlPart) end  --     
	if plg.tDirLink[urlPart] then    debugLog('Warning: tDirLink[urlPart] exist:    '..urlPart) end
	if plg.tOnSuccess[urlPart] then  debugLog('Warning: tOnSuccess[urlPart] exist:  '..urlPart) end
	plg.tDirLink[urlPart]   = fnDirLink;
	plg.tSkipUrl[urlPart]   = fnSkipUrl;
	plg.tOnSuccess[urlPart] = fnOnSuccess;
	if Settings and Settings['<misc>'] and Settings['<misc>'].logSupportedHosts then debugLog('        '..urlPart) end
end

--[[
regCheckError    
dirUrlPart -   / , 
]]
function regCheckError(dirUrlPart, fnOnCheck, fnOnError)
	if type(dirUrlPart) == 'table' then
		for k, v in pairs(dirUrlPart) do regCheckError(v, fnOnCheck, fnOnError) end
		return
	end

	if type(dirUrlPart) ~= 'string' or #dirUrlPart < 5 then
		error("regCheckError error: dirUrlPart must be a string of at least 5 characters '" .. (dirUrlPart or '') .. "'", 2) end
	if type(fnOnCheck) ~= 'function' and fnOnCheck~=nil or type(fnOnError) ~= 'function' and fnOnError~=nil then
		error('regCheckError error: fnOnCheck and fnOnError must be a function or nil', 2) end
	if plg.tOnCheck[dirUrlPart] then debugLog('Warning: tOnCheck[dirUrlPart] exist: '..dirUrlPart) end
	if plg.tOnError[dirUrlPart] then debugLog('Warning: tOnError[dirUrlPart] exist: '..dirUrlPart) end
	plg.tOnCheck[dirUrlPart] = fnOnCheck;
	plg.tOnError[dirUrlPart] = fnOnError;
end

--[[
regDestroy     plg.tDestroy,   
  ;   1   
]]
function regDestroy(fnDestroy)
	if type(fnDestroy) ~= 'function' then
		error('regDestroy error: fnDestroy must be a function', 2) end
	--local _ = getfenv(2)
	--local sn = _.script and _.script.name
	local sn = getfenv(2).script.name
	plg.tDestroy[sn] = fnDestroy
end

--  PlgInit    USD  
function PlgInit()
	usd.setretresult(table.concat(plg.tHosts, '\n') .. '|1036')
end

function getHandler(tbl,u)
	u = string.lower(u)
	local f, h, s = math.huge, nil	-- position, handler, substring
	for k, v in pairs(tbl) do
		local tmp = string.find(u, k:lower(), 1, true)
		if tmp and tmp<f then f, h, s = tmp, tbl[k], k end
	end
	return h, s
end

--local getMirrorUrl
--local getLstInfoCache

local function GDLinit(ini, url)
	--debugLog( ('os.setlocale: %s'):format(os.setlocale('C')) )
	debugLog( ('os.setlocale: %s'):format(os.setlocale('', 'ctype')) )
	usd.relocationmode(1)
	usd.setretresult('')

	usd.setreferer('')
	usd.setcookie('')
	local sm = Settings['<misc>']
	if type(sm.extIPservices)=='table' then sm.extIP = sm.extIPservices[math.random(#sm.extIPservices)] end

	--debugLog('GDLinit: usd.getlocation()='..serialize(usd.getlocation()))
	--debugLog('GDLinit: previous: '..serialize(getHost(usd.getlocation(),nil,nil,2) or '<no host 2>'))
	local shit = sm.crutchHttpMode=='auto' and tableContains(sm.needCrutch or {}, getHost(usd.getlocation(),nil,nil,2))	-- previous download
	if shit then debugLog('autoCrutch') end

	if (sm.crutchHttpMode=='on' or shit) and sm.crutchHttp then
		debugLog('crutchHttp'..(shit and ' ('..sm.needCrutch[shit]..')' or ''))
		usd.get(Settings['<misc>'].crutchHttp)
		usd.get(Settings['<misc>'].crutchHttp)
		usd.setreferer('')
		usd.setcookie('')
	end

	if usd.fdebug then
		local host = URI.parse(url).host or '<no host>'
		if host:find('.',1,true) then usd.savetolog('Resolved '..host..': '..serialize(plg.resolve(host) or '<nil>')) end --- ftp://m/
	end

	--usd.get('http://0.0.0.0/headers/')
	if ini then
		tmpData = {}
		tmpUsd.ini = readIni()
		if tmpHttp then
			tmpHttp.USERAGENT = usd.ini.main.useragent
			tmpHttp.PROXY = usd.ini.proxy.usehttpproxy == '1' and ('http://'..usd.ini.httpproxy.address..':'..usd.ini.httpproxy.port..'/')
		end
		Cache.delOld()
		Timeout.delOld()
	end

	if Settings['<userGDLinit>'] then
		debugLog("Settings['<userGDLinit>']() ...")
		Settings['<userGDLinit>'](url)
		debugLog("Settings['<userGDLinit>']() end")
	end
end

--  tDirLink    
function PlgGetDirectLink(origUrl)
	counters.reset()
	if Settings['<misc>'].GDLpause then usd.waittime(Settings['<misc>'].GDLpause) end
	GDLinit(true, origUrl)
--usd.waittime(1)
	-- origUrl = URI.recode(origUrl, true)
	local GetDirectLinkHandler = getHandler(plg.tDirLink, origUrl)
	if GetDirectLinkHandler then
		local fn = debug.getfenv(GetDirectLinkHandler).script
		debugLog('GDL: ' .. (fn and fn.fullname or '<no script.fullname>') )
		GetDirectLinkHandler(origUrl)

		--usd.setretresult('%Server report: You need wait ' .. (h*60+m)*60+s .. ' seconds')
		local r = plg.getretresult()	-- 
		local wait = r:match('^%%Server report: You need wait (%d+) seconds')
		if wait and tonumber(wait) <= plg.config.maxwait then
			usd.setstatus(r)
			debugLog('plg.config.maxwait='.. plg.config.maxwait..', '..r)
			usd.setretresult('')
			usd.setretresult('%Server report: You need wait '..(wait+math.random(2,6))..' seconds', wait)
			return
			--usd.waittime(wait+2)
			--if usd.progstatus() == 0 then
			--	debugLog('USD stopped')
			--	return
			--end
			--GDLinit(false)
			--GetDirectLinkHandler(origUrl)
		end

		--if r == '' then usd.waittime(10) end
		r = plg.getretresult()	-- 
		if r:find('^https?://') then
			local host = URI.parse(r).host or '<no host>'
			debugLog('Resolved '..host..': '..serialize(plg.resolve(host) or '<nil>'))
			local c = Settings['<misc>'] and Settings['<misc>'].saveCookiesTo
			if c then
				debugLog('Saving cookies into '..c)
				local h, err = io.open(c, 'wb')
				if h then
					h:write(usd.getcookie())
					h:close()
				else
					usd.savetolog(err)
				end
			end
		end

		return
	end
	local err = 'PlgGetDirectLink handler not found: ' .. origUrl
	usd.setretresult('%'..err)
	error(err) --  - ,  USD   :-)
end

local OCfullNamePusd, OCheaders

function PlgOnSuccess(origUrl, dirUrl, fullName)
	usd.setretresult('');

	debugLog('usd.progstatus()='..usd.progstatus());
	debugLog('PlgOnSuccess origUrl='..origUrl);
	--origUrl = URI.recode(origUrl, true)

	if tmpData.getMirrorUrl then
		debugLog('        getMirrorUrl='..tmpData.getMirrorUrl);
	end
	debugLog('PlgOnSuccess dirUrl='..dirUrl);
	debugLog('PlgOnSuccess fullName='..fullName);

	local OCfullName = trim((OCfullNamePusd:gsub('%.pusd$','')))
	local size = fileSize(OCfullName) -- exist?

	--if size and Settings['<misc>'].fixOSfullName and OCfullName ~= fullName then
	if not size then
		debugLog('not exist? ok')
	elseif size and OCfullName ~= fullName then
		fullName = OCfullName
		debugLog('fixed fullName       ='..OCfullName)
		usd.setretresult(OCfullName)
	end

	debugLog('usd.progstatus()='..usd.progstatus());

	local oldresult = plg.getretresult()

	local OnSuccessHandler = getHandler(plg.tOnSuccess, origUrl)
	local OnSuccessHandlerMirror = tmpData.getMirrorUrl and getHandler(plg.tOnSuccess, tmpData.getMirrorUrl)

	if OnSuccessHandler then
		local fn = debug.getfenv(OnSuccessHandler).script
		debugLog('OS: ' .. (fn and fn.fullname or '<no script.fullname>') )
		if OnSuccessHandlerMirror then
			debugLog('Skipping OS handler...')
		else
			OnSuccessHandler(origUrl, dirUrl, fullName, OCheaders)
		end
	end

	if tmpData.getMirrorUrl then
		debugLog('OS (mirror):')
		if OnSuccessHandlerMirror then
			debugLog('Calling OnSuccess for '..tmpData.getMirrorUrl)
			local fn = debug.getfenv(OnSuccessHandlerMirror).script
			debugLog('OS: ' .. (fn and fn.fullname or '<no script.fullname>') )
			OnSuccessHandlerMirror(tmpData.getMirrorUrl, dirUrl, fullName, OCheaders)
		else
			debugLog('No OS handler')
		end
		tmpData.getMirrorUrl = false
	end

	if Settings['<rename>'] then
		if OnSuccessHandler or OnSuccessHandlerMirror then fullName = plg.getretresult():match('^([%w]:\\[^"<>?*:|]+)$') or fullName end
		local name = fullName:match('\\([^\\]+)$')
		debugLog("Settings['<rename>']() ...")
		local name2 = Settings['<rename>'](name)
		debugLog("Settings['<rename>']() end")
		if name2~=name then
			debugLog('new name = '..serialize(name2 or '<nil>'))
		end
		if name2 then usd.setretresult(fileRename(fullName, filterName(tostring(name2 or name), true))) end
	end

	if OnSuccessHandler or OnSuccessHandlerMirror then return end
	debugLog('usdLua.lua: PlgOnSuccess handler not found')
end

function PlgOnError(dirUrl, errMsg, data)
	--usd.setretresult(1,10);
	usd.setretresult('');

	debugLog('PlgOnError: dirUrl='..dirUrl)
	debugLog('PlgOnError: errMsg='..errMsg)
	if data:find('[%z\001-\008\011\012\014-\031]') then
		debugLog('PlgOnError: data=<binary garbage>')
	elseif #data>128 then
		debugLog('PlgOnError: data=<html data> ?')
		if errMsg=='Connection aborted on request' --[[and #data==300000]] then
			debugLog('skip data saving')
		else
			debugSave(os.date('err-%y%m%d-%H%M%S-') .. counters.err .. '.htm', data, nil, false)
		end
	else
		debugLog('PlgOnError: data='..data)
	end
	local OnErrorHandler = getHandler(plg.tOnError, dirUrl)
	if OnErrorHandler then
		local fn = debug.getfenv(OnErrorHandler).script
		debugLog('OE: '..(fn and fn.fullname or '<no script.fullname>') )
		--usd.waittime(1)
		OnErrorHandler(dirUrl, errMsg, data)
		return
	end
	debugLog('usdLua.lua: PlgOnError handler not found')
	--usd.setstatus('PlgOnError')
	usd.waittime(10)
	return
end

function PlgOnCheck(dirUrl, fullName, headers, currStatus)
	usd.setretresult('');

	OCfullNamePusd = fullName
	OCheaders = headers
	debugLog('PlgOnCheck: dirUrl = '..dirUrl)
	debugLog('        fullName   = '..fullName)
	debugLog('        headers    = '..headers)
	debugLog('        currStatus = '..currStatus)

	-- 2GB
	local h = parseHeaders(headers)
	local fSize = h.SIZE
	if (fSize or 0) > 0 and currStatus==1 and (h.CODE==200 or h.CODE==206) then
		if fSize == fileSize(fullName) then
			debugLog(fSize.. ': sizes match, set status 2')
			usd.setretresult(2)
		end
	end

	local OnCheckHandler = getHandler(plg.tOnCheck, dirUrl)
	if OnCheckHandler then
		local fn = debug.getfenv(OnCheckHandler).script
		debugLog('OC: '..(fn and fn.fullname or '<no script.fullname>'))
		--usd.waittime(1)
		OnCheckHandler(dirUrl, fullName, headers, currStatus)
		return
	end
	debugLog('usdLua.lua: PlgOnCheck handler not found')
	return
end

function PlgDestroy()
	usd.savetolog('PlgDestroy start')
	for k, v in pairs(plg.tDestroy) do
		usd.savetolog('PlgDestroy: ' .. k)
		local status, err = pcall(v)
		if not status then usd.savetolog(err) end
	end
	usd.savetolog('PlgDestroy end')
end

----------------------------------------------------------------------------------------------------------------------------

do -- http://lua-users.org/wiki/StringTrim
	local space = lpeg.S' \t\n\v\f\r'
	local nospace = 1 - space
	local ptrim = space^0 * lpeg.C((space^0 * nospace^1)^0)
	local match = lpeg.match
	function trim(s, charset)
		if not charset then return match(ptrim, s) end
		--local space = lpeg.S(charset)
		local space = lpeg.P(charset)
 		local nospace = 1 - space
 		local ptrim = space^0 * lpeg.C((space^0 * nospace^1)^0)
		return match(ptrim, s)
	end
end


function split(str, sep, func)	-- http://www.inf.puc-rio.br/~roberto/lpeg/lpeg.html
	if sep=='' then return lpeg.match(lpeg.Ct(lpeg.C(lpeg.P(1))^0), str) end
	sep = lpeg.P(sep)
	local elem = func and (lpeg.C((1 - sep)^0) / func) or lpeg.C((1 - sep)^0)
	local p = lpeg.Ct(elem * (sep * elem)^0)   -- make a table capture
	return lpeg.match(p, str)
end


function splitKV(str, sepKV, sepP, func)	-- http://www.inf.puc-rio.br/~roberto/lpeg/
	func = func or rawset
	local space = lpeg.space^0
	local empty = lpeg.C('')
	local name = lpeg.C((1-lpeg.S(sepKV..sepP))^1) * space
	local value = (lpeg.C((1-lpeg.S(sepP))^1) + empty )* space
	local pair = lpeg.Cg(name * lpeg.S(sepKV)^0 * space * value) * (lpeg.S(sepP) * space)^0
	local list = lpeg.Cf(lpeg.Ct("") * pair^0, func)
	return list:match(str)
end

--  
function filterName(str,noSpaces)
	if not str then return '' end
	if type(str) ~= 'string' then error('filterName error: str must be string; type='..type(str), 2) end
	--local truncSpaces   = '^%s*(.-)%s*$'
	-- '+', ';'  : USD 1.3.5.6    
	local replaceChars  = '[^%w--%%%.%-%[%]\'\32`~!@#$%^&()_={},.]+'
	local replaceSymbol = '_'
	str = str or ''
	local tmp = entityDecode(str, true)
	tmp = tmp:gsub('%s+',' '):gsub('["<>]',"'")
	--tmp = tmp:match(truncSpaces):gsub(replaceChars, replaceSymbol)
	tmp = trim(tmp):gsub(replaceChars, replaceSymbol)
	if noSpaces then tmp=tmp:gsub('[%s_\']+','_'):gsub('_?%-_?','-'):gsub('^%-', '_-') end
	return tmp
end

function filterUtf8(str) return filterName(utf8ToAnsi(str), true)end

-- oldFullName -    , newName -    , newExt -     ()
--  ,     
function fileRename(oldFullName, newName, newExt, prefix)
	if type(oldFullName) ~= 'string' or #oldFullName==0 then
		error('fileRename error: oldFullName must be non-empty string', 2) end
	debugLog('fileRename oldFullName='..oldFullName)
	if newName then	debugLog('newName='..newName) end
	if newExt then debugLog('newExt='..newExt) end
	if prefix then debugLog('prefix='..prefix) end
	if not (newName or newExt or prefix) then return oldFullName end --   
	if newExt and newExt~=-1 and newName and newName:find(escapeLua(newExt)..'$') then	newName = newName:gsub(escapeLua(newExt)..'$','') end
	if newName == '' then newName = nil end --    true
	local path, fname = string.match(oldFullName, '^(.*\\)([^\\]*)$')
	local name, ext = string.match(fname, '^(.-)(%.[^.]+)$')

	if not newExt then	--  newExt=nil,  newName -    .
		local _
		_, newExt = (newName or ''):match('^(.-)(%.[^.]+)$')
		if newExt
			and #newExt >= 2
			and #newExt <= 5
			then
			newName = _
		else
			newExt = nil
		end
	elseif newExt == -1 then
		newExt = ext
	end


	name = newName or name or fname
	ext = newExt or ext or ''
	prefix = prefix or ''
	name = filterName(name)
	ext = filterName(ext)
	if name:lower():find(escapeLua(ext:lower())..'$') then name = name:sub(1,#name-#ext) end
	if prefix then filterName(prefix):sub(1,128) end
	local maxLength = MAX_PATH - 30 - 6 -- [1234] -- 232 (MAX_PATH-28) -  ; 231 - ok
	if #path + #prefix + #name + #ext > maxLength then
		name = name:sub(1, (maxLength - #path - #ext) ) --  
		if (#path + #prefix + #name + #ext > maxLength) or name=='' then error('Too long path or newExt!') end
	end

	local newFullName = path .. prefix .. name .. ext

	if plg.lowerW(plg.recode(CP_ACP,CP_WINUNICODE,oldFullName))==plg.lowerW(plg.recode(CP_ACP,CP_WINUNICODE,newFullName))
		then return oldFullName end --   

	local tmp = {}
	for i = 2, 2222 do
		if i == 2222 then error('Too many files!') end
		tmp = { io.open(newFullName, 'r') } --     : nil, ,  
		if #tmp ~= 1 and tmp[3]==2 then -- 2=No such file or directory
			break
		end
		io.close(tmp[1])
		newFullName = path .. prefix .. name .. '[' .. pad(i, 2) .. ']' .. ext
	end

	tmp = {os.rename(oldFullName, newFullName)}
	if #tmp >1 then error('Rename error: ' .. tmp[2]) end
	usd.savetolog('fileRename end:        '..newFullName)
	return newFullName
end

function fileSize(fname)
	if type(fname) ~= 'string' then
		debugLog('fileSize: fname is not a string!')
		return
	end
	-- 2GB
	--local h, err = io.open(fname, 'rb')
	--if h then
	--	local size = h:seek('end')
	--	h:close()
	--	return size
	--end
	--debugLog(err)
	--return nil, err
	local size, err = plg.filesize(fname)
	if err then debugLog(err) end
	return size, err
end

function fileRead(fname, maxSize)
	local h, err = io.open(fname, 'rb')
	if h then
		local contents = h:read(maxSize or '*a')
		h:close()
		return contents
	end
	usd.savetolog(err)
	return nil, err
end

function fileWrite(fname, ...)
	local h, err
	if not select(1,...) then
		err = 'no data'
	else
		h, err = io.open(fname, 'wb')
		if h then
			h:write(...)
			h:close()
			return true
		end
	end
	usd.savetolog('fileWrite: '..err)
	return nil, err
end

function fileAppend(fname, ...)
	local h, err
	if not select(1,...) then
		err = 'no data'
	else
		h, err = io.open(fname, 'ab')
		if h then
			h:write(...)
			h:close()
			return true
		end
	end
	usd.savetolog('fileAppend: '..err)
	return nil, err
end


do
	local fmtdata = {
		  ['.png'] = {head='^\137PNG\13\10'}
		, ['.gif'] = {head='^GIF8[79]a'}
		, ['.jpg'] = {head='^\255\216\255'}
		, ['.bmp'] = {check=function (head, tail, size, filename)
				local a, b = struct.unpack('< c2 I4', head)
				return a=='BM' and b==size
			end}
		, ['.tif'] = {check=function (head, tail, size, filename) return (head:find('^MM%z%*') or head:find('^II%*%z')) end, exts={'.tiff'}}
		, ['.psd'] = {head='^8BPS%z\1%z'}
		, ['.swf'] = {head='^[CFZ]WS[\5-\31]'}
		, ['.rar'] = {head='^Rar!\26\7%z', tail='\196={%z@\7%z', exts = {'.cbr'}}
		, ['.zip'] = {head='^PK\3\4', tail='PK\5\6', exts={'.apk', '.cbz', '.docx', '.pptx', '.xlsx', '.xpi'}}
		, ['.pdf'] = {head='^%%PDF%-1%.%d[\r\n]+%%'}
		, ['.flv'] = {head='^FLV\1'}
		, ['.wmv'] = {head='^0&\178u\142f\207\17\166\217%z\170%zb\206l', exts={'.asf','.wma'}}
		, ['.ogg'] = {head='^OggS%z[%z-\7]', exts={'.ogm','.ogv'}}
		, _Matroska = {check=function (head, tail, size, filename)	if head:find('^\26E\223\163') then return head:find('matroska') and '.mkv' or head:find('webm') and'.webm' end	end}
		, _RIFF = {check=function (head, tail, size, filename)
				if size<16 then return end
				local riff, rsize, id = struct.unpack('< c4 I4 c4', head)
				local rfmt = {WAVE='.wav', ['AVI ']='.avi'}
				return riff=='RIFF' --[[and rsize+8==size]] and rfmt[id]
        	end}
		, ['.mp4'] = {
			  exts = {'.3gp','.m4a','.m4v','.mov'}
			, check = function (head, tail, size, filename)
				local bsize, btype, n1 = struct.unpack('> I4 c4 c4', head)
				if bsize > size then return end
				if btype=='ftyp' then
					local mov = tableKeys('qt  ')
					local mp4 = tableKeys('isom','mp42','M4V ','dash')
					--return mov[n1] and '.mov' or mp4[n1] and true
					return mov[n1] and true or mp4[n1] and true
				end
				if tableKeys('moov','mdat','wide')[btype] then return true end
			end
		}
	}
	function getProperExt(filename)
		local sizeHead, sizeTail = 1024, 1024
		local size, err = fileSize(filename)
		if not size then return nil, err end
		if size==0 then return nil, filename..': empty file' end
		local h, err = io.open(filename, 'rb')
		if not h then	usd.savetolog(filename..': open error: '..err)	return nil, err	end
		local head = h:read(sizeHead)
		local tail
		if size > sizeTail then
			local pos, err = h:seek('end',-sizeTail)
			if not pos then	usd.savetolog(filename..': seek error: '..err)	return nil, err	end
			tail = h:read(sizeTail)
		end
		h:close()

		for k, v in pairs(fmtdata) do
			local fext = (filename:match('%.[^./]+$') or '_no_ext_'):lower()
			local found, newExt
			if v.check then
				found = v.check(head, tail, size, filename)
				if type(found)=='string' then newExt = found end
			else
				found = head:find(v.head)
			end
			if v.tail then found = found and (tail or head):find(v.tail) end
			local keepExt = found and v.exts and tableContains(v.exts, fext)
			if newExt or keepExt then return newExt or v.exts[keepExt] end
			if found then return k end
		end
		return nil, 'unknown type'
	end
end




------------------------------------------------------------------------------------------------------------------------

--       strgood   strbad
function tryDl(url, post, tries, strgood, strbad)
	tries = tries or 5  --    
	strgood = strgood or '' --    
	local p
	local function checkStr(flag,str,mode)
		mode = (mode=='and' or mode=='or') and mode or 'or'
		if mode=='and' then
			flag = flag and p:find(str)
		else
			flag = flag or p:find(str)
		end
		return flag
	end
	local function checkTable(tbl)
		local flagOr, flagAnd = false, true
		if tbl.a then  for k,v in pairs(tbl.a) do  flagAnd=checkStr(flagAnd, v,'and')  end  end
		if tbl.o then  for k,v in pairs(tbl.o) do  flagOr =checkStr(flagOr , v,'or' )  end  end
		if tbl.a and not tbl.o then flagOr=true end
		if not (tbl.a or tbl.o) then
			for k, v in pairs(tbl) do  flagOr = checkStr(flagOr, v)  end
		end
		return flagOr and flagAnd
	end

	for i=1, tries do
		debugLog('tryDl attempt '..i)
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		p = (post and usd.post(url,post) or usd.get(url))
--debugSaveInc('tryDl_'..i..'.html', p)

		local good, bad = true, false

		if type(strgood)=='function' then
			good, bad = strgood(p)
		else
			if type(strgood)=='table' then  good = checkTable(strgood)  else  good = p:find(strgood)  end
			if type(strbad)=='table' then  bad = checkTable(strbad)  elseif strbad then  bad = p:find(strbad)   end
		end

		if good and not bad then return p end

		usd.waittime(2)
	end
	return nil, p
end

function trySubmit(form, subm, tries, strgood, strbad)
	debugLog('trySubmit:')
	local req = form:getinputs(subm or false)	-- clickX, clickY
	if form.method == 'POST' then
		return tryDl(form.action, req, tries, strgood, strbad)
	else
		return tryDl(form.action:gsub('%?.*$','')..'?'..req, tries, strgood, strbad)
	end
end

------------------------------------------------------------------------------------------------------------------------

local function trimName(newName)
	local maxLength = MAX_PATH - 30 - 6 - #usd.ini.main.saveto
	local del = #newName-maxLength
	if del>0 then
		local n, e = newName:match('^(.-)(%.?[^.]-)$')
		if #n>#e then
			n=n:sub(1, math.max(#n-del,1))
			del = #n+#e-maxLength
			if del>0 then e=e:sub(1,math.max(#e-del,2)) end
		else
			e=e:sub(1, math.max(#e-del,2))
			del = #n+#e-maxLength
			if del>0 then n=n:sub(1,math.max(#n-del,1)) end
		end
		newName = n..e
	end
	return newName
end

--    '?/pref-name-suff.fext'  ""
function addNewName(orig,name,pref,suff,fext,sep)
	if type(orig)~='string' then error('origUrl is not string: '..type(orig)) end
	name = trim(name or '') if name=='' then name=nil end
	pref = trim(pref or '') if pref=='' then pref=nil end
	suff = trim(suff or '') if suff=='' then suff=nil end
	if not (name or pref or suff or fext) then return orig end
	local get = orig:match('(%?.*)$')
	local orig2 = orig:match('^([^?]+)')
	sep = filterName(sep or '-')
	pref = pref and filterName(pref) .. sep or ''
	suff = suff and sep .. filterName(suff) or ''
	local origFname = orig2:match('/([^/]+)$') or ''
	local fname = origFname

	if not fext then
		local newExt = filterName( (name or ''):match('^.-(%.[^.]+)$') )
        if newExt
			and #newExt >= 2
			and #newExt <= 5
			then
			fext = newExt
			name = name:match('^(.-)%.[^.]+$') or name
		else
			fext = filterName(fname:match('(%.[^.]+)$') or '')
		end
	elseif fext==-1 then
		fext = filterName( fname:match('^.-(%.[^.]+)$') )
	end

	fname = filterName(name or fname:match('^(.-)%.[^.]+$') or fname)

	local newName = ( pref .. fname .. suff .. fext ):gsub('%s','_'):gsub('%%','%%25'):gsub('&','%%26'):gsub('_?%-_?','-') -- escapeUC don't works
	newName = trimName(newName)

	if plg.lowerW(plg.recode(CP_ACP,CP_WINUNICODE,unescape(origFname)))==plg.lowerW(plg.recode(CP_ACP,CP_WINUNICODE,newName))	then return orig end
	return (orig2 .. (get and get..'&/' or '?/') .. newName)
end

------------------------------------------------------------------------------------------------------------------------

local function mp3ToWav(fname, channels, sampleRate, buffer, align)
	local f = fileRead(fname)
	if f:sub(-128,3) == 'TAG' then f = f:sub(1,#f-128) end
	channels, sampleRate, buffer, align = channels or 1, sampleRate or 16000, buffer or 3000, align or 1 -- rc2
	local tmp = {
		'RIFF'
		, struct.pack('<I4', #f+0x22) -- tag?
		, 'WAVE'
		,'fmt '
		, struct.pack('< I4 I2 I2 I4 I4 I2', 0x1e, 0x55, channels, sampleRate, buffer, align)
		, '\0\0\12\0\1\0\2\0\0\0', '\108', '\0\1\0q\5'
		, 'fact\4\0\0\0', struct.pack('<I4', sampleRate*16) -- samples?
        , 'data', struct.pack('<I4', #f)
        , f
	}
	local n = fname..'.wav'
	fileWrite(n, table.concat(tmp,''))
	return n
end


function queryCaptchaOCR(cfile, timeout, ctype, manual, host, noUniversal)
	timeout = timeout or 0
	local captcha
	ctype = ctype:gsub('_v%d+$','')				-- script version
	debugLog('ctype = ' .. ctype .. ', cfile = ' .. cfile)
	if cfile:find('%s') then
		local m = 'Put the USD to the directory without spaces >:->'
		usd.savetolog(m)
		usd.setstatus(m)
	end
	local imageTypes = {jpeg=true, png=true, gif=true, bmp=true}
	local cfileType
	cfile, cfileType = plg.setproperext(cfile)
	if usd.progstatus() == 0 then return debugLog('USD stopped') end
	if not cfile or not imageTypes[cfileType] then
		error('no captcha or wrong type: '..tostring(cfileType))
	end

	if not host then
		local origUrl, origUrl = debug.getlocal(2,1) --  >:-)
		host = getHost(origUrl)
	end

	debugLog('queryCaptchaOCR: host = ' .. host)

	local host2 = host:gsub('([%-%+%*()%%%[%].])','%%%1')

	local OCR = Captchas[host] and tableCopy(Captchas[host])
	if OCR then
		debugLog('ctype: host')
	else
		OCR = Captchas[ctype] and tableCopy(Captchas[ctype])
	end

	if not OCR then	debugLog('queryCaptchaOCR: captcha type "' .. host .. '" or "'.. ctype ..'" is not found in captchas.lua') end
	OCR = OCR or {}

--debugLog('ocr1:'..serialize(OCR))

	if noUniversal then
		debugLog('queryCaptchaOCR: noUniversal flag')
	elseif Captchas['_Universal_'] and OCR.ocrCmd~=false then
		debugLog('Combining with _Universal_...')
		local u = Captchas['_Universal_']
		local tmp = tableCombine(u, OCR)
		tmp.min, tmp.max = OCR.min, OCR.MAX
		if OCR.ocrCmd==nil then
			tmp.ocrCmd = u.ocrCmd
			tmp.result = u.result
			tmp.timeout = u.timeout
		end
		OCR = tmp
	end

	if OCR.timeout==nil then OCR.timeout=true end
	debugLog(serialize(OCR))

	local start = os.time()

	if not manual and OCR and OCR.ocrOnly and host then
		if not ('>'..OCR.ocrOnly..'<'):find('%W'..host2..'%W') then
			debugLog('queryCaptchaOCR: host is not found in the list "ocrOnly"')
			manual = true
		end
	elseif not manual and OCR and OCR.skipHosts and host then
		if ('>'..OCR.skipHosts..'<'):find('%W'..host2..'%W') then
			debugLog('queryCaptchaOCR: host is found in the list "skipHosts"')
			manual = true
		end
	end

	if manual then debugLog('queryCaptchaOCR: manual flag') end

	--if ctype=='reCaptcha2' then
	--	manual = true
	--	debugLog('queryCaptchaOCR: reCaptcha2 - forced manual')
	--end

	if OCR and OCR.tryManual and not manual then
		debugLog('tryManual')
		local tstart = os.clock()
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		local captcha, timeout = usd.showhawindow(cfile, timeout)
		if captcha=='' and (os.clock() - tstart < 1.5) then		--    Enter    1.5 
			captcha, timeout = usd.showhawindow(cfile, timeout)
		end
		if captcha ~= '' then return captcha, timeout end
		usd.waittime(5)
	end

	if OCR and OCR.ocrCmd and not manual then
		local sw = OCR.sw or SW_SHOWMINNOACTIVE
		local cmd = OCR.ocrCmd .. ' ' .. cfile
		local exitcode, err = plg.exec(cmd, OCR.timeout, sw)
		if exitcode and string.lower(OCR.result)=='clipboard' then
			captcha = usd.getclipboard()
		elseif exitcode then
			captcha, err = fileRead(OCR.result)
			if err then
				usd.savetolog('queryCaptchaOCR error: '..err)
			end
		end
		captcha = trim(captcha or '')
		usd.savetolog('captcha = ' .. captcha)
		if captcha==''
			or (OCR.min and OCR.min > #captcha)
			or (OCR.max and OCR.max < #captcha)
			then
			usd.savetolog('OCR error'..(
				((OCR.min and ('; min='..OCR.min) or '') .. (OCR.max and ('; max='..OCR.max) or '') )
				or '')
			)
		elseif captcha then
			usd.waittime(math.random(5,12)-(os.time()-start))
			--     
			timeout = timeout - (os.time() - start)
			return captcha, timeout
		end
	end
	timeout = timeout - (os.time() - start)

	if OCR and (OCR.noFallback or OCR.tryManual) and not manual then
		return '', timeout
	end

	if not imageTypes[cfileType] then
		usd.savetolog('queryCaptchaOCR: unknown captcha image type')
		return '', timeout
	end

	local tstart = os.clock()
	if usd.progstatus() == 0 then return debugLog('USD stopped') end
	captcha, timeout = usd.showhawindow(cfile, timeout)
	if captcha=='' and (os.clock() - tstart < 1.5) then		--    Enter    1.5 
		captcha, timeout = usd.showhawindow(cfile, timeout)
	end
	return captcha, timeout
end

function queryCaptcha(url, timeout, ctype, manual, host, noUniversal)
	timeout = timeout or 0
	--local logpref = _.logpref or (_.script and _.script.name..'_' or '')..'captcha'
	--ctype = ctype or (_.script.name:gsub('_v%d+$',''))

	local _none = {}
	local _f, _l
	for i=2, 22 do
		local tmp = getfenv(i)
		--if tmp.logpref then
		if tmp.script then
			_f = tmp
			_l = i
			break
		end
	end
	_f = _f or _none
	local logpref = _f.logpref or (_f.script and _f.script.name..'_' or '') ..'captcha'

	host = host or getHost(url) or '<unknown>'

	ctype = ctype or _f.script.name
	if not host then
		host = getHost(url)
	end

	local oldref = usd.getlocation()
	local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
	--usd.get(url .. '|' .. cfile)
	usd.waittime(1)
	--tryDl(url .. '|' .. cfile, nil, nil, 'Done')
	local tmpdata = tryDl(url)
	fileWrite(cfile, tmpdata)
	debugLog(cfile)
	local captcha
	captcha, timeout = queryCaptchaOCR(cfile, timeout, ctype, manual, host, noUniversal)
	usd.setreferer(oldref)
	return captcha, timeout
end

function queryReCaptcha(key, timeout, manual, host, noUniversal, check, reload)
	local conf = Captchas['reCaptcha'] or {}
	local data -- key, timeout, manual, host, noUniversal, check, reload, form
	if type(key)=='table' then
		data = key
	else
		data = {key=key, timeout=timeout, manual=manual, host=host, noUniversal=noUniversal, check=check, reload=reload}
	end
	if not data.key and data.form and data.form.html then
		debugLog('key from form')
		data.key = data.form.html:match('/recaptcha/api/challenge%?k=([%w_-]+)')
			or data.form.html:match('/recaptcha/api/noscript%?k=([%w_-]+)')
			--or data.form.html:match('data%-sitekey=[\'"]([%w_-]+)')
	end

	local tmp = tableCopy(data)
	tmp.form = tmp.form and '<form skipped>' or tmp.form
	debugLog('queryReCaptcha: data = '..serialize(tmp))
	debugLog('queryReCaptcha: conf = '..serialize(conf))
	if not data.key then error('no key') end
	if data.reload==nil then data.reload = conf.reload~=false end

	data.timeout = data.timeout or 0

	local _none = {}
	local _f, _l
	for i=2, 22 do
		local tmp = getfenv(i)
		--if tmp.logpref then
		if tmp.script then
			_f = tmp
			_l = i
			break
		end
	end
	_f = _f or _none
	local logpref = _f.logpref or (_f.script and _f.script.name..'_' or '') ..'recaptcha'
	data.host = data.host
		or (data.referer or data.form) and getHost(data.referer or data.form.action)
		or '<unknown>'

	local oldref = usd.getlocation()
	local oldCookies = usd.getcookie()
	local server = 'http://www.google.com/recaptcha/api/'
	usd.setreferer(server)
	usd.setcookie('')

	local rcUrl = server .. (data.check and 'noscript' or 'challenge') .. '?k=' .. data.key
	local rc, challenge, captcha, cfile, form
	captcha = ''
	rc = usd.get(rcUrl)
	debugSaveInc(logpref .. '.html', rc)
	local start = os.time()
	local wait
	if usd.progstatus() == 0 then return debugLog('USD stopped') end
	if not data.check then
		server = rc:match("server : '([^']+)',")
		challenge = rc:match("challenge : '([^']+)',")
		if data.reload then
			local tmp = usd.get(('%sreload?c=%s&k=%s&reason=r&type=image&lang=en'):format(server,challenge,data.key))
			debugSaveInc(logpref .. '.html', tmp)
			challenge = tmp:match("finish_reload%('([^']+)'")
			usd.setreferer(server)
		end
		cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
		--usd.get(server .. 'image?c=' .. challenge .. '|' .. cfile)
		local tmpdata = usd.get(server .. 'image?c=' .. challenge)
		fileWrite(cfile, tmpdata)
		debugLog(cfile)
		if not conf.skipBigger or conf.skipBigger > cfileSize then
			captcha, data.timeout = queryCaptchaOCR(cfile, data.timeout, 'reCaptcha', data.manual, data.host, data.noUniversal)
		else
			debugLog('Skipped big captcha: '..cfileSize..' > '..conf.skipBigger..' '..cfile)
		end
	else
		local attempts = tonumber(data.check) or conf.tries or captchaAttempts
		if attempts < 1 then attempts = 1 end
		for i=1, attempts do
			local start2 = os.time()
			--rc = usd.get(rcUrl)
			--debugSaveInc(logpref .. '.html', rc)
			form = Form.parse(rc:match('<form.-</form>'))
			form.action = rcUrl
			challenge = form.inputs.recaptcha_challenge_field
			if usd.progstatus() == 0 then return debugLog('USD stopped') end
			if data.reload then
				local tmp = usd.get(('%sreload?c=%s&k=%s&reason=r&type=image&lang=en'):format(server,challenge,data.key))
				debugSaveInc(logpref .. '.html', tmp)
				challenge = tmp:match("finish_reload%('([^']+)'")
				form.inputs.recaptcha_challenge_field = challenge
				usd.setreferer(server)
			end
			cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
			--usd.get(server .. 'image?c=' .. challenge .. '|' .. cfile)
			local tmpdata = usd.get(server .. 'image?c=' .. challenge)
			fileWrite(cfile, tmpdata)
			debugLog(cfile)
			local cfileSize = fileSize(cfile)
			if not conf.skipBigger or conf.skipBigger > cfileSize then
				form.inputs.recaptcha_response_field, data.timeout
					= queryCaptchaOCR(cfile, data.timeout, 'reCaptcha', data.manual, data.host, data.noUniversal)
				rc = form:submit()
				debugSaveInc(logpref .. '.html', rc)
				if rc:find('</textarea></body></html>') then
					challenge = rc:match('<textarea[^>]+>([^<]+)</textarea></body></html>')
					captcha = 'manual_challenge'
					break
				end
			else
				debugLog('Skipped big captcha: '..cfileSize..' > '..conf.skipBigger..' '..cfile)
			end
			usd.waittime(start2+7-os.time())
		end
	end
	usd.waittime(start+10-os.time())
	usd.setreferer(oldref)
	usd.setcookie(oldCookies)
	if data.form then data.form.inputs.recaptcha_response_field, data.form.inputs.recaptcha_challenge_field = captcha, challenge end
	return captcha, data.timeout, challenge
end


-- key, timeout, manual, host, noUniversal, form, referer
-- check, reload,
function queryReCaptcha2(data)
	local conf = Captchas['reCaptcha2'] or {}
	if not data.key and data.form and data.form.html then
		data.key = data.form.html:match('data%-sitekey%s*=%s*[\'"]([^\'"]+)')
		debugLog('key from form')
	end

	local tmp = tableCopy(data)
	tmp.form = tmp.form and '<form skipped>' or tmp.form
	debugLog('queryReCaptcha2: data = '..serialize(tmp))
	debugLog('queryReCaptcha2: conf = '..serialize(conf))
	if not data.key then error('no key') end
	if data.reload==nil then data.reload = conf.reload end

	data.timeout = data.timeout or 0
	local convert = Settings and Settings['<misc>'] and Settings['<misc>'].convert
	if not convert then
		local msg = "Need convert from Settings['<misc>'] !"
		usd.savetolog(msg)
		usd.setstatus(msg)
		usd.setretresult('%'..msg)
		return
	end

	conf = tableCombine({font = "Arial", fontSize = 20, language='en'}, conf)


	local _none = {}
	local _f, _l
	for i=2, 22 do
		local tmp = getfenv(i)
		if tmp.script then 	_f = tmp _l = i break end
	end
	_f = _f or _none
	local logpref = _f.logpref or (_f.script and _f.script.name..'_' or '') ..'recaptcha2'
	data.host = data.host
		or (data.referer or data.form) and getHost(data.referer or data.form.action)
		or '<unknown>'

	local oldref = usd.getlocation()
	local oldCookies = usd.getcookie()
	local server = 'http://www.google.com/recaptcha/api2/'
	usd.setreferer(server)
	usd.setcookie('')

	--local rcUrl = server .. (data.check and 'noscript' or 'challenge') .. '?k=' .. data.key
	local rcUrl = 'http://www.google.com/recaptcha/api/fallback?k=' .. data.key .. '&hl=' .. conf.language
	local rc, challenge
	rc = usd.get(rcUrl)
	debugSaveInc(logpref .. '.html', rc)
	local start = os.time()
	local wait
	if usd.progstatus() == 0 then return debugLog('USD stopped') end

	local captcha = ''
	local attempts = tonumber(data.check) or conf.tries or captchaAttempts
	if attempts < 1 or not data.check then attempts = 1 end
	for i=1, attempts do
		local start2 = os.time()
		local rcForm, rcReload = Form.parse(rc)

		rcForm = Form.parse(rc:match('<form.-</form>'))
		rcForm.action, rcReload.action = rcUrl, rcUrl
		challenge = rcForm.inputs.c
		if usd.progstatus() == 0 then return debugLog('USD stopped') end

		if data.reload then
			rc = rcReload:submit()
			debugSaveInc(logpref .. '.html', rc, 'reload')
			rcForm, rcReload = Form.parse(rc)
			usd.setreferer(server)
			challenge = rcForm.inputs.c
		end
		rcForm.action, rcReload.action = rcUrl, rcUrl

		local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)

		--usd.get(('%spayload?c=%s&k=%s|%s'):format(server, challenge, data.key, cfile))
		local tmpdata = usd.get(('%spayload?c=%s&k=%s'):format(server, challenge, data.key))
		fileWrite(cfile, tmpdata)
		debugLog(cfile)
		cfile = plg.setproperext(cfile)
		--local text = rc:match('<label for="response".-<strong>(.-)</strong>')
		local text = rc:match('<strong>(.-)</strong>')
		text = utf8ToAnsi(text):gsub('"',"'")

		local ann = {}
		for i=0,2 do
			local v, b = i*100+conf.fontSize, i*3+1
			table.insert(ann,(' -annotate +%d+%d "%d"'):rep(3):format(0,v,b, 100,v,b+1, 200,v,b+2))
		end
		ann = table.concat(ann)
		local cfile2 = cfile..'.jpg'
		local cmd = ('%s %s -quality 90 -undercolor white -fill black -font %s -pointsize %s %s -pointsize %s label:"Enter the numbers of pics with:" -pointsize %s label:"%s" -append %s'):format(
			convert
			, cfile
			, conf.font
			, conf.fontSize
			, ann
            , conf.fontSize-6
			, conf.fontSize
			, text
			, cfile2
		)
		plg.exec(cmd, true, SW_SHOWMINNOACTIVE)

		local tmp
		local post = {'%simple%c='..escapeUC(rcForm.inputs.c)}
		tmp, data.timeout = queryCaptchaOCR(cfile2, data.timeout, 'reCaptcha2', data.manual, data.host, data.noUniversal)
		--for n in tmp:gmatch('%d+') do table.insert(post, 'response='..(tonumber(n)-1)) end
		for n in tmp:gmatch('%d') do table.insert(post, 'response='..(tonumber(n)-1)) end
		rc = usd.post(rcForm.action, table.concat(post,'&'))
		debugSaveInc(logpref .. '.html', rc)
		if rc:find('"fbc%-verification%-token".-<textarea') then
			captcha = rc:match('<textarea[^>]+>([^<]+)</textarea>')
			break
		end
		usd.waittime(start2+7-os.time())
	end
	usd.waittime(start+10-os.time())
	usd.setreferer(oldref)
	usd.setcookie(oldCookies)
	if data.form then data.form.inputs['g-recaptcha-response'] = captcha end
	return captcha, data.timeout
end


function querySolvemedia(key, timeout, manual, host, noUniversal, check)
	local data -- key, timeout, manual, host, noUniversal, check, form, referer
	if type(key)=='table' then
		data = key
	else
		data = {key=key, timeout=timeout, manual=manual, host=host, noUniversal=noUniversal, check=check}
	end
	if not data.key and data.form and data.form.html then
		data.key = data.form.html:match('//api.solvemedia.com/papi/challenge%.[no]-script%?k=([^"]+)')
		debugLog('key from form')
	end
	local tmp = tableCopy(data)
	tmp.form = tmp.form and '<form skipped>' or tmp.form
	debugLog('querySolvemedia: data = '..serialize(tmp))
	if not data.key then error('no key') end

	data.timeout = data.timeout or 0
	local stopAfterTimeout
	if type(data.timeout)=='table' then
		data.timeout=data.timeout[1]
		stopAfterTimeout = true
	end

	local _none = {}
	local _f, _l
	for i=2, 22 do
		local tmp = getfenv(i)
		--if tmp.logpref then
		if tmp.script then
			_f = tmp
			_l = i
			break
		end
	end
	_f = _f or _none
	local logpref = _f.logpref or (_f.script and _f.script.name..'_' or '') ..'solvemedia'
	if not data.host then
	    if data.form then data.host = getHost(data.form.action) end
		data.host = data.host or '<unknown>'
	end

	local conf = tableCombine(
		{jsMode = false, tryAnswer = true, fontSize = 16, lineSpacing = 4, font = [[Courier-New]]}
        , Captchas['solvemedia'] or {}
	)
	conf.convert = Settings and Settings['<misc>'] and Settings['<misc>'].convert

	debugLog('querySolvemedia: conf = '..serialize(conf))

	local oldref = data.referer or usd.getlocation()
	local oldCookies = usd.getcookie()
	usd.setcookie('')

	local attempts = not data.check and 1 or tonumber(data.check) or conf.tries or captchaAttempts
	if attempts < 1 then attempts = 1 end
	local form
	for i=1, attempts do
		if stopAfterTimeout and data.timeout<1 then break end
		usd.setreferer(oldref)
		local sm = usd.get('http://api.solvemedia.com/papi/challenge.noscript?k='..data.key)
		debugSaveInc(logpref .. '.html', sm)

		local cimg = 'http://api.solvemedia.com' .. sm:match('<img[^>]-src="(/papi/media%?[^"]+)"')
		local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		--usd.get(cimg .. '|' .. cfile)
		local tmpdata = usd.get(cimg)
		fileWrite(cfile, tmpdata)
		debugLog(cfile)
		form = sm:match('<form.-</form>')
		form = Form.parse(form)
		if not form.action:find('://') then
			form.action = 'http://api.solvemedia.com/papi/' .. form.action
		end
		form.inputs.adcopy_response
			, data.timeout = queryCaptchaOCR(cfile, data.timeout, 'solvemedia', data.manual, data.host, data.noUniversal)
		sm = form:submit()
		debugSaveInc(logpref .. '.html', sm)

		if sm:find('/verify.pass.') then
			sm = usd.get('http://api.solvemedia.com/papi/verify.pass.noscript?c='..form.inputs.adcopy_challenge)
			debugSaveInc(logpref .. '.html', sm)
			break
		end
	end

	usd.setreferer(oldref)
	usd.setcookie(oldCookies)

	local captcha, challenge = 'manual_challenge', form.inputs.adcopy_challenge
	if stopAfterTimeout and data.timeout<1 then
		debugLog('Timeout - stop')
		captcha, challenge = '', ''
	end

	if data.form then data.form.inputs.adcopy_response, data.form.inputs.adcopy_challenge = captcha, challenge end
	return captcha, data.timeout, challenge
end


function queryAdsCaptcha(url, timeout, manual, host, noUniversal)
	timeout = timeout or 0
	--local _ = getfenv(2)
	--local logpref = _.logpref or (_.script and _.script.name..'_' or '')..'adscaptcha'
	local _ = getfenv(2) if not (_.logpref or _.script) then _ = getfenv(3) end
	local logpref = _.logpref or (_.script and _.script.name..'_' or '') ..'adscaptcha'
	if not host then
		local origUrl, origUrl = debug.getlocal(2,1) --  >:-)
		host = getHost(origUrl)
	end
	local oldref = usd.getlocation()
	local oldCookies = usd.getcookie()
	usd.setcookie('')

    url = url:lower():gsub('/get%.aspx%?','/NoScript.aspx?')

	local captcha

	local ac = usd.get(url)
	debugSaveInc(logpref .. '.html', ac)

	local cimg = ac:match('(http://api.adscaptcha.com/+Challenge.aspx[^%s"\']+)')

	local challenge = cimg:match('cid=([^&]+)')
	local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
	if usd.progstatus() == 0 then return debugLog('USD stopped') end
	--usd.get(cimg .. '|' .. cfile)
	local tmpdata = usd.get(cimg)
	fileWrite(cfile, tmpdata)
	debugLog(cfile)
	captcha, timeout = queryCaptchaOCR(cfile, timeout, 'adsCaptcha', manual, host, noUniversal)

	usd.setreferer(oldref)
	usd.setcookie(oldCookies)
	return captcha, timeout, challenge
end


function queryAdverigo(data)
	local conf = Captchas['adverigo'] or {}
	if not data.key and data.form and data.form.html then
		debugLog('key from form')
		data.key = data.form.html:match("adVerigo%.init%([\"']([^\"']+)")
			or data.form.html:match('//js%.adverigo%.com/(%x+)%.js')
	end

	local tmp = tableCopy(data)
	tmp.form = tmp.form and '<form skipped>' or tmp.form
	debugLog('queryAdverigo: data = '..serialize(tmp))
	debugLog('queryAdverigo: conf = '..serialize(conf))
	if not data.key then error('no key') end
	data.timeout = data.timeout or 0

	local _none = {}, _f, _l; for i=2, 22 do local tmp = getfenv(i) if tmp.script then _f = tmp _l = i break end end; _f = _f or _none
	local logpref = _f.logpref or (_f.script and _f.script.name..'_' or '') ..'adverigo'
	data.host = data.host or (data.referer or data.form) and getHost(data.referer or data.form.action) or '<unknown>'

	if usd.progstatus() == 0 then return debugLog('USD stopped') end
	local start, wair = os.time()
	local oldref, oldCookies = usd.getlocation(), usd.getcookie();	usd.setreferer('')	usd.setcookie('')

	local refresh
	local page = usd.get('http://api.adverigo.com/info.json?sid=&videoSupport=false&hash='..data.key)
	local info = parseJsObject(page)
	debugSaveInc(logpref .. '.html', page, serialize(info,nil,true))

	debugSaveInc(logpref .. '.html', usd.get('http://api.adverigo.com/checkAdriver.json?sid='..info.sid))

	local attempts = not data.check and 1 or tonumber(data.check) or conf.tries or captchaAttempts
	if attempts < 1 then attempts = 1 end
	for i=1, attempts do
		for i=1, math.max(tonumber(conf.skipAds) or 1, 1) do
			page = usd.get(('http://api.adverigo.com/refresh.json?sid=%s&hash=%s&needAdriver=false'):format(info.sid,data.key))
			refresh = parseJsObject(page)
			debugSaveInc(logpref .. '.html', page, serialize(refresh,nil,true))
			if refresh.safe==1 then break end
			usd.waittime(2,2)
		end
    	usd.relocationmode(0)
		debugSaveInc(logpref .. '.html', usd.get(('http://api.adverigo.com/captcha.%s?sid=%s'):format(refresh.ext, refresh.sid)))
		usd.relocationmode(1)
		local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
		--usd.get(parseHeaders(usd.getheaders()).LOCATION1:gsub('^https:','http:')..'|'..cfile)
		local tmpdata = usd.get(parseHeaders(usd.getheaders()).LOCATION1:gsub('^https:','http:'))
		fileWrite(cfile, tmpdata)
		debugLog(cfile)
		captcha, data.timeout = queryCaptchaOCR(cfile, data.timeout, 'adverigo'..(refresh.safe==0 and '_ad' or ''), data.manual, data.host, data.noUniversal)
		if captcha~='' then
			--usd.waittime(2,2)
			page = usd.get(('http://api.adverigo.com/verify.json?sid=%s&answer=%s'):format(refresh.sid, captcha))
			debugSaveInc(logpref .. '.html', page)
			if page:find('"status":true') then break end
		end
	end

	usd.waittime(start+10-os.time()); usd.setreferer(oldref); usd.setcookie(oldCookies)
	--if data.form then data.form.inputs.recaptcha_response_field, data.form.inputs.recaptcha_challenge_field = captcha, challenge end
	return captcha, data.timeout, refresh.sid
end


------------------------------------------------------------------------------------------------------------------------

do
	local getMirrorLevel = 0
	local inherit = {}

	--local function getMirror2(mirrors, preferred, interactive, rows, unwanted, params, preferredOnly)
	local function getMirror2(mirrors, data)
		local conf = tableCombine( {interactive=false,useMega=false,preferred={},unwanted={},skip={}}, Settings and Settings['<getMirror>'] or {} )
		if getMirrorLevel==1 then
			inherit = {}
			for k,v in pairs(conf) do debugLog('conf.'..k..'='..serialize(v)) end
		end
		if data then for k,v in pairs(data) do debugLog('data.'..k..'='..serialize(v)) end end
		data = data or {}
		if data.inherit then inherit = {preferred=data.preferred, unwanted=data.unwanted, skip=data.skip} end
		data.params = data.params or {}
		--data.params.skipUrl = data.params.skipUrl or data.skipUrl
		--data.skipUrl = data.skipUrl or data.params.skipUrl
		data.preferred = data.preferred or inherit.preferred or conf.preferred or {}
		data.unwanted = data.unwanted or inherit.unwanted or conf.unwanted or {}
		data.skip = data.skip or inherit.skip or conf.skip or {}
		data.interactive = data.interactive and conf.interactive

		local function checkMega(url)
			debugLog('checkMega: '..url)
			local isNode, fileId, fileKey = (url or ''):match('^https?://mega%.co%.nz/#(N?)!(.-)!(.+)$')
			if not fileId then return end
			local page = usd.post('https://g.api.mega.co.nz/cs?id=1', '[{"a":"g","ssl":"0","g":"1","'..(isNode=='N' and 'n' or 'p')..'":"'..fileId..'"}]')
			debugSaveInc('checkMega.html', page)
			local flag = not not page:find('"g":"http://')
			debugLog(flag and 'checkMega: exists' or 'checkMega: some problem')
			return flag
		end


		local hnames = {}				-- ,      preferred/unwanted
		local tmp = {}
		local mirrorsCount = 0
		local megaconz

		for k, v in pairs(mirrors) do
			v = trim(v)
			local url = URI.parse(v)
			if (url and url.host and url.scheme and (url.scheme:find('^https?$') or url.scheme=='ftp')) then
				if url.scheme:find('^https?$') then url.scheme = 'http' end
				local skipUrl = false
				if data.skipUrl then
					local u = url(nil, true)
					local f = type(data.skipUrl)=='function' and data.skipUrl or getHandler(plg.tSkipUrl, u)
					skipUrl = f and f(u)
				end
				local h = getHost(url)
				if type(k) == 'number' then	--   - ,    
					k = h
				end
				--if skiplist:find(','..getHost(url):gsub('%-','%%-')..',') then
				if tableContains(data.skip, h) then
					debugLog('Skip: '..v)
				elseif skipUrl then
					debugLog(('data.skipUrl: %s; result: %s; %s'):format(tostring(data.skipUrl), tostring(skipUrl), v))
				elseif h == 'mega.co.nz' or h == 'mega.nz' then
					url.scheme = 'http'
					megaconz = url(nil, true)
					local GDLhandler, h = getHandler(plg.tDirLink, megaconz)
					if conf.useMega and GDLhandler and checkMega(megaconz) then
						debugLog('Using Mega...')
						local info = getLstInfo()
						local pusdsize = 0
						if info and info.localfile then
							pusdsize = fileSize(info.localfile..'.pusd') or 0
						end
						if pusdsize == 0 then
							debugLog('Change url...')
							tmpData.getLstInfoCache = nil
							usd.modquery(megaconz)
							GDLhandler(megaconz, data.params)
							debugLog('getMirror() end - mega 1;')
							return
						else
							debugLog("Can't use Mega: this file has already been partially downloaded!")
						end
					else
						debugLog('Skip '..v)
					end

				else
					tmp[k] = url(nil, true) --          :-)
					mirrorsCount = mirrorsCount + 1
					table.insert(hnames, k)
				end
			else
				usd.savetolog('getMirror: bad mirror: '..tostring(v))
			end
		end
		mirrors = tmp

		if usd.progstatus()==0 then
			usd.setretresult('')
			debugLog('getMirror: USD stopped 1')
			return
		end

		if #hnames==0 then
	    	if megaconz then
	    		usd.modquery(megaconz)
	    		tmpData.getLstInfoCache = nil
				local GDLhandler, h = getHandler(plg.tDirLink, megaconz)
				if GDLhandler then GDLhandler(megaconz, data.params) end
				debugLog('getMirror() end - mega 2')
	    		return
	    	end
			debugLog('Empty mirrors table!')
	--debugSaveInc('getMirrors-err.html', '')
			usd.setretresult('%notfound%')
			return false, '', {}
		end

		local minwait = false
		local notfound = false

		local function errFunc(msg)
			for s in debug.traceback():gmatch('([^\r\n]+)') do debugLog(s) end
			return msg or '<no error msg>'
		end

		--   (true  )
		local getdirect = function(url)
			local GDLhandler, h = getHandler(plg.tDirLink, url)
			if GDLhandler then
				if h then debugLog('-- substring: '..h) end
				GDLinit(false, url)
				--local status, err = pcall(GDLhandler, url)
				local status, err = xpcall(function() GDLhandler(url, data.params) end, errFunc)
				if not status then
					debugLog(err)
					--debugSave(os.date('getMirror-err-%y%m%d-%H%M%S-') .. counters.getMirrorErr .. '.htm', url .. '\r\n\r\n' .. err, err, false)
					return false
				end
				local r = plg.getretresult()
				debugLog('result: '..r)

				if  (r:lower() == '%done%')
					or (r~=''  and  not r:find('^%%')  and  r:find('://')) then 		--   
					return true
				else
					local wait = r:match('^%%Server report: You need wait (%d+) seconds')
					if wait then
						wait = tonumber(wait)
						minwait = math.min(minwait or wait, wait)
					elseif r == '%notfound%' or r == '%deleted%' then
						notfound = (notfound or 0) + 1
					end
					--return false
				end
			end
			return false
		end

		--debugLog('Mirrors:          '..table.concat(hnames, ', '))
		debugLog('Mirrors:')
		for k, v in pairs(mirrors) do
			debugLog(v)
		end

		local unsupported = {}

		--     (type = 'select')   
		if data.preferred or data.unwanted then
			local tmp = {}
			--  
			for i=1, #(data.preferred or {}) do
				for k, v in pairs(hnames) do
					if v == data.preferred[i] and getHandler(plg.tDirLink, mirrors[v]) then
						table.insert(tmp, v)
						hnames[k] = nil
					end
				end
			end

			if not data.preferredOnly then

				--local tmpUnw = ',' .. table.concat(unwanted, ',') .. ','

				--  
				for k, v in pairs(hnames) do
					--if not tmpUnw:find(','..v..',',1,true) and getHandler(plg.tDirLink, mirrors[v]) then
					if not tableContains(data.unwanted, v) and getHandler(plg.tDirLink, mirrors[v]) then
						table.insert(tmp, v)
						hnames[k] = nil
					end
				end

				--  
				for k, v in pairs(hnames) do
					if getHandler(plg.tDirLink, mirrors[v]) then
						table.insert(tmp, v)
						hnames[k] = nil
					end
				end
			end

			local uList = {}
			for k, v in pairs(hnames) do
				table.insert(uList, v)
				unsupported[v] = mirrors[v]
			end
			if #uList>0 then
				debugLog( 'Unsupported: ' .. table.concat(uList, ', ') )
			end

			hnames = tmp
		end

		debugLog( 'Filtered mirrors: ' .. table.concat(hnames, ', ') )

		if #hnames == 0 then
			local err = '%No script handlers'
			usd.setretresult(err)
			debugLog(err)
			return false, err, unsupported
		end

		if data.interactive then
			local dlg = Dialog.new(data.rows)
			dlg:addrows({
	            {'__________________________'}
	            , {'Select mirror:'}
	            , {{type='select', name='host', hnames }}
			})
			local _ = getfenv(2)
			dlg:makeform(_.script and _.script.name or '<getMirror>')
			local h = dlg:show()
	        if h == '' then	-- esc
	        	debugLog('getMirror() end - esc')
	        	return
	        end
	        h = h:match('host=([%d]+)') + 1	--     0
	        local m = mirrors[hnames[h]]
	        --if getdirect(m) then return true, m end --  
			--m = URI.recode(m)
	        if getdirect(m) then			--  
	        	tmpData.getMirrorUrl = m
	        	debugLog('getMirror() end - interactive')
	        	return true, 'http://fakemirror/'
	        end
			hnames[h] = false				--  
		end

		--    
		for i, v in ipairs(hnames) do
			if usd.progstatus()==0 then break end
			local m = mirrors[v]
			--if m and getdirect(m) then return true, m end
	        if m and getdirect(m) then
	        	tmpData.getMirrorUrl = m
	        	debugLog('getMirror() end - auto 1')
	        	return true, 'http://fakemirror/'
	        end
		end

		usd.setretresult('')

		if usd.progstatus()==0 then
			debugLog('getMirror: USD stopped 2')
			return
		end

		local _
		if minwait then
			_ = '%Server report: You need wait ' .. minwait .. ' seconds'
		elseif notfound == mirrorsCount
			or notfound == #hnames and megaconz
			then
			if notfound == #hnames then debugLog('Supported mirrors are dead') end
			if megaconz and checkMega(megaconz) then
				local info = getLstInfo()
				local pusdsize = 0
				if info and info.localfile then
					pusdsize = fileSize(info.localfile..'.pusd') or 0
				end
				if pusdsize == 0 then
					debugLog('Change url...')
					usd.modquery(megaconz)
					tmpData.getLstInfoCache = nil
					usd.setretresult('%Restarting...', 5)
				else
					usd.setretresult('%Delete .pusd')
				end
				debugLog('getMirror() end - auto 2')
				return
			end
			usd.savetolog('All mirrors are dead')
			_ = '%notfound%'
		elseif notfound == #hnames then
			_ = '%Supported mirrors are dead'
		else
			_ = '%getMirror error'
		end
		debugLog('#hnames='..#hnames .. ' notfound='..(notfound or 0) )
		usd.setretresult(_)
		debugLog('getMirror() error: '.._)
		return false, _, unsupported
	end

	function getMirror(mirrors, data)
		if getMirrorLevel<0 then error('getMirrorLevel<0') end
		if getMirrorLevel>5 then
			debugLog('Aborting: too deep')
			return false, 'too deep', {}
		end
		getMirrorLevel = getMirrorLevel+1
		debugLog('getMirror() start; l='..getMirrorLevel)
		local q, w, e = getMirror2(mirrors, data)
		debugLog('getMirror() end; l='..getMirrorLevel)
		getMirrorLevel = getMirrorLevel-1
		return q, w, e
	end
end

------------------------------------------------------------------------------------------------------------------------

Form={}
Form.__index = Form

Form.fp = re.compile([[
		formtext <- {} form {}
		form	<- '<'[fF][oO][rR][mM] garbage attrs '/'? '>' ([^<]+ / comment / input / button / textarea / !('</' [fF][oO][rR][mM] garbage '>') .)* '</' [fF][oO][rR][mM] garbage '>'
		comment <- '<!--' (!'-->' .)* '-->'
		input	<- '<'[iI][nN][pP][uU][tT] garbage attrs '/'? '>'
		button	<- '<'[bB][uU][tT][tT][oO][nN] garbage attrs '/'? '>'
		textarea <- ('<' [Tt][Ee][Xx][Tt][Aa][Rr][Ee][Aa] garbage attrs '>' { (!('</'[Tt][Ee][Xx][Tt][Aa][Rr][Ee][Aa]'>') .)*  } )   -> ta
		attrs	<- (attr garbage)*  -> tokeyval
		garbage <- ['"%s]*
		attr	<- ( { aname } %s* '=' %s* str / { aname }{''})
		aname	<- %a[%w-]*
		str		<- '"' { [^"]* } '"' / "'" { [^']* } "'" / { [^%s>]+ }
	]]
	, {
		tokeyval = function(...)	--   key=value   
			local t = {}
			for i=1, #arg, 2 do
				t[arg[i]:lower()]=arg[i+1]	-- key   
			end
			return t
		end
		, ta = function(attrs,value) attrs.value=value return attrs end
	})

function Form.parse(form, baseUrl)
	local string, table = string, table
	if type(form) ~= 'string' then error('The argument must be a string!',2) end

   	local fpr = {}
	re.gsub(form, Form.fp, function(...)
		table.insert(fpr,{...})
		return ''
	end)

	local function parse2(fpr)
		if type(fpr)~='table' or #fpr==0 then return end
		local f = {}
   		setmetatable(f, Form.__index)
		f.enctype = string.lower(fpr[2].enctype or '')
		if f.enctype ~= 'multipart/form-data' then f.enctype = 'application/x-www-form-urlencoded' end
		f.method = string.upper(fpr[2].method or '')
		if f.method ~= 'POST' then f.method = 'GET' end
		f.action = fpr[2].action or ''
		if baseUrl then f.action = URI.combine(baseUrl, f.action)() end
		f.inputs = {}
		f.submits = {}
		f.html = form:sub(fpr[1],fpr[#fpr]-1)
		local fi, fs = f.inputs, f.submits

		for i=3, #fpr-1 do
			local t = fpr[i]
			if t.name == '' then t.name = nil end
			if t.type then t.type = string.lower(t.type) end

			if t.type == 'reset' or (not t.name and t.type ~= 'image') then
			elseif t.type == 'submit' then
				fs[t.name] = t.value or 'Submit'
			elseif t.type == 'image' then
				local coords = {x=0,y=0,src=t.src}
				if t.name then
					fs[t.name] = coords
				else
					table.insert(fs, coords)
				end
			elseif (t.type == 'checkbox' or t.type == 'radio') then
				if t.checked then
					fi[t.name] = t.value or 'on'
				end
			else
				fi[t.name] = t.value or ''
			end
		end

	   	return f
	end
	for fpri=1, #fpr do fpr[fpri]=parse2(fpr[fpri]) end

	return unpack(fpr)
end

function Form.make(tbl)
	local f = {}
   	setmetatable(f, Form.__index)
	f.action = tbl.action or ''
	f.enctype = string.lower(tbl.enctype or '')
	if f.enctype ~= 'multipart/form-data' then f.enctype = 'application/x-www-form-urlencoded' end
	f.method = string.upper(tbl.method or '')
	if f.method ~= 'POST' then f.method = 'GET' end
	f.inputs = tableCopy(tbl.inputs or {})
	f.submits = tableCopy(tbl.submits or {})
	return f
end

function Form:escape(str)
	if self.enctype == 'multipart/form-data' then return str end -- no escape
	return tostring(str):gsub('[^%da-zA-Z_.-]',function(c)
		if c==' ' then return '+' end
		return '%'..bit.tohex(c:byte(),2)
	end)
end

--   
--    ,   submit 
--     
function Form:getinputs(sname, clickX, clickY)
	local t={}
	for k, v in pairs(self.inputs) do
		table.insert(t, self:escape(k)..'='..self:escape(v))
	end
	local submit = (sname~=nil or clickX or clickY) and self:getsubmit(sname, clickX, clickY)
	if submit then table.insert(t, submit) end
	local simple = self.method == 'POST' and self.enctype~='multipart/form-data' and '%simple%' or ''
	return simple .. table.concat(t, self.enctype~='multipart/form-data' and '&' or '\n')
end

function Form:setinputs(tbl, remove)
	if tbl then self.inputs = tableCombine(self.inputs, tbl) end
	if remove then for k,v in pairs(remove) do self.inputs[v]=nil end end
end

--     nil
function Form:getsubmit(sname, clickX, clickY)
	local s
	local sk, sv = next(self.submits)	--   
	if sname and self.submits[sname] or not sname then --      nil/false
		sk = sname or sk
		sv = self.submits[sname] or sv
		if type(sv)=='table' then -- image
			local pref = type(sk)=='number' and '' or self:escape(sk)..'.'
			s = pref..'x='..(clickX or sv.x).. '&' .. pref..'y='..(clickY or sv.y)
		else
			s = sk and sv and self:escape(sk)..'='..self:escape(sv)
		end
	end
	return s
end

function Form:submit(sname, clickX, clickY)
	local req = self:getinputs(sname or false, clickX, clickY)
	if self.referer then usd.setreferer(self.referer) end
	if self.method == 'POST' then
		return usd.post(self.action, req)
	else
		return usd.get(self.action:gsub('%?.*$','')..'?'..req)
	end
end

------------------------------------------------------------------------------------------------------------------------

Dialog = {}
Dialog.__index = Dialog

function Dialog.new(rows, caption, width, fontHeight)
	local dlg = {rows={}, form='', fontHeight=fontHeight or plg.config.fontheight}
	local sd = Settings['<Dialog>']
	if sd then
		dlg.sound = sd.sound
		dlg.soundflags = sd.soundflags
		dlg.beep = sd.beep
	end

   	setmetatable(dlg, Dialog.__index)
	if rows then
		dlg:addrows(rows)
		dlg:makeform(caption, width)
	end
	return dlg
end

function Dialog:addrows(rows)
	for i=1, #rows do
		self:addrow(rows[i])
	end
end

function Dialog:addrow(...)
	if #arg == 0 then return end

	if #arg==1 and (type(arg[1])=='table' and not arg[1].type) then
		arg = arg[1]
	end

	local WW, WH = plg.gettextextent('W', self.fontHeight)
	local top, left = 0, 0

    local parserow = function(row)
		--if type(row)~='string' and type(row)~='table' then error('Row '..rownum..': Argument must be a table or string: '..tostring(row)) end
		if type(row)~='string' and type(row)~='table' then row='<bad: '..tostring(row)..'>' end
		local width, height = 0, 0
		local str = ''

		if type(row) == 'string' then
			row = {type='label', row}
		end

		if type(row[1]) == 'string' then
			str = (row[1]:gsub('[\r\n|]+',' '))
			width, height = plg.gettextextent(str, self.fontHeight)
			str = str:gsub('&','&&')
		end

		if row.type then row.type = string.lower(row.type) end

		if row.type == 'label' then
			width  = math.max(width, row.width or 0)
			height = math.max(height, row.height or 0)
			local l = {type='label', width=width, height=height, value=str, top=top, left=left}
			left = left + width
			if #str>2 and not str:find('[^_]') then
				l.top = l.top - math.floor(WH/2)
			end
			return l
		end

		local r = {type=row.type
				 , width=math.max(width, row.width or 0)
				 , height=math.max(height, row.height or 0)
				 , name=row.name
				 , value=row.value or 0
				 , top=top
				 , left=left
				 }

		if row.type == 'checkbox' then
			r.width = r.width + WW*2
			r.caption = str
			left = left + r.width
			return r
		end

		if row.type == 'edit' or row.type == 'password' then
			r.height = r.height + math.floor(WH/2)
			r.width = r.width + WW
			r.value = str
			if not r.value then r.value='' end
			left = left + r.width
			return r, true
		end

		if row.type == 'select' then
			if type(row[1])~='table' then error('Items for "select" must be a table!') end
			r.width = WW
			r.height = WH
			local items = {}
			for i=1, #row[1] do
				str = (row[1][i]:gsub('[\r\n|]+',' '))
				local w, h = plg.gettextextent(str, self.fontHeight)
				r.width = math.max(r.width,w)
				r.height = math.max(r.height,h)
				r['item'..i]=str
			end
			r.width = r.width + WW*3
			r.height = r.height + WH
			left = left + r.width
			return r, true
		end

		error('Unknown type: '..tostring(row.type))
	end

	local parsed = {}
	local flag
	for i=1, #arg do
		local r, f = parserow(arg[i])
		flag = flag or f
		table.insert(parsed, r)
	end

	if flag then	--    edit/password/select
		for i=1, #parsed do
			if parsed[i].type == 'label' or parsed[i].type == 'checkbox' then
				parsed[i].top = parsed[i].top + math.floor(WW/2)
			end
		end
	end

	table.insert(self.rows, parsed)
	return

end


function Dialog:makeform(capt, width)

	local scrleft, scrtop, scrright, scrbottom = plg.gettextextent()
	local maxWidth, maxHeight = math.floor((scrright-scrleft)*0.9), math.floor((scrbottom-scrtop)*0.9)
	width = tonumber(width or 0)
	local offH, offV = 5, 5		-- offset
	--local caption = plg.exename .. '/' .. plg.plgname .. '/' .. (capt or '.lua')
	local caption = plg.plgname .. '.plg / ' .. (capt or '.lua')
	local captionW, captionH = plg.gettextextent(caption, self.fontHeight)
	local WW, WH = plg.gettextextent('W', self.fontHeight)
	local top = offV
	local left = offH
	local widthItems = 0

	local form = {}
	for i=1, #self.rows do
		local rWidth, rHeight = 0, 0
		for j=1, #self.rows[i] do
			local r = tableCopy(self.rows[i][j])
			rHeight = math.max(rHeight, r.top + r.height)
			r.top = r.top + top
			r.left = r.left + left + WW*(j-1)
			rWidth = r.left + r.width
			--table.insert(form, tableConcat(r, '|'))
			table.insert(form, tableConcat(r, '=', '|'))
		end
		top = top + rHeight + math.floor(WH/2)
		widthItems = math.max(widthItems, rWidth)
	end

	local formW = math.max(300, math.min( maxWidth, (math.max(captionW, widthItems, width) + offH*3 ) ) )
	local formH = math.max(120, math.min( maxHeight, captionH + top + WH*4 ) )
	table.insert(form, 1, 'type=form|width='..formW..'|height='..formH..'|caption='..caption)

	self.form=table.concat(form, '\n')
	return
end

function Dialog:show()
	if self.sound then plg.playsound(self.sound, 0, self.soundflags) end
	if self.beep then playbeep(self.beep) end
	local _ = usd.simpleoptions(self.form)
	if self.sound then plg.playsound() end	-- stop sound
	return _
end


------------------------------------------------------------------------------------------------------------------------

function prompt(msg, text, caption, width)
	d = Dialog.new({
		{msg or 'Prompt'}
		, {type='edit', name='prompt', width=width or 300, text}
		}, caption)
	local p = d:show()
	if p == '' then return nil end
	--return (p:gsub('^prompt=%s*',''):gsub('[\r\n%s]*$','')) -- gsub  2 !
	return (p:gsub('^prompt=%s*(.-)%s*$','%1')) -- gsub  2 !
end

------------------------------------------------------------------------------------------------------------------------

function playbeep(...)
	if type(arg[1])=='table' then arg = arg[1] end
    for i=1, #arg, 2 do
		plg.beep(arg[i],arg[i+1])
	end
end

------------------------------------------------------------------------------------------------------------------------

-- http://www.lua.org/pil/12.1.1.html
function serialize (o, allowdupes, pretty, useToString)
	local tmp = {}
	local tables={}
	local key
	if pretty and type(pretty) ~= 'string' then pretty = '\t' end

	local function serialize2 (o, ident)
		ident = ident or 0
		local pref = pretty and '\n'..pretty:rep(ident)
		local pref2 = pretty and pref..pretty..', '
		if type(o) == "number" then
			table.insert(tmp, ('%.16g'):format(o))
		elseif type(o) == "boolean" then
			table.insert(tmp, o and 'true' or 'false')
		elseif type(o) == "string" then
			table.insert(tmp, ( (string.format("%q", o)):gsub('\007','\\a'):gsub('\\\r','\\r'):gsub('\\\n','\\n') ) )
			--table.insert(tmp, ( (string.format("%q", o)):gsub('\\\r','\\r'):gsub('\\\n','\\n'):gsub('%c',function(s)return '\\'..pad(s:byte(),3) end) ) )
		elseif type(o) == "table" then
			if not allowdupes then
				if tables[o] then	--x={}x[x]=x
					error('Possible loop detected: '..tmp[#tmp]..tables[o])
				end
				tables[o]=key
			end
			local i1, i2 = 0, 0
			for k, v in pairs(o) do
				i1=i1+1
				if type(k)=='number' then i2=i2+1 end
			end
			local simple = (i1 == i2) and (i1 == #o)
			local zerobased = (i1 == i2) and (i1 == (#o + 1)) and o[0]
			table.insert(tmp,"{")
			--if pretty then table.insert(tmp, pref .. pretty) end
			local pref3 = pretty and pref..pretty..'  '
			if pretty then table.insert(tmp, pref3) end
			for k,v in pairs(o) do
				key=k
				if not simple then	-- key, ' = '
					if zerobased then
						if k == 0 then
							table.insert(tmp,"[0]")
							table.insert(tmp, pretty and " = " or "=" )
						end
					elseif tostring(k):find('^[%a_][%w_]*$') then
						table.insert(tmp, k)
						table.insert(tmp, pretty and " = " or "=")
					else
						serialize2(k, ident+1)
						tmp[#tmp] = '['..tmp[#tmp]..']'
						table.insert(tmp, pretty and " = " or "=" )
					end
				end
				serialize2(v, ident+1)
				table.insert(tmp, pref2 or ",")
			end
			if tmp[#tmp] == (pref2 or ",") then
				if pretty then
					tmp[#tmp] = pref
					table.insert(tmp,"}")	-- non-empty
					if tmp[#tmp-4]=='{'	-- single value
						--and tmp[#tmp-3]==pref..pretty
						and tmp[#tmp-3]==pref3
						then
						tmp[#tmp-3]=' '
						tmp[#tmp-1]=' '
					elseif tmp[#tmp-6]=='{'
						and tmp[#tmp-3] == ' = '
						--and tmp[#tmp-5]==pref..pretty
						and tmp[#tmp-5]==pref3
						then
						tmp[#tmp-5]=' '
						tmp[#tmp-1]=' '
					end
				else
					tmp[#tmp] = "}"
				end
			else
				if pretty then
					tmp[#tmp] = "}"
				else
					table.insert(tmp,"}")	-- empty
				end
			end
		else
			if useToString then
				table.insert(tmp, tostring(o) )
			else
				error("cannot serialize a " .. type(o) .. ' ('..tostring(o)..')')
			end
		end
	end

	serialize2(o)

	if pretty then table.insert(tmp, '\n') end

	--leak? return table.concat(tmp)
	tmp = table.concat(tmp)
	return tmp
end


function deserialize(s)
	local f, err = loadstring('return ' .. s)
	if err then
		--error(err)
		debugLog(err)
		return false
	end
	setfenv(f, {})
	return pcall(f)
end


function serializeMirrors(data, skipCheck)
	if type(data) ~= 'table' then error('The argument must be a table: '..type(data) ) end
	local tmp = tableKeys('string','number','boolean','nil')
	if not tmp[type(data.name)] then error('Invalid name ('..type(data.name)..'): '..tostring(data.name)) end
	if not tmp[type(data.size)] then error('Invalid size ('..type(data.size)..'): '..tostring(data.size)) end
	if not (data.mirrors and next(data.mirrors) or data.direct and next(data.direct)) then error('No mirrors!') end
	if usd.progstatus() == 0 then debugLog('USD stopped') return end

	local e, m = nil, getHandler(plg.tDirLink, 'ftp://m/')
	if not m then
		e = "serializeMirrors: m.lua is not found."
		usd.savetolog(e)
		return nil, e
	end
	--if not skipCheck and getLstInfo().url:find('^ftp://m/') then
	if not skipCheck and getLstInfo().url:find('^ftp://') then
		e = 'serializeMirrors: Already serialized.'
		usd.savetolog(e)
		return nil, e
	end

	local skiplist = Settings['<getMirror>'] and Settings['<getMirror>'].skip or {}
	if data.mirrors then
		for k, v in pairs(data.mirrors) do
			v = trim(v)
			local host = getHost(v)
			--if host and skiplist:find(','..host:gsub('([%-%+%*()%%%[%].])','%%%1')..',') then
			if host and tableContains(skiplist, host) then
				debugLog('Skip: '..v)
				data.mirrors[k] = nil
			end
		end
	end

	local tmp = ascii85.encode(zlib.compress(serialize(data)),9):gsub("'",'v'):gsub('"','w') -- USD   
	--tmp = 'ftp://m/'..(data.name or 'noname')..(data.size and ('>'..data.size) or '')..tmp
	tmp = ('ftp://m/%s%s%s'):format(
			tostring(data.name or 'noname'):gsub('[%s<\'"]+','_')
			, (data.size and ('>'..tostring(data.size)) or ''):gsub('[%s<\'"]+','')
			, tmp )
	if #tmp > 4095 then
		e = 'Serialized data is too long!'
		usd.savetolog(e)
		return nil, e
	end

	return m, tmp
end

------------------------------------------------------------------------------------------------------------------------

do
	local patternE = re.compile([[
			escaped <- "\" ( {[uU]} {%x^4} / {[xX]} {%x^2} / octal / {.} )
			octal	<- {[0-3] [0-7]^-2 / [4-7] [0-7]? } -> octNum
		]]
		, {octNum = function(o) return tonumber(o,8) end}
	)
	local r = {b='\b', f='\f', n='\n', r='\r', t='\t', v='\v'}
	local fr = n2utf8
	local f = function(t,x)
				x = x and tonumber(x, 16)
				if x then return (t=='u' or t=='U') and fr(x) or string.char(x)	end
				return r[t] or type(t)=='number' and string.char(t) or t
			end
	function unescapeJS(str, recode)
		fr = recode or n2utf8
		return re.gsub((str:gsub('\\\r?\n','')),patternE,f)
	end


	local patternDJC = re.compile([[
		something	<-  {[^'"/]+ / qstring2 / regexp } / comment / { "/" }
		qstring2	<-	"'" ( "\" . / [^\']+ )* "'"  /  '"'  ( '\' . / [^\"]+ )* '"'
		regexp		<-	"/" [^/\*] ( [^/\]+ / "\" . )* "/"
		comment		<-	("//" [^%nl]* / "/*" (!'*/' .)* "*/" )	-> ''
	]])
	function delJsComments(str)
		if type(str) ~= 'string' then return end
		if str=='' then return '' end
		local tmp = {}
		re.gsub(str, patternDJC, function(v) table.insert(tmp,v) end)
		--memory leak! return table.concat(tmp)
		tmp = table.concat(tmp)
		return tmp
	end

	local conf
	local function num(n)
		local r = tonumber(n)
		return r and (r <= (2^53-1) and r >= -(2^53-1) ) and r or n
	end
	local patternPJO = re.compile([[
		jsobj		<-  obj / array
		obj			<-	( '{' ( property ( ',' property)* )? ','? %s* '}' ) 	-> tokeyval
		property	<-	pname ':' pvalue
		pname		<-	%s* ( qstring / word ) %s*
		undefined	<-  '' -> null
		pvalue		<-	%s* ( jsobj / strconcat / qstring / something ) %s*
		pvalue2		<-	pvalue / undefined
		array		<-	( '[' ( pvalue2 (%s* ',' pvalue2 )* )? %s* ']' )		-> toarr
		strconcat	<-	{ qstring (%s* "+" %s* qstring)+ }						-> concat
		qstring		<-	( "'" { ( "\" . / [^\']+ )* } "'"  /  '"' {  ( '\' . / [^\"]+ )* } '"' )
		qstring2	<-	( "'" ( "\" . / [^\']+ )* "'"  /  '"'  ( '\' . / [^\"]+ )* '"' )
		word		<-	{[_.%w-]+}
		something	<-  { ( %s* qstring2 / %s* balanced / %s* [^],'"(){}%s[]+ )+ }
	    balanced	<-	%s* (balancedp / balancedb / balanceds)
		balancedp	<-	"(" ([^('")]+ / qstring2 / balanced)* ")"
		balancedb	<-	"[" ([^]'"[]+ / qstring2 / balanced)* "]"
		balanceds	<-	"{" ([^{'"}]+ / qstring2 / balanced)* "}"
	]], {
			tokeyval = function(...)	--   key=value   
				local args = {...}
				if conf.flat then return #args, ... end
				local t = {}
				for i=1, #args, 2 do
					local k = conf.noNumKeys and args[i] or num(args[i])
					local v = conf.noNumVals and args[i+1] or num(args[i+1])
					if not conf.noBoolean then	if v == 'true' then v = true elseif v == 'false' then v = false end 	end
					if not conf.noUnescape then
						if type(k) == 'string' then k = unescapeJS(k) end
						if type(v) == 'string' then v = unescapeJS(v) end
					end
					if v == 'null' then v = conf.newNull end
					if v == 'undefined' then v = conf.newUndefined end
					t[k] = v
				end
				return t
			end
		, toarr = function(...)
				local args = {...}
				local t = {}
				local tf = {}
				for i, v in pairs(args) do	-- [,,,4,,]
					if conf.flat then
						table.insert(tf,v)
					else
						local k = conf.zeroBase and i-1 or i
						v = conf.noNumVals and v or num(v)
						if not conf.noBoolean and v == 'true' then				v = true
						elseif not conf.noBoolean and v == 'false' then			v = false
						elseif v == 'null' then									v = conf.newNull
						elseif type(v) == 'string' and not conf.noUnescape then	v = unescapeJS(v)
						end
						t[k] = v
					end
				end
				if conf.flat then return #tf, unpack(tf) end
				return t
			end
		, concat = function(_, ...)
				return table.concat({...},'')
			end
        , null = function() return nil end

	})

	function parseJsObject(obj, noNumKeys, noNumVals, noBoolean, newNull, zeroBase, noUnescape, flat, newUndefined)
		if type(obj) ~= 'string' then return debugLog('parseJsObject(): not string: '..type(obj)) end
		local timeStart = os.clock()
		obj = delJsComments(obj)
		local timeDelJsComments = os.clock()

		conf = type(noNumKeys)=='table' and noNumKeys
			or {noNumKeys=noNumKeys, noNumVals=noNumVals, noBoolean=noBoolean, newNull=newNull, zeroBase=zeroBase, noUnescape=noUnescape, flat=flat, newUndefined=newUndefined}
		if conf.flat then return { re.match(string.sub(obj,re.find(obj, patternPJO)), patternPJO) } end

		local objs = {}
		re.gsub(obj, patternPJO, function(o)
			table.insert(objs,o)
			return ''
		end)
		local timeEnd = os.clock()
		if #obj>102400 then debugLog(('parseJsObject() size: %d; total: %0.3fs; del comments: %0.3fs; parsing: %0.3fs;'):format(#obj, timeEnd-timeStart, timeDelJsComments-timeStart, timeEnd-timeDelJsComments)) end
		setmetatable(objs, {__mode = "v"})	-- fix memory leak?
		return unpack(objs)
	end
end

------------------------------------------------------------------------------------------------------------------------

function setHeader(hdr, clean)
	if type(hdr)=='table' then for _, v in ipairs(hdr) do setHeader(v, clean) end return end
	local hdr2 = escapeLua(hdr)
	local c = usd.getcookie():gsub('^=0; ','')	--  *;q=0
	c=c:gsub('^'..hdr2..';? ?', ''):gsub(';? ?\r\n'..hdr2..';? ?', '; '):gsub('^[; ]*(.-)[; ]*$','%1')
	if not clean then c = c .. '\r\n'..hdr end
	usd.setcookie(c)
end

function setXHR(clean)
	setHeader('X-Requested-With: XMLHttpRequest', clean)
end

------------------------------------------------------------------------------------------------------------------------

function getLstInfo(useCache)
	if useCache and tmpData.getLstInfoCache then
		debugLog('getLstInfo: cached: ' .. serialize(tmpData.getLstInfoCache))
		return tableCopy(tmpData.getLstInfoCache)
	end
	usd.addquery('http://_create_lst_')	--  USD  .lst; origUrl   - getMirror()
	local lst = usd.workdir .. plg.exename .. '.lst'
	usd.waittime(Settings['<misc>'].getLstInfoPause)

	local item = fileRead(lst)
	if not item then
		usd.savetolog("getLstInfo: Can't open ".. lst)
		return nil
	end
	--  
	item = (item or ''):match('.-\r\n(item0=.+)')
	item = (item or ''):match('^(.-)\r\nitem1=') or item

	if not item then
		usd.savetolog("getLstInfo: Can't read ".. lst)
		return nil
	end

	local t = {}
	for k, v in item:gmatch('item0_?([^=]*)=([^\r\n]*)') do
		k = (k=='' and 'url' or k):lower()
		if (k=='size' or k=='state') and v:find('^%d+$') then v = tonumber(v) end
		t[k] = v~='' and v
	end

	if type(t.saveto)=='string' then t.saveto = t.saveto:gsub('\\?$','\\', 1) end

	debugLog('getLstInfo: ' .. serialize(t))
	tmpData.getLstInfoCache = tableCopy(t)

    return t
end

local setPusdNameOCOE=function()debugLog('setPusdNameOCOE')usd.setretresult(1,5)end
regCheckError('http://0.0.0.0/setPusdName/',setPusdNameOCOE,setPusdNameOCOE)

function setPusdName(name, info)
	if Settings['<misc>'].extDownloader then return false end
	info = info or getLstInfo()
	if not info.size then
		usd.savetolog('setPusdName: getLstInfoPause is too small?')
		info = getLstInfo()  --  
		if not info.size then
			usd.savetolog('setPusdName: getLstInfo() error!')
			return
		end
	end
	if info.localfile then return false, info end
	name = filterName(name)
	debugLog('setPusdName: name = '..name)
	usd.setretresult('http://0.0.0.0/setPusdName/'..name,0,0)
	return true, info
end

function getResumeFlag(lstInfo, setRange)
	lstInfo = lstInfo or getLstInfo(true)
	local fname = lstInfo.localfile
	if not fname then return 0 end
	fname = fname and fname .. '.pusd'
	local pusdSize = fileSize(fname) or 0
	local limit = setRange=='force' and -1 or Settings['<misc>'].getResumeFlagLimit
	local resume = pusdSize < limit and 0 or 1
	debugLog( ('getResumeFlag: pusdSize = %d %s limit = %d; resume flag = %d'):format(pusdSize, pusdSize<limit and '<' or '>=', limit, resume) )
	if resume==1 and setRange then
		local r = 'Range: bytes='..pusdSize..'-'
		debugLog('getResumeFlag: adding header: '..r)
		setHeader(r)
	end
	return resume
end


------------------------------------------------------------------------------------------------------------------------

--http://stackoverflow.com/questions/183485/can-anyone-recommend-a-good-free-javascript-for-punycode-to-unicode-conversion
Punycode = {
	 initial_n = 0x80
	,initial_bias = 72
	,delimiter = "-"
	,base = 36
	,damp = 700
	,tmin = 1
	,tmax = 26
	,skew = 38
	,maxint = 0x7FFFFFFF
}

Punycode.utf16={
	decode = function(input, codePage)
		local output = {}
		input = plg.recode(codePage or CP_UTF8, CP_WINUNICODE, input)
		input = plg.lowerW(input)
		local len = #input
		local value, extra
		for i=1, len, 2 do
			value = input:byte(i)+input:byte(i+1)*256
			--value = Punycode.ansiToUnicode[value] or value
			table.insert(output, value)
		end
		return output
	end
}

Punycode.decode_digit = function (cp)
	return cp - 48 < 10 and cp - 22 or cp - 65 < 26 and cp - 65 or cp - 97 < 26 and cp - 97 or Punycode.base;
end

Punycode.encode_digit = function (d, flag)
	return d + 22 + 75 * (d < 26 and 1 or 0) - ((flag ~= 0 and 1 or 0) * 2^5);
end

Punycode.adapt = function (delta, numpoints, firsttime)
	local k
	delta = firsttime and math.floor(delta / Punycode.damp) or math.floor(delta / 2);
	delta = delta + math.floor(delta / numpoints);
	k = 0
	while delta > math.floor(((Punycode.base - Punycode.tmin) * Punycode.tmax) / 2) do
		delta = math.floor(delta / (base - tmin))
		k = k + base
	end
	return k + math.floor(((Punycode.base - Punycode.tmin + 1) * delta) / (delta + Punycode.skew))
end

Punycode.encode_basic = function (bcp, flag)
	bcp = (bcp - 97 < 26 and 1 or 0) * 2^5
	return bcp + ((not flag and (bcp - 65 < 26 and 1 or 0)) * 2^5 );
end

Punycode.encode = function (input, codePage)
	local n, delta, h, b, bias, j, m, q, k, t, ijv, case_flags;
	--input = Punycode.utf16.decode(input:lower());
	input = Punycode.utf16.decode(input, codePage);
	local input_length = #input
	local output={}
	n = Punycode.initial_n;
	delta = 0;
	bias = Punycode.initial_bias;
	--// Handle the basic code points:
	for j = 1, input_length do
		if input[j] < 0x80 then
			--table.insert(output, string.char(Punycode.ansiToUnicode[input[j]] or input[j]) )
			table.insert(output, string.char(input[j]) )
		end
	end

	h = #output
	b = #output
	--// h is the number of code points that have been handled, b is the
	--// number of basic code points

	if (b > 0) then table.insert(output, Punycode.delimiter) end

	--// Main encoding loop:
	while (h < input_length) do
	--    // All non-basic code points < n have been
	--    // handled already. Find the next larger one:
		m = Punycode.maxint
		for j=1, input_length do
			ijv = input[j];
			if (ijv >= n and ijv < m) then m = ijv end
		end

		if (m - n > math.floor((Punycode.maxint - delta) / (h + 1))) then
			error("punycode_overflow (1)")
		end
		delta = delta + (m - n) * (h + 1);
		n = m

		for j = 1, input_length do
			ijv = input[j];
			if ijv < n then
				delta = delta+1
				if (delta > Punycode.maxint) then error("punycode_overflow (2)") end
			end

			if (ijv == n) then
				q = delta
				k = Punycode.base
				while true do
					t = k <= bias and Punycode.tmin or k >= bias + Punycode.tmax and Punycode.tmax or k - bias;
					if (q < t) then break end
					table.insert(output, string.char( Punycode.encode_digit(t + (q - t) % (Punycode.base - t), 0)) );
					q = math.floor( (q - t) / (Punycode.base - t) );
					k = k + Punycode.base
				end
				table.insert(output, string.char( Punycode.encode_digit(q, 0 )));
				bias = Punycode.adapt(delta, h + 1, h == b);
				delta = 0;
				h = h + 1
			end
		end

		delta = delta+1
		n = n+1;
	end
	return table.concat(output, '')
end

Punycode.toAscii = function ( domain, codePage )
    local domain_array = {}
    for d in domain:gmatch('[^.]+') do table.insert(domain_array, d) end
    out = {}
    for i=1, #domain_array do
    	local s = domain_array[i]
    	table.insert(out, s:find('[^A-Za-z0-9-]') and "xn--" .. Punycode.encode(s, codePage) or s:lower())
    end
    return table.concat(out, '.')
end

------------------------------------------------------------------------------------------------------------------------

-- scheme userinfo host port path query fragment

-- http://tools.ietf.org/html/rfc3986#appendix-A
-- http://www.cyberforum.ru/javascript/thread342063.html
URI = {}
URI.__oldURI = URI

URI.__index = function(t,k)
	if k == 'path' then
		--return t.path_abempty or t.path_absolute or t.path_noscheme or t.path_rootless or '/'
		return rawget(t, 'path_abempty') or rawget(t, 'path_absolute') or rawget(t, 'path_noscheme') or rawget(t, 'path_rootless')
	else
		return rawget(t, k) or rawget(URI.__oldURI, k)
	end
end

URI.__newindex = function(t,k,v)
	if t == URI.__oldURI then error("Table 'URI' is write-protected!",2) end
	if k == 'path' then
		local oldAbs = t.path_abempty or t.path_absolute
		local oldRel = t.path_noscheme or t.path_rootless
		t.path_abempty, t.path_absolute, t.path_noscheme, t.path_rootless = nil
		if v:find('^/') then
			rawset(t, 'path_absolute', URI.simplify(v) )
		elseif oldRel then
			rawset(t, 'path_rootless', URI.simplify(v) )
		else
			rawset(t, 'path_absolute', URI.simplify((oldAbs or '/'):gsub('/[^/]+$','/') .. v) )
		end
	else
		rawset(t, k, v)
	end
end

URI.pattern = re.compile([[

	URI_reference	<- URI / relative_ref

	URI				<- scheme ":" hier_part ( "?" query )? ( "#" fragment )?

	hier_part		<- '//' authority path_abempty
					/  path_absolute
					/  path_rootless
					/  path_empty

	absolute_URI	<- scheme ":" hier_part ( "?" query )?

	relative_ref	<- relative_part ( "?" query )? ( "#" fragment )?

	relative_part	<- "//" authority path_abempty
					/  path_absolute
					/  path_noscheme
					/  path_empty

	scheme			<- ( {:name: '' -> 'scheme' :}   {( ALPHA ( ALPHA / DIGIT / "+" / "-" / "." )* )} )		-> {}

	authority		<- (( userinfo "@" )? host ( ":" port )?)
	userinfo		<- ( {:name: '' -> 'userinfo' :} {( unreserved / pct_encoded / sub_delims / ":" )*} )	-> {}
	host			<- ( {:name: '' -> 'host' :}     {(IP_literal / IPv4address / reg_name)} )				-> {}
	port			<- ( {:name: '' -> 'port' :}     {DIGIT*} )												-> {}

	IP_literal		<- "[" ( IPv6address / IPvFuture  ) "]"

	IPvFuture		<- [vV] HEXDIG+ "." ( unreserved / sub_delims / ":" )+
    IPv6address		<-                             ( h16 ":" )^6 ls32
					/                         "::" ( h16 ":" )^5 ls32
					/ ( h16                )? "::" ( h16 ":" )^4 ls32
					/ ( h16 ( ":" h16 )?   )? "::" ( h16 ":" )^3 ls32
					/ ( h16 ( ":" h16 )^-2 )? "::" ( h16 ":" )^2 ls32
					/ ( h16 ( ":" h16 )^-3 )? "::"   h16 ":"     ls32
					/ ( h16 ( ":" h16 )^-4 )? "::"               ls32
					/ ( h16 ( ":" h16 )^-5 )? "::"   h16
					/ ( h16 ( ":" h16 )^-6 )? "::"


	ls32			<- ( h16 ":" h16 ) / IPv4address
	h16				<- HEXDIG HEXDIG^-3
	IPv4address		<- dec_octet "." dec_octet "." dec_octet "." dec_octet
	dec_octet		<- DIGIT			-- 0-9
					/  [1-9] DIGIT		-- 10-99
					/  "1" DIGIT^2		-- 100-199
					/  "2" [0-4] DIGIT	-- 200-249
					/  "25" [0-5]		-- 250-255

	reg_name		<- ( unreserved / pct_encoded / sub_delims )*

	path			<- path_abempty
					/  path_absolute
					/  path_noscheme
					/  path_rootless
					/  path_empty

	path_abempty	<- ( {:name: '' -> 'path_abempty' :}  { ( "/" segment )* } )						-> {}
	path_absolute 	<- ( {:name: '' -> 'path_absolute' :} { "/" ( segment_nz ( "/" segment )* )? } )	-> {}
	path_noscheme	<- ( {:name: '' -> 'path_noscheme' :} { segment_nz_nc ( "/" segment )* } )			-> {}
	path_rootless	<- ( {:name: '' -> 'path_rootless' :} { segment_nz ( "/" segment )* } )				-> {}
	path_empty		<- ( {:name: '' -> 'path_empty' :}    {''} )										-> {}

	segment			<- pchar*
	segment_nz		<- pchar+
	segment_nz_nc	<- ( unreserved / pct_encoded / sub_delims / "@" )+

	pchar			<- unreserved / pct_encoded / sub_delims / ":" / "@"

	query			<- ( {:name: '' -> 'query' :}    {( pchar / "/" / "?" )*} )	-> {}

	fragment		<- ( {:name: '' -> 'fragment' :} {( pchar / "/" / "?" / "|" / " " )*} )	-> {}

	pct_encoded		<- "%" HEXDIG HEXDIG

	unreserved		<- ALPHA / DIGIT / "-" / "." / "_" / "~" / UTF8 / CYRILLIC / OTHER_SYMBOLS
	reserved		<- gen_delims / sub_delims
	gen_delims		<- ":" / "/" / "?" / "#" / "[" / "]" / "@"
	sub_delims		<- "!" / "$" / "&" / "'" / "(" / ")" / "*" / "+" / "," / ";" / "="

	ALPHA			<- [A-Za-z]
	DIGIT			<- [0-9]
	HEXDIG			<- [0-9A-Fa-f]

	OTHER_SYMBOLS	<- "[" / "]"

	CYRILLIC		<- [--]

	UTF8tail		<- ]]..'[\128-\191]\r\n'..[[
	UTF8	<- ]]
	--.. '[\000-\127] / [\194-\223][\128-\191] / [\224][\160-\191][\128-\191] / [\225-\236\238\239][\128-\191][\128-\191]'
	.. ' [\194-\223] UTF8tail'
	.. ' / [\224][\160-\191] UTF8tail / [\225-\236\238\239] UTF8tail UTF8tail / [\237][\128-\159] UTF8tail'
	.. ' / [\240][\144-\191] UTF8tail UTF8tail / [\241-\243] UTF8tail UTF8tail UTF8tail / [\244][\128-\143] UTF8tail UTF8tail'
)
--227 129 187

--http://www.faqs.org/rfcs/rfc3629.html
--http://keithdevens.com/weblog/archive/2004/Jun/29/UTF-8.regex

--   build    userinfo  fragment;    'http',   - '/'.
function URI:__tostring(build)
	if self.__oldURI ~= URI.__oldURI then error('Wrong object: '..tostring(self)..' ('..type(self)..')') end
	local u = {}
	local function add(a,b,c) if a then table.insert(u, b or ''); table.insert(u, c or ''); end end
	--add (self.scheme,	self.scheme, ':')
	add (true,	self.scheme or 'http', ':')
	table.insert(u, '//')
	add (self.userinfo and build, self.userinfo, '@')
	add (self.host,	self.host)
	add (self.port, ':', self.port)
	if self.path_abempty and not self.host then
		add (true, 	'//', self.path_abempty)
	else
		table.insert(u, self.path_abempty or self.path_absolute or self.path_noscheme or self.path_rootless or '/')
	end
	add (self.query and self.query~='',	'?', self.query)
	add (self.fragment and build, '#', self.fragment)

	return table.concat(u)
end

function URI:__call(rel, build)
	if rel then
		return self:combine(rel, build) -- build = codePage
	--elseif build
	else
		return self:__tostring(build)
	end
end

function URI.simplify(path)
	local n
	repeat	path, n = path:gsub('/%./','/')			-- '/./' -> '/'
	until n==0
	repeat	path, n = path:gsub('/[^/]*/%.%./','/')	-- '/somedir/../' -> '/'
	until n==0
	path = path:gsub('/%.$','/'):gsub('/[^/]*/%.%.$','/'):gsub('//+','/'):gsub('^/%.%./','/')
	return path
end

function URI.parse(base, codePage)
	if type(base)~='string' then error('"base" must be a string: '..tostring(base)..' ('..type(base)..')', 2) end

	base = base:gsub('^http://https%.%.','https://') -- Proxomitron
	base = base:gsub('\032','%%20')

	local parse = function(url)
		local tmp = {re.match(base, URI.pattern)}
		local tmp2 = {}
		setmetatable(tmp2, URI.__oldURI)
		for i=1, #tmp do		--  {[1]='value',name='test'}
			local n = tmp[i].name
			local v = tmp[i][1]
			if n=='scheme' then v = string.lower(v) end
			--if n=='host' then v = Punycode.toAscii(string.lower(v)) end
			if n=='host' then v = Punycode.toAscii(unescape(v), codePage) end
			if n:find('^path_') then
				v = URI.simplify(v)
				if v:find('[\128-\255]') then
					v = v:gsub('[\128-\255]+', function(c)
						return escapeU(codePage and plg.recode(codePage, CP_UTF8, c) or c)
					end)
				end
			end
			--if v~='' then tmp2[n] = v end
			tmp2[n] = v~='' and v or false
			--if n=='query' then
			--elseif n=='query' then
			--elseif v~='' then
			--	tmp2[n] = v
			--end
		end
		tmp2.q = tmp2.query and splitKV(tmp2.query,'=','&',function(t,i,v) t[unescape(i)]=unescape(v) return t end) or {}
		tmp2.p = tmp2.path and tmp2.path~='/' and split(trim(tmp2.path,'/'),'/') or {}
		--if tmp2.query=='' then tmp2.query=nil end
		-- ? if not tmp2.port and scheme=='https' then tmp2.port = 443 end
		return tmp2
	end
	return parse(base)
end

function URI.combine(base, relative, codePage)
	if type(base) == 'string' then
		base = URI.parse(base, codePage)
	elseif not (type(base) == 'table' and base.__oldURI == URI.__oldURI) then
		error('"base" must be a string or URI object: '..tostring(base)..' ('..type(base)..')', 2)
	end

	if relative and type(relative) == 'string' then
		relative = URI.parse(relative, codePage)
	elseif not (type(relative) == 'table' and relative.__oldURI == URI.__oldURI) then
		error('"relative" must be a string or URI object: '..tostring(relative)..' ('..type(relative)..')',2)
	end

	local rPath = relative.path_abempty or relative.path_absolute or relative.path_noscheme or relative.path_rootless
	--local rNonEmpty = relative.scheme or relative.userinfo or relative.host or relative.port or relative.path or relative.query

	local tmp2 = {
		  scheme       = relative.scheme or base.scheme or nil
        , userinfo     = relative.userinfo or nil
        , host         = relative.host or base.host or nil
        --, port         = relative.port or (not (relative.host or relative.scheme) and base.port) or nil
        --, host         = relative.host or (not relative.scheme and base.host) or nil
        , port         = relative.port or (not (relative.host or relative.scheme) and base.port) or nil
        , path_abempty = relative.path_abempty
        				or relative.path_absolute
        				or ( not (rPath or relative.host)
        					and (base.path_abempty or base.path_absolute) )
        				or nil
        , query        = relative.query or (not (rPath or relative.host or relative.query==false) and base.query) or nil
        , fragment     = relative.fragment or nil --or (not rNonEmpty and base.fragment) or nil
	}

	if rPath and not tmp2.path_abempty then
		if not relative.scheme then
			tmp2.path_abempty = (base.path_abempty or '/'):gsub('/[^/]+$','/') .. rPath
		else
			tmp2.path_noscheme = relative.path_noscheme
			tmp2.path_rootless = relative.path_rootless
		end
	end

	if tmp2.path_abempty then tmp2.path_abempty = URI.simplify(tmp2.path_abempty) end

	tmp2.p = tmp2.path and tmp2.path~='/' and split(trim(tmp2.path,'/'),'/') or {}
	tmp2.q = tmp2.query and splitKV(tmp2.query,'=','&',function(t,i,v) t[unescape(i)]=unescape(v) return t end) or {}

	setmetatable(tmp2, URI.__oldURI)
	return tmp2
end

function URI.recode(url, codePage)
	if url:find('^ftp://m/') then return url end
	local tmp = URI.parse((url:gsub('\032','%%20')), codePage)
	local new = tmp(nil, true)				-- userinfo, fragment
	if url ~= new then
		debugLog('URI.recode: old: '..url)
		debugLog('URI.recode: new: '..new)
		return new, tmp
	end
	return url, tmp
end

------------------------------------------------------------------------------------------------------------------------

do
	local getHost_d2 = tableKeys('1fichier.com', 'letitbit.net', 'megashares.com', 'shareflare.net', 'vip-file.com', 'rghost.net', 'junocloud.me')
	--local getHost_d2 = {}
	function getHost(url, isHost, codePage, level)
		--if Settings and not next(getHost_d2) then getHost_d2 = tableKeys(unpack(Settings['<misc>'].getHostL2 or {})) end
		if type(url) == 'string' then
			if not isHost then
				url = URI.parse(url, codePage)
			end
		elseif not (type(url) == 'table' and url.__oldURI == URI.__oldURI) then
			error('"url" must be a string or URI object: '..tostring(url)..' ('..type(url)..')', 2)
		end
		local h = isHost and Punycode.toAscii(unescape(url), codePage) or url.host
		if h and not level then
			h = h:gsub('^ww*%d*%.([%w-]+%..-)','%1')
			h = h:gsub('^[%w.]-%.([^.]+%.[^.]+)$', getHost_d2)
		end
		if h and level then
			local ip = {h:match('^(%d+)%.(%d+)%.(%d+)%.(%d+)$')}
			if #ip>0 then	for i=1, 4 do	if #ip[i]>3 or tonumber(ip[i])>255 then	ip = nil	break	end	end	end
			if #ip>0 then return level=='#' and 1 or h end
			local tmp = split(h, '.')
			if level=='#' then return #tmp end
			level = minMax(1,#tmp, level)
			h = table.concat(tmp, '.', #tmp-level+1)
		end
		return h
	end
end

------------------------------------------------------------------------------------------------------------------------

function replaceVars(str)
	return (str:gsub('%%(%w+)%%',os.getenv))
end

------------------------------------------------------------------------------------------------------------------------

do	-- http://www.inf.puc-rio.br/~roberto/lpeg/
	-- Lexical Elements
	local Space = lpeg.S(" \r\n\t")^0
	local Number = lpeg.C(lpeg.P"-"^-1 * lpeg.R("09")^1) * Space
	local TermOp = lpeg.C(lpeg.S("+-")) * Space
	--local FactorOp = lpeg.C(lpeg.S("*/")) * Space
	local FactorOp = lpeg.C(lpeg.S("*/%")) * Space
	local Open = "(" * Space
	local Close = ")" * Space

	-- Grammar
	local Exp, Term, Factor = lpeg.V"Exp", lpeg.V"Term", lpeg.V"Factor"
	local G = lpeg.P{ Exp,
	  Exp = lpeg.Ct(Term * (TermOp * Term)^0);
	  Term = lpeg.Ct(Factor * (FactorOp * Factor)^0);
	  Factor = Number + Open * Exp * Close;
	}

	G = Space * G * -1

	-- Evaluator
	local function eval (x)
	  if type(x) == "string" then
	    return tonumber(x)
	  else
	    local op1 = eval(x[1])
	    for i = 2, #x, 2 do
	      local op = x[i]
	      local op2 = eval(x[i + 1])
	      if (op == "+") then op1 = op1 + op2
	      elseif (op == "-") then op1 = op1 - op2
	      elseif (op == "*") then op1 = op1 * op2
	      elseif (op == "/") then op1 = op1 / op2
	      elseif (op == "%") then op1 = op1 % op2
	      end
	    end
	    return op1
	  end
	end

	-- Parser/Evaluator
	function evalExp (s)
	  local t = lpeg.match(G, s)
	  if not t then error("syntax error", 2) end
	  return eval(t)
	end

	-- small example
	--print(evalExp"3 + 5*9 / (1+1) - 12")   --> 13.5
end



function urlHead(starturl, referer, tries)
	local data
	if type(referer)=='table' then data = referer else data = {referer=referer, tries=tries} end
	data.referer = data.referer or usd.getlocation()
	data.tries = data.tries or 10
	if usd.progstatus() == 0 then return end
	usd.relocationmode(0)
	usd.setreferer(data.referer)
	local url = starturl
	if url:find('^https:') then
		if data.https then
			url = url:gsub('^https://','http://https..')
		else
			url=url:gsub('^https:','http:')
		end
	end
	local uri = URI.parse(url)
	local hdrs = {}
	local tmp = usd.head(url)
	table.insert(hdrs, tmp)
	for i = 2, data.tries do
		url = parseHeaders().LOCATION1
		usd.setreferer(data.referer)
		if not url or usd.progstatus() == 0 then break end
		uri = uri(url)
		if not data.https then uri.scheme='http' end
		url = uri()
		if uri.scheme=='https' then
			if data.https then
				url = url:gsub('^https://','http://https..')
			end
		end
		tmp = usd.head(url)
		table.insert(hdrs, usd.getheaders())
	end
	usd.relocationmode(1)
	return ('urlHead %d/%d tries; %s\r\n\r\n%s'):format(#hdrs, data.tries, starturl, tableConcat(hdrs,'\r\n','\r\n'..('-'):rep(88)..'\r\n') )
end

local function fixCookies() usd.setcookie( ( tableConcat(splitKV(usd.getcookie(),'=',';'),'=','; ') ) ) end

function urlGet(url, data)
	if usd.progstatus() == 0 then return end
	data = data or {}
	debugLog('urlGet data: '..serialize(data,nil,nil,true))
	data = tableCombine({tries = 10, headCheck=nil, logpref='urlGet'}, data or {})
	if not data.referer then
		local r = usd.getlocation()
		data.referer = r:find('^https?://0%.0%.0%.0/') and '' or r
	end
	local function check(url) if data.headCheck then return type(data.headCheck)=='string' and url:find(data.headCheck) or type(data.headCheck)=='function' and data.headCheck(url) end end
	if check(url) then return url end
	usd.relocationmode(0)
	usd.setreferer(data.referer)
	local uri = URI.parse(url)
	local tmp, tmpfile
	local post = data.post
	--if data.gzip then data.binary = data.binary or true end
	local hGzip = {
		'Accept-Encoding: deflate, gzip, x-gzip, identity, *;q=0'
		--,'TE: gzip, chunked'
		--,'TE: deflate, gzip, chunked, identity, trailers'
	}
	local fc = data.fixCookies and ( type(data.fixCookies)=='function' and data.fixCookies or fixCookies )

	for i = 1, data.tries do
		if not data.https then
			if uri.scheme=='https' and uri.port=="443" then uri.port=nil end
			uri.scheme='http'
		end
		url = uri()
		if uri.scheme=='https' then
			if data.https=='Proxomitron' then
				url = url:gsub('^https://','http://https..')
			end
		end
		debugLog('try '..i..': '..url)
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		if data.headers then setHeader(data.headers) end
		if type(data.gzip)=='string' and data.gzip:lower()=='addheader' then setHeader(hGzip) end
		tmp = post and usd.post(url,post) or usd.get(url)
		if tmp:find("GET Error: can't resolve hostname to IP address") and data.https=='Proxomitron' and url:find('^http://https%.%.') then
			local err = 'No Proxomitron?'
			usd.setstatus(err)
			debugLog(err)
			usd.setretresult('%'..err)
			return err, err
		end
		--if data.binary then
		--	tmp = fileRead(tmpfile)
			if data.gzip then
				local err, tmp2 = tmp:match('^(GET Error: %C+)\n(\31\139\8%z.+)$')
				if err then	tmp,tmp2 = tmp2, nil end
				if tmp:find('^\31\139\8%z') then
					debugLog('gzipped')
					tmp = zlib.decompress(tmp,31)
					--if not usd.fdebug then os.remove(tmpfile) end
				end
			end
		--end
		if data.headers then setHeader(data.headers, true) end
		if tostring(data.gzip):lower()=='addheader' then setHeader(hGzip, true) end
		if fc then fc() end
		local h = parseHeaders(usd.getheaders())
		if not h.CODE then debugLog('no CODE from headers') break end -- empty headers
		if h.CODE==302 or h.CODE==303 then post=nil end		-- rfc2616 10.3.3 302
		url = h.LOCATION1
		usd.setreferer(data.referer)
		if not url then break end
		if not data.noLog then debugSaveInc(data.logpref..'.html', tmp, 'try '..i) end
		if check(url) then
			debugLog('headCheck ok')
			usd.relocationmode(1)
			return url
		end
		uri = uri(url)
		if data.wait then usd.waittime(data.wait) end
	end
	usd.relocationmode(1)
	if data.json then
		local j = parseJsObject(tmp)
		debugSaveInc(data.logpref..'.html', tmp, serialize(j or '<nil>',nil,true))
		return j, tmp
	end
	return not data.headCheck and tmp, tmp --, tmpfile
end

function minMax(min,max,value) return math.min(math.max(min,value),max) end


function uppodDecode(str,data)	--{a=a,b=b,hash=hash}
	local timeStart, strlen = os.clock(), #str
	local function trDecode(str)
		if str:find('^[co]:') then return (str:gsub('^[co]:','')) end
		local n1,n2, s = str:match('^(.)(.)A(.-)r.$')
		if not s then return str end
		n1 = (tonumber(n2..n1) or 0) / 2
		s=s:reverse()
		if n1>=1 then s=s:gsub('('..('.'):rep(n1)..').','%1') end
		return s, true
	end
	data = data or {}
	if str:find('^{') or str:find('^https?://') then return str end
	if str:find('^#%x%x%x%x%x%x%x%x%x') then return (str:sub(2):gsub('%x%x%x',function(a)return string.char(tonumber(a,16))end )) end
	local str, flag = trDecode(str)
	local a, b = data.a, data.b
	local hash = data.hash or [[0123456789WGXMHRUZID=NQVBLihbzaclmepsJxdftioYkngryTwuvihv7ec41D6GpBtXx3QJRiN5WwMf=ihngU08IuldVHosTmZz9kYL2bayE]]
	if not (a and b) then
		local tmp = split(hash, 'ih')
		a,b=tmp[1],tmp[2]
		if flag then a,b=tmp[3],tmp[4] end
	end
	local recode = (function(a,b)local t={} for i=1,#a do local c,d=a:sub(i,i),b:sub(i,i) t[c],t[d]=d,c end return t end)(a,b)
	str = str:gsub('.',recode)
	local timeRecode = os.clock()
	str = base64.decode(str)
	timeEnd = os.clock()
	if strlen>102400 then debugLog(('uppodDecode()   size: %d; total: %0.3fs; recode: %0.3fs; b64d: %0.3fs'):format(strlen, timeEnd-timeStart, timeRecode-timeStart, timeEnd-timeRecode)) end
	return str
end


-- cache: dirUrl, post, cookie, referer, noResume, newName, size, maxAge
-- config: enable, minSize, maxAge, whiteList, blackList
Storage['<Cache>'] = Storage['<Cache>'] or {}
--local Cache_whiteList, Cache_blackList
Cache = {
    checkHost = function(origUrl)
    	local conf = Settings['<Cache>']
    	local host = getHost(origUrl)
    	if not tmpData.cacheHosts then
			debugLog('Cache settings: '..serialize(Settings['<Cache>'] or '<none>'))
    		tmpData.cacheHosts = {}
    	end
    	if tmpData.cacheHosts[host]~=nil then return tmpData.cacheHosts[host] end
		if not conf.enable
			or ( conf.blackList and tableContains(conf.blackList, host) )
			or ( conf.whiteList and not tableContains(conf.whiteList, host) )
			then
			--debugLog('Cache.checkHost(): false: '..host)
			tmpData.cacheHosts[host] = false
			return false
		end
		--debugLog('Cache.checkHost(): true:  '..host)
		tmpData.cacheHosts[host] = true
		return true
	 end

	, get = function(origUrl, getData)
		local conf = Settings['<Cache>']
		if not conf.enable then return false end
		if not Cache.checkHost(origUrl) then return end
		local cached = Storage['<Cache>'][origUrl]
		if not cached then return end
		--cached = tableCopy(cached)
		debugSaveInc('cached.html', origUrl..'\r\n'..serialize(cached,nil,true), nil, false)
		if cached.maxAge and (os.time()-cached.time > cached.maxAge) then
			Cache.del(origUrl)
			return false
		end
		if getData then return cached end
		if cached.cookie then usd.setcookie(cached.cookie) end
		if cached.referer then usd.setreferer(cached.referer) end

		local sizeHead = -1
		local sizeLst = tonumber(getLstInfo().size or -2)
		if not cached.post then
			usd.head(cached.dirUrl)
			local h = parseHeaders(usd.getheaders())
			sizeHead = h.CODE==200 and h.SIZE or -1
			debugSaveInc('cached.html', 'sizeHead='..sizeHead..'\r\nsizeLst= '..sizeLst)
		end

		if sizeHead < (conf.minSize or 1024*1024) then -- 7 - "Expired"
			debugLog('Cache.get(): file is too small')
			return false
		end

		if ( (sizeHead == sizeLst) or (0 == sizeLst) )
			or cached.post
		then
			if cached.referer then usd.setreferer(cached.referer) end
			if cached.cookie then usd.setcookie(cached.cookie) end
			usd.setretresult(cached.dirUrl, 0, cached.noResume and 0 or 1, cached.post)
			return cached
		end
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		Cache.del(origUrl)
		return false
	end

	, set = function(origUrl, data, addCookieReferer)
		if not Cache.checkHost(origUrl, true) then return end
		local tmp = tableCopy(data)
		tmp.time = os.time()
		if addCookieReferer then
			tmp.referer = tmp.referer or usd.getlocation()
			tmp.cookie = tmp.cookie or usd.getcookie()
		end
		Storage['<Cache>'][origUrl] = tmp
		return true
	end

	, del = function(origUrl)	Storage['<Cache>'][origUrl]=nil	end

	, delOld = function(maxAge)
		if not Storage['<Cache>'] then return end
		maxAge = maxAge or Settings['<Cache>'].maxAge or 60*60*24
		local ts = os.time()
		for k, v in pairs(Storage['<Cache>']) do
			if ts-v.time>maxAge
				or not v.time
				or v.maxAge and ts-v.time > v.maxAge
				then
				Storage['<Cache>'][k]=nil
			end
		end
	end

} -- Cache


function parseHeaders(str)
	local tmp
	local hdrs = {}
	if not str then
		debugLog('parseHeaders(): no str, using usd.getheaders()')
		str = usd.getheaders()
	end
	hdrs.LOCATION, tmp = str:match('^Location: ([^\r\n]*)%s*(.*)$')
	if hdrs.LOCATION=='' then hdrs.LOCATION = nil end
	if tmp=='' then return hdrs end -- empty
	if hdrs.LOCATION then hdrs.LOCATION = hdrs.LOCATION:gsub('^http://https%.%.','http://') end
	hdrs.CODE, hdrs.REASON, tmp = (tmp or str):match('^[hH][tT][tT][pP]/%d.%d%s+(%d+) *([^\r\n]*)%s*(.+)$')
	if hdrs.CODE then hdrs.CODE = tonumber(hdrs.CODE) end

	local sep = '%c()<>@;:\\"%[%]?={}\032'
	for h, v in (tmp or str):gmatch('([^'..sep..']+):([^\r\n]*)') do
		h = h:lower()
		hdrs[h] = hdrs[h] or {}
		table.insert(hdrs[h], trim(v))
	end

	if hdrs['content-disposition'] then
		local cd = hdrs['content-disposition'][1]
		hdrs.FILENAME = cd:match(';%s*[fF][iI][lL][eE][nN][aA][mM][eE]%*%s*=%s*([^;%s]+)')

		if hdrs.FILENAME then
			local cp, name = hdrs.FILENAME:match("^\"?([%w-]*)''(.-)\"?$")
			cp = cp:lower()
			if cp=='' then cp=nil end
			hdrs.FILENAMECP = cp
			hdrs.FILENAME = name
		end

		hdrs.FILENAME = hdrs.FILENAME
			or cd:match(';%s*[fF][iI][lL][eE][nN][aA][mM][eE]%s*=%s*"([^"]+)"')
			or cd:match(";%s*[fF][iI][lL][eE][nN][aA][mM][eE]%s*=%s*'([^']+)'")
			or cd:match(';%s*[fF][iI][lL][eE][nN][aA][mM][eE]%s*=%s*([^;%s]+)')

		if (hdrs.FILENAME or ''):find('^=%?') then
			local cp, name = hdrs.FILENAME:match('^=%?([%w-]+)%?Q%?(.-)%?=$')
			hdrs.FILENAMECP = cp:lower()
			hdrs.FILENAME = name:gsub('=','%%')
		end
	end

	if hdrs['content-type'] then
		local t, cp = hdrs['content-type'][1]:lower():match('^([^;]*)%s*;%s*charset%s*=(.*)')
		hdrs.TYPE = trim(t or hdrs['content-type'][1]:lower(), re.compile('[%s ;]') )
		hdrs.TYPECP = cp and trim(cp, re.compile('[%s ;]') ) or nil
	end

	if hdrs['content-range'] then
		local s1, s2
		s1, s2, hdrs.SIZE = hdrs['content-range'][1]:lower():match('^bytes (%d+)%-(%d+)/(%d+)$')
		if s1 then hdrs.SIZEPART = s2-s1+1 end	-- empty header!
	elseif hdrs['content-length'] then	--    content-range!
		hdrs.SIZE = hdrs['content-length'][1]:match('^(%d+)$')
	end
	hdrs.SIZE = tonumber(hdrs.SIZE)

	if hdrs['refresh'] then
		hdrs.REFRESHTIME = tonumber(hdrs['refresh'][1]:match('^%s*(%d+)'))
		hdrs.REFRESH = hdrs['refresh'][1]:match('[Uu][Rr][Ll]%s*=%s*(.+)$')
	end

	hdrs.LOCATION1 = hdrs.location and hdrs.location[1] or nil
	local tmp = hdrs.LOCATION1 or hdrs.LOCATION or hdrs.REFRESH
	hdrs.FILENAME = hdrs.FILENAME
		or (tmp and (URI.parse(tmp).path or ''):match('/([^/]+)$'))
		or nil
	if hdrs.FILENAME then hdrs.FILENAME = (unescape(hdrs.FILENAME):gsub('\\(.)','%1'):gsub('[\\/]','_')) end

	return hdrs
end


local charset62 = split('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ','')
function numBase(num, base, charset)
	base = base or 10
	charset = charset or charset62

	if type(base)~='number' then
		error('base is not a number',2)
	elseif type(charset)~='table' or #charset<2 then
		error('bad charset',2)
	elseif base<2 or base>#charset then
		error('wrong base; must be 2...#charset',2)
	end

	if type(num)=='number' then
		local str = {}
		repeat
			table.insert(str, 1, charset[(num%base)+1])
			num = math.floor(num/base)
		until num == 0
		return table.concat(str)
	elseif type(num)=='string' then
		local tmp = nil
		for c in num:gmatch('.') do
			local d = tableContains(charset, c)
			if not d or d>base then break end				-- javascript:alert([parseInt('123a1'),parseInt('z')]) -- 123,NaN
			tmp = (tmp or 0)*base + d-1
		end
		return tmp
	end

	error('num is not a number or string',2)
end




function chunkedDownload(url, newName, data)
	data = tableCombine({logpref='chunkedDownload', chunkSize=1024*1024, chunkPause=1, referer=usd.getlocation(), saveTo=nil, status=''}, data or {})
	data.chunkSize = math.max(data.chunkSize, 256*1024)
	debugLog('chunkedDownload(): data='..serialize(data))

	usd.setreferer(data.referer)
	local tmp = data.noHead and urlGet(url, {headers={'Range: bytes='..math.random(1234,2345)..'-'..math.random(3456,4567)}}) or usd.head(url)
	debugSaveInc(data.logpref..'.html', tmp)
	local headers = parseHeaders()
	local fsize = headers.SIZE or -1
	debugLog(fsize..' bytes')
	if fsize <= 0 then return debugLog('chunkedDownload() end: file size = 0 or none') end

	local restart, info, pusd, limit
	if data.saveTo then
		pusd = data.saveTo
		limit = fsize-1
	else
		if fsize<data.chunkSize+1024 then return debugLog('chunkedDownload() end: file is too small') end
		restart, info = setPusdName(newName or plg.exename..'-chunkedDownload-'..os.time(), data.info)
		if restart then return true, info end
		pusd = info.localfile..'.pusd'
		limit = fsize-1-data.chunkSize-1024
	end

	local pusdsize = fileSize(pusd) or 0
	--local tmpfile = table.concat({(usd.workdir or Settings['<misc>'].tempDir)..data.logpref, plg.plgname, plg.exename..'.tmp'}, '-')
	local debugHeaders = {}

	local function checkError(flag, msg)
		if flag then
			debugSaveInc(data.logpref..'.html', table.concat(debugHeaders,'\r\n'..('-'):rep(88)..'\r\n'), serialize(headers,nil,true))
			error(msg or '<no error msg>')
		end
	end

	usd.setstatus(('chunkedDownload(): %0.2f MB\n%s'):format(fsize/1024/1024, data.status))
	usd.waittime(1)
	for i = pusdsize, limit, data.chunkSize do
	    local chunkEnd = math.min(i+data.chunkSize-1, fsize-1)
		local range = 'Range: bytes='..i..'-'..chunkEnd
		local checkCR = '^bytes '..i..'%-'..chunkEnd..'/'
		debugLog(range)
		if data.headers then setHeader(data.headers) end
		setHeader(range)
		usd.setreferer(data.referer)
		--local result = usd.get(url..'|'..tmpfile)
		checkError(usd.progstatus() == 0, 'chunkedDownload(): USD stopped 1')
		local tmp = usd.get(url)
		checkError(usd.progstatus() == 0, 'chunkedDownload(): USD stopped 2')
		table.insert(debugHeaders, usd.getheaders())
		if data.headers then setHeader(data.headers, true) end
		setHeader(range, true)
		headers = parseHeaders()
		--debugLog(headers)
		local size = chunkEnd-i+1
		checkError(headers.CODE ~= 206, 'chunkedDownload(): Wrong code!')
		checkError(headers.SIZEPART ~= size, 'chunkedDownload(): Wrong headers! Size mismatch')
		checkError(not headers["content-range"][1]:lower():find(checkCR), 'chunkedDownload(): Wrong content-range!')
		checkError(#tmp ~= size, 'chunkedDownload(): Wrong data size: '..size..' <> '..#tmp)
		fileAppend(pusd, tmp)
		tmp = nil
		usd.waittime(data.chunkPause)
	end
	--os.remove(tmpfile)
	debugSaveInc(data.logpref..'.html', table.concat(debugHeaders,'\r\n'..('-'):rep(88)..'\r\n'), serialize(headers,nil,true))
	debugLog('chunkedDownload() end')
	return false, info
end

function s2hms(n) return ('%02d:%02d:%02d'):format(math.floor(n/60/60),math.floor((n/60)%60),n%60) end


function getIP(useCache, ref)
	if useCache and tmpData.IP then
		usd.setreferer(ref)
		return tmpData.IP
	end
	local oldCookie = usd.getcookie()
	ref = ref or usd.getlocation()
	usd.setcookie('')
	usd.setreferer('')
	local IP = usd.get(Settings['<misc>'].extIP or 'http://icanhazip.com/'):match('%d+%.%d+%.%d+%.%d+')
	usd.setcookie(oldCookie)
	usd.setreferer(ref)
	if not IP then
		debugLog('getIP(): no IP')
		return false
	end
	tmpData.IP = IP
	return IP
end


Storage['<Timeouts>'] = Storage['<Timeouts>'] or {}
Timeout = {
	get = function(host, ref, IP)
		if ref then usd.setreferer(ref) end
		local tmp = Storage['<Timeouts>'][host]
		if not tmp then return false end
		debugLog(serialize(tmp))
		debugLog('Since last download: '..(os.time()-tmp.timestamp))
		local diff = (tmp.timestamp+tmp.timeout)-(os.time())
		if diff<1 then return false end
		local currentIP = IP or getIP(true, ref)
		debugLog('current IP: '..tostring(currentIP))
		if tmp.IP~=currentIP then return false end
		debugLog('need wait: '..diff)
		usd.setretresult('%Server report: You need wait ' .. diff .. ' seconds')
		return diff
	end
	, set = function(host, timeout, ref, IP)
		if timeout<1 then return end
		Storage['<Timeouts>'][host] = {timestamp=os.time(), IP=(IP or getIP(true, ref)), timeout=timeout}
		if ref then usd.setreferer(ref) end
	end
    , delOld = function()
    	local ts = os.time()
    	for k, v in pairs(Storage['<Timeouts>']) do
    		if ts > v.timestamp+v.timeout then Storage['<Timeouts>'][k] = nil end
    	end
    end
}

function convertGif(url, maxGifSize, checkType)
	local uri = URI.parse(url)
	if not maxGifSize then return debugLog('convertGif(): no maxGifSize') end
	if (not checkType or checkType=='ext') and not uri.path:lower():find('%.gif$') then return debugLog('convertGif(): not .gif') end
	local logpref = 'convertGif'
	local u = url --:match('^([^?]+)')
	debugSaveInc(logpref..'.html', usd.head(u))
	local h = parseHeaders()
	if not h then
		debugSaveInc(logpref..'.html', usd.head(u))
		h = parseHeaders()
	end
	if (not checkType or checkType==true or checkType=='type') and h.TYPE:lower() ~= 'image/gif' then return debugLog('convertGif(): not image/gif') end
	if (h.SIZE or maxGifSize) < maxGifSize then return debugLog('convertGif(): too small') end
	local page, data
	local attempts = 6
	--local key = randomString(10,'%w')
	local u1 = 'http://upload.gfycat.com/transcode?fetchUrl='..escapeUC(url)
	--local u2 = ('http://upload.gfycat.com/transcodeRelease/%s?fetchUrl=%s'):format(key,escapeUC(url))
	--local u3 = 'http://gfycat.com/cajax/checkUrl/'..escapeUC(url)
	for i=1, attempts do
		--local u2 = u..(i>1 and (u:find('?') and '&' or "?")..i or '')
		--page = usd.get('http://upload.gfycat.com/transcode?fetchUrl='..escapeUC(u2))
		data, page = urlGet(u1,{json=true,logpref=logpref})
		data = data or {}
		if data.error then
			debugLog(data.error)
			if data.error=="Invalid Key" or data.error=="Oops! Does not appear to be a valid GIF or Video" then
				return
			elseif data.error:find('^Connection timeout') then
			end
		end
		--if data.isOk or (data.error or ''):find('^Key already in use') then
		--end
		if data.gifSize==h.SIZE or i==attempts or data.gfyname then break end
		usd.waittime(30)
	end
	if data.error then return end
	--if data.gifSize~=h.SIZE then return debugLog('convertGif(): wrong size') end
	page = usd.get('http://gfycat.com/cajax/get/'..data.gfyName)
	data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
	if data.gfyItem.gifSize > data.gfyItem.mp4Size then
		url = data.gfyItem.mp4Url
		if data.gfyItem.mp4Size / data.gfyItem.webmSize > 2 then url = data.gfyItem.webmUrl end
	elseif data.gfyItem.gifSize > data.gfyItem.webmSize then
		url = data.gfyItem.webmUrl
	else
		return nil	-- no url
	end
	url = url:gsub('^https:','http:')
	return url
end


------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------

(function(...)
	local function readonly(tname)	 -- http://www.lua.org/pil/13.4.5.html
		local old = _G[tname]
		local proxy = {__override__ = function(k,v) if not (tname=='plg' and k=='lib2version') then debugLog(('!!! Warning !!! override: %s %s = %s'):format(tname,k,v)) end old[k]=v end}
		local mt = {
			__index = function(t,k) return old[k] end
			, __newindex = function(t,k,v)
				local err = 'Attempt to modify read-only table: '..tname
				usd.savetolog(err)
				error(err,2)
			end
		}
		setmetatable(proxy, mt)
		_G[tname] = proxy
	end

	local wp = {}
	local skip=tableKeys('_G', 'Storage', '__Storage__Old__', 'iup')
	for k, v in pairs(_G) do
		if not skip[k] and type(v) == 'table' then
			table.insert(wp, k)
			readonly(k)
		end
	end
	debugLog('    Write protected: '..table.concat(wp, ', '))
end)();


------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------


_exec = function(fname)
	local func, err = loadfile(replaceVars(fname))
	if func then
		usd.savetolog('    loading ' .. fname)
		func()
	elseif err:find(': No such file or directory$') then	-- cannot open d:\file.lua: No such file or directory
		usd.savetolog('    not exist (OK): ' .. err)
	else
		usd.savetolog('    not loaded (error): ' .. err)
		plg.msg('Error:\n\n'..err)
	end
end
_exec2 = function(name) _exec(usd.workdir .. 'lua\\' .. name) end

Captchas = {}
captchaAttempts = 3
_exec2 'captchas.lua'

Accounts={}
function addAccount(site, login, pass)
	Accounts[site]=Accounts[site] or {}
	table.insert(Accounts[site], {login=login, password=pass} )
end
_exec2 (plg.plgname .. '_accounts.lua')

Settings={}
_exec2 (plg.plgname .. '_settings.lua')
_exec2 (plg.plgname .. '_settings2.lua')

Settings['<Cache>'] = Settings['<Cache>'] or {}

Settings['<misc>'] = tableCombine({getResumeFlagLimit=128*1024, subdirs={}}, Settings['<misc>'] or {} )
local sm = Settings['<misc>']
sm.modqueryPause = math.max(sm.modqueryPause or 0, 4)	  --  4 
sm.getLstInfoPause = math.max(sm.getLstInfoPause or 0, 3) --  3 
sm.extDownloader = tonumber( usd.ini.main.dowithlink ) ~= 0
sm.tempDir = sm.tempDir and replaceVars(sm.tempDir):gsub('\\?$','\\', 1) or usd.workdir
sm.maxWait = minMax(60,99999,sm.maxWait or 0)
if type(sm.extIPservices)=='table' then sm.extIP = sm.extIPservices[math.random(#sm.extIPservices)] end
--sm.getHostL2 = sm.getHostL2 or {'1fichier.com', 'letitbit.net', 'megashares.com', 'shareflare.net', 'vip-file.com'}
_exec2('somelibrary.luac')

_exec, _exec2, sm, sd = nil

debugLog(('usdLua.lua version = %s; somelibrary version = %s'):format(plg.lib1version, tostring(plg.lib2version)))
