
function GDL(origUrl) 	-- GetDirectLink
	usd.setstatus(script.name)
	logpref = script.name .. '_GDL_v08'
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<div class="triangle%-border">[^<]-(Our servers are overloaded at the current moment)')
	if not err then
		local tmp = page:match("var msg = '([^']+)=';[^<]-Base64.decode")
		if tmp then err = base64.dec(tmp) end
	end
	if err then
		if err:find('The file link that you requested is not valid') then err = 'notfound%' end
		return usd.setretresult('%'..err)
	end


	local wait = page:match('var waitSeconds = (%d+);')
	--if not wait then
	--	wait = page:match('<div class="triangle-border">[^<]-wait <span>(%d+) minutes</span>')
	--	if wait then wait = wait*60 end
	--end
	if wait then
		usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
		return
	end

	usd.waittime(3,3)

	local dirUrl = page:match('value="(http://dc%d+%.2shared%.com/download/[^"]+)"')

  	if not dirUrl then return usd.setretresult('%plugindefect') end

	usd.setretresult(dirUrl,1,1)
	return
end

regDirSuccess( '.2shared.com/', GDL, OS)
