
function GDL(origUrl)
	usd.setstatus(script.name)
	local logpref = script.name..'_GDL_v13'
	local dirUrl, page, badpage, form
	script.tmp={}

	--USD -   : df="";sd="";afu="";afp="";adu="";adp="";asl="";chf="";dirPwdVerified=""
	--local function fixCookie() usd.setcookie( (usd.getcookie():gsub(';(%S)', '; %1'):gsub('WWW Login=','Login=')) ) end
	local function fixCookie() usd.setcookie( (usd.getcookie():gsub('^%W+',''):gsub('WWW_JSESSIONID="";',''):gsub('WWW[%s_]',''):gsub(';+(%S)', '; %1')) ) end

	if script.cookie then
		usd.setcookie(script.cookie, 1)
	else
		usd.get('http://0.0.0.0/headers')
		usd.setreferer('')
		usd.setcookie('4langcookie=en')

		local a = Accounts['4shared.com']
		if not a then
			usd.setretresult('%Need account')
			return
		end

		page = usd.get('https://www.4shared.com/web/login/validate?login='..escapeUC(a[1].login)..'&password='..escapeUC(a[1].password))
		debugSaveInc(logpref..'.html', page, 'login 1')
		fixCookie()

		local data = parseJsObject(page)
		if not data.success then
			usd.setretresult('%'..utf8ToAnsi(data.errorMessage or '<login error>'))
			return
		end

		local data = {login=a[1].login, password=a[1].password, returnTo=origUrl, remember='on', _remember='on'}
		page = usd.post('https://www.4shared.com/web/login', tableConcat(data, '=','&',escapeUC))
		debugSaveInc(logpref..'.html', page, 'login 2')
		fixCookie()

		usd.waittime(2,2)
	end

	origUrl = URI.recode(origUrl)
	page = usd.get(origUrl)
	local ecp = parseJsObject(page:match('epomCustomParams = .-</script>') or '')
	debugSaveInc(logpref..'.html', page, serialize(ecp or '<nil>',nil,true))
	if not ecp or (ecp.filetype~="SIMPLE_VIEW" and ecp.fileName=='') then return usd.setretresult('%notfound%') end

	local id = origUrl:match('^[^/]+//[^/]+/[^/]+/([^/]+)')

	local folder = page:match('class="jsItemDirId" value="([^"]+)"')
	if folder then
		page = usd.post('http://www.4shared.com/web/accountActions/changeDir', '%simple%dirId='..folder)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'_folder.html', page, serialize(data or {},nil,true))
		for k,v in ipairs(data.info.files) do
			usd.addquery( ('http://www.4shared.com/file/%s/%s_%0.2fMb'):format(
				v.id
				, filterName(utf8ToAnsi(entityDecode((v.name))):gsub('<wbr/>',''):gsub('%s+','_'):gsub('[\'"]',''))
				, (v.size or 0)/1024/1024
			))
		end
		usd.setretresult('%done%')
		return
	end

	script.tmp.newName = filterUtf8(ecp.fileName)

	local wait = page:match("id='downloadDelayTimeSec'[^>]->(%d+)<") or 5
	wait = math.max(wait,20)
	dirUrl = page:match('href="(http://dc%d+%.4shared%.com/download/[^"]+)" class="downloadButton"')

	if dirUrl then
		usd.waittime(wait+2, 2)
		usd.setretresult(dirUrl, 1, 1)
		script.cookie = usd.getcookie()
		return
	end

	local tmp = page:match('href="(http://www.4shared.com/get/'..escapeLua(id)..'[^"]+)"')
		or page:match('value="(http://www.4shared.com/get/'..escapeLua(id)..'[^"]+)"')

	if page:find('</html>') and not tmp then
		usd.setretresult('%notfound%')
		return
	end

	usd.waittime(2,2)

	page = usd.get(URI.recode(tmp))
	debugSaveInc(logpref..'.html', page)

	if page:find('SharedFileImpl.wasDeleted',1,true) then
		script.cookie = usd.getcookie()
		usd.setretresult('%deleted%')
		return
	end

	local wait = page:match('class="downButtonPromoCounter">(%d+)<')
	wait = math.max(20, tonumber(wait) or 0)

	dirUrl = page:match('id="baseDownloadLink" value="(http://dc%d+%.4shared%.com/download/[^"]+)"')

	if not dirUrl or dirUrl:find('/4shared_Desktop_',1,true) then return usd.setretresult('%plugindefect') end

	usd.waittime(wait+2,2)

	script.cookie = usd.getcookie()

	usd.setretresult(dirUrl, 1, 1)

	return

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess('.4shared.com/', GDL,  OS)
