--	http://bayfiles.com/file/*	http://bayfiles.net/file/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0005'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, err, dirUrl
	script.tmp={}

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	if usd.getlocation():match('http://bayfiles%.%a+/$') then
		return usd.setretresult('%notfound%')
	end
	err = page:match('<div id="download%-header" class=[^<]+<p>(.-)<')
	if err then
		usd.savetolog('Error: '..err)
		return usd.setretresult('%notfound%')
	end
	err = page:match('<center><strong style="color:#B22B13;">(.-)<')
	if err then
		usd.setstatus(err)
		usd.savetolog('Error: '..err)
		usd.waittime(math.random(20,40))
		return usd.setretresult('%Server report: '..err)
	end

	script.tmp.newName = utf8ToAnsi(page:match('<p title="([^"]+)">'))
	local delay = page:match('var delay = (%d+);') or 120
	local vfid = page:match('var vfid = (%d+);')
	dirUrl = page:match('href="(http://s%d+%.baycdn%.%a+/dl/[^"]+)"')

	if not dirUrl then
		page = usd.getcookie()
		debugSaveInc(logpref..'.html', page)
		local a = tonumber(page:match('a=(%x+)%%2F'), 16)
		page = usd.get('/ajax_download?_='..a..'&action=startTimer&vfid='..vfid)
		debugSaveInc(logpref..'.html', page)

		local token = page:match('"token":"(%x+)"')
		usd.waittime(delay+math.random(1,4))
		page = usd.post('/ajax_download', '%simple%action=getLink'..'\n'..'vfid='..vfid ..'\n'..'token='..token)
		debugSaveInc(logpref..'.html', page)

		dirUrl = page:match("location%.href = '(http://[^']+)';")
		if not dirUrl then return usd.setretresult('%dirUrl not found') end
		usd.setretresult(dirUrl, math.random(1,4),1)
		return
	end

	usd.setretresult(dirUrl, delay+math.random(1,4),1)
	return
end


function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess( 'bayfiles.com/file/', GDL, OS )
regDirSuccess( 'bayfiles.net/file/', GDL, OS )

