--	http://data.hu/get/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0001'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<div class="error_box">(.-)</div>')
	if err then
		usd.savetolog('Error: '..string.gsub(utf8ToAnsi(err), '<br>',' '))
		return usd.setretresult('%notfound%')
	end

	newName = page:match('<div class="download_filename">(.-)</div>')
	newName = utf8ToAnsi(newName)

	local dirUrl = page:match('<div class="download_box_button"><a href="([^"]+)">')
	if not dirUrl then return usd.setretresult('%dirUrl not found') end
	usd.setretresult(dirUrl..'?/'..newName, math.random(1,7),1)
	return
end

function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, newName))
end

regDirSuccess('//data.hu/get/', GDL, OS)

