--	http://dropmefiles.com/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0004'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, folderUrl, dirUrl
	script.tmp={}

	if origUrl:find('.dropmefiles.com/dl/', 1,true) then
		folderUrl = origUrl:gsub('drop%d.dropmefiles.com/dl/','dropmefiles.com/'):gsub('/%d+$','')
		page = utf8ToAnsi(usd.get(folderUrl))
		debugSaveInc(logpref..'.html', page)

		if usd.getlocation() == 'http://dropmefiles.com' then
			return usd.setretresult('%notfound%')
		end
		err = page:match('class="dw%-list showed">%s*<b>(.-)</')
			or page:match('class="time lt">%s*<div class="counter">(.-)</')
		if err then
			usd.savetolog('Error: '..err:gsub('<br />',' '))
			return usd.setretresult('%notfound%')
		end

		script.tmp.newName = page:match('stream:([^:]+):'..origUrl)
		dirUrl = origUrl
		usd.setretresult(dirUrl, math.random(1,7),1)
		return
	end

	page = utf8ToAnsi(usd.get(origUrl))
	debugSaveInc(logpref..'.html', page)
	dirUrl, script.tmp.newName = page:match('data%-href="([^"]+)"%s*data%-downloadurl="application/octet%-stream:([^:]+):http')

	if not dirUrl then
		if usd.getlocation() == 'http://dropmefiles.com' then
			return usd.setretresult('%notfound%')
		end
		err = page:match('class="dw%-list showed">%s*<b>(.-)</')
			or page:match('class="time lt">%s*<div class="counter">(.-)</')
		if err then
			err = err:gsub('<[^>]+>',' ')
			usd.savetolog('Error: '..err)
			if err == '  ' then
				return usd.setretresult('%deleted%')
			end
			return usd.setretresult('%notfound%')
		end
		return usd.setretresult('%dirUrl not found')
	end

	if page:find('class="fileCount">1</div>',1, true) then
		dirUrl = dirUrl:gsub('https://','http://')
		usd.setretresult(dirUrl, math.random(1,7),1)
		return
	end

	page = page:match('id="upfiles">(.-)<noindex>')
	if not page then return usd.setretresult('%Folder is empty?') end
	debugSaveInc(logpref..'.html', page)

	page:gsub('stream:([^:]+):(http://drop%d.dropmefiles.com/dl/[^"]+)">'
	, function(name, link)
		usd.savetolog(' + '..name..' | '..link)
		usd.addquery(link)
	end)

	return usd.setretresult('%done%')
end

function OS(origUrl, dirUrl, fullName)
	if script.tmp.newName then
		usd.setretresult(fileRename(fullName, script.tmp.newName))
	end
	return
end

regDirSuccess( 'dropmefiles.com/', GDL, OS )

