--	http://exfile.ru/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0001'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, form, err, dirUrl
	script.tmp={}

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	script.tmp.newName = page:match('ExFile %-=%- ([^<]+)</title>')

	if page:find('<pre><input type="password"') then
		form = page:match('<input type="hidden" name="id_file".-</table>')
		if not form then return usd.setretresult('%form not found') end
		form = Form.parse('<form action="http://exfile.ru/action/get_param.php" method=post>'..form..'</form>')
		form.inputs.password = origUrl:match("://([^@/]-)@")
		if not form.inputs.password then
			local default = usd.getoption(script.name,'Default', '')
			local dlg = Dialog.new( {
				{ ' :   '..origUrl }
				, { ' :', {name='password', type='password', default} }
				}, script.name)
			form.inputs.password = dlg:show():match("password=(.-)\n")
		end
		if origUrl:find('@') then usd.waittime(math.random(3,9)) end
		page = form:submit()
		debugSaveInc(logpref..'.html', page)
	end

	dirUrl = page:match('<a href="(/download/%d+[^"]*)"')
	if not dirUrl then
		err = page:match('id="link"><p class="red">(.-)<')
		if err then
			usd.savetolog('Error: '..err)
			return usd.setretresult('%notfound%')
		end
		err = page:match('<span class="red">(.-)<')
		if err then return usd.setretresult('%'..err) end
		return usd.setretresult('%dirUrl not found')
	end

	usd.setretresult('http://exfile.ru'..dirUrl, math.random(1,4),1)
	return
end

function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess( '//exfile.ru/', GDL, OS )
regDirSuccess( '@exfile.ru/', GDL, OS )

