--	http://file.karelia.ru/*

function GDL(origUrl)
	usd.setstatus(script.name)
	logpref = script.name..'_GDL_0005'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, dirUrl

function getNewName(str)
	newName = str:match('/([^/]+)%?force$') or str:match('/([^/]+)$')
	newName = utf8ToAnsi(unescape(newName))
end

	if origUrl:match('://f?i?l?e?%-?st%d+\.') then
		page = usd.head(origUrl)
		debugSaveInc(logpref..'.html', page)
		if usd.getlocation():match('://f?i?l?e?%-?st%d+\.') then
			getNewName(origUrl)
			usd.setretresult(origUrl, math.random(4,7),1)
			return
		else
			return usd.setretresult('%notfound%')
		end
	end

	if origUrl:match('%.ru/[^/]+$') then origUrl = origUrl..'/' end

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	err = page:match('class="errorpage">(.-)<')
	if err then
		usd.savetolog(utf8ToAnsi('Error: '..err))
		return usd.setretresult('%notfound%')
	end

	if page:find('class="totalSize">1 ', 1,true) then
		dirUrl = page:match('href="(http://[^"]+)"%s+class="file%-download')
		if not dirUrl then return usd.setretresult('%dirUrl not found') end
		getNewName(dirUrl)
		usd.setretresult(dirUrl, math.random(1,7),1)
		return
	end

	if page:match('class="totalSize">(%d+) ') > '1' then
		page:gsub('href="(http://[^"]+)"[^>]+>%s+<span class="filename[^"]+">([^<]+)</span><i>&mdash;([^<]+)<'
		, function(link, name, size)
			usd.savetolog(utf8ToAnsi(' + '..name..size:gsub('&nbsp;',' ')))
			usd.savetolog(link); usd.addquery(link..'?force')
		end)
		return usd.setretresult('%done%')
	else
		return usd.setretresult('%Folder is empty?')
	end

end

function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, newName))
end

regDirSuccess( '.karelia.ru/', GDL, OS )
regDirSuccess( 'file.sampo.ru/', GDL, OS )
