--	http://www.filepup.net/files/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0002'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, wait, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	local _ = page:match("document%.location='([^']+/get/[^']+)';")

	if not _ then
		if page:find('>This file has been deleted.<',1, true) then return usd.setretresult('%notfound%') end
		usd.setretresult('%No free download?')
		return
	end

	wait = page:match('var time = (%d+);') or 30
	usd.waittime(wait+math.random(1,4))
	page = usd.get(_)
	debugSaveInc(logpref..'.html', page)

	form = page:match('<form name="popi".-</form>')
	if not form then return usd.setretresult('%popi not found') end
	form = Form.parse(form)
	usd.waittime(math.random(1,4))
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	dirUrl = usd.getheaders():match('Location: ([^%c]+)', 2)
	if not dirUrl then
		err = page:match('class="error">(.-)<')
		if err then return usd.setretresult('%Server report: '..err) end
		return usd.setretresult('%dirUrl not found')
	end

	dirUrl = dirUrl:gsub('%?file=','?/')
	usd.setretresult(dirUrl, 1,1)
	return
end

regDirSuccess( 'filepup.net/files/', GDL, OS )

