--	http://files.mail.ru/*

function GDL(origUrl)
	usd.setstatus(script.name)
	logpref = script.name..'_GDL_0005'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, form, wait, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	page = utf8ToAnsi(page)

	err = page:match('class="errorMessage mb10">%s*<b></b><br />%s*([^<]+)<')
	if err then
		usd.savetolog('Error: '..err)
		return usd.setretresult('%notfound%')
	end

	if origUrl:find('//cloud.mail.ru/',1, true) then
		dirUrl = page:match('"get": "https://(cloclo%d+%.datacloudmail%.[^"]+)"')
		if dirUrl then
			return usd.setretresult('http://'..dirUrl, math.random(1,4),0)
		end
		return usd.setretresult('%dirUrl not found')
	end

	form = page:match('<form name="getfile".-</form>')
	if form then
		form = Form.parse(form)
		form.inputs.linkpass = origUrl:match("://([^@/]-)@")
		if not form.inputs.linkpass then
			local default = usd.getoption(script.name,'Default', '')
			local dlg = Dialog.new( {
				{ ' :   '..origUrl }
				, { ' :', {name='password', type='password', default} }
				}, script.name)
			form.inputs.linkpass = dlg:show():match("password=(.-)\n")
		end
		if origUrl:find('@') then usd.waittime(math.random(3,9)) end
		page = form:submit()
		debugSaveInc(logpref..'.html', page)
		page = utf8ToAnsi(page)
	end

	dirUrl = page:match('<a href="(http://download%d+%.files%.[^"]+)"')
	if not dirUrl then
		err = page:match('class="errorMessage mb10">%s*<b></b><br />%s*([^<]+)<')
		if err then return usd.setretresult('%'..err) end
		return usd.setretresult('%dirUrl not found')
	end

	local newName = page:match('<span title="([^"]+)"')
	wait = page:match('\'UCanDownloadIn\', "(%d+)"') or 10
	usd.setretresult(dirUrl..'?/'..newName, wait+math.random(1,4),1)
	return
end

regDirSuccess( '//files.mail.ru/', GDL, OS )
regDirSuccess( '@files.mail.ru/', GDL, OS )
--regDirSuccess( '//cloud.mail.ru/', GDL, OS )

