
function GDL(origUrl)
	logpref = script.name..'_GDL_0000'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, form, dirUrl
	script.tmp={}

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	local _ = page:match('class="iframe" src="(.-)"')
	if not _ then return usd.setretresult('%iframe not found') end

	page = usd.get(_)
	debugSaveInc(logpref..'.html', page)
	form = page:match('<form action="getlink/.-</form>')
	if not form then
		err = page:match('/image/design/(%d+).png"')
		if err then
			usd.savetolog('Error: '..err)
			return usd.setretresult('%notfound%')
		end
		return usd.setretresult('%form not found')
	end
	form = Form.parse(form)

	script.tmp.newName = utf8ToAnsi(page):match('<p>: <span>(.-)<')
	dirUrl = URI.combine(usd.getlocation(), form.action)()
	usd.setretresult(dirUrl, math.random(1,4),1, form:getinputs())
	return
end

function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess( 'filetonet.com/', GDL, OS )

