--	http://www.gamefront.com/files/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0002'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if usd.getheaders():find('404 Not Found',1, true) then
		return usd.setretresult('%notfound%')
	end

	local downloadLink = page:match('href="([^"]+)" class="downloadNow" id="downloadLink"')
	if not downloadLink then return usd.setretresult('%downloadLink not found') end
	usd.waittime(math.random(1,7))
	page = usd.get(downloadLink)
	debugSaveInc(logpref..'.html', page)

	dirUrl = page:match("var downloadUrl = '([^']+)';")
	if not dirUrl then return usd.setretresult('%downloadUrl not found') end
	local downloadCount = page:match('var downloadCount = (%d+);') or 5
	usd.setretresult(dirUrl, downloadCount+math.random(1,7),1)
	return
end

regDirSuccess( 'gamefront.com/files/', GDL, OS )

