--  http://www.getzilla.net/files/*

function GDL(origUrl)
    logpref = script.name..'_GDL_0000'
    usd.setstatus(logpref:gsub('_GDL_',' '))
    local page = usd.get(origUrl)
    debugSaveInc(logpref..'.html', page)

    local err = page:match('<div class="caption orange">([^<]+)</div>')
    if err then
        usd.savetolog('Error: '..utf8ToAnsi(err))
        return usd.setretresult('%notfound%')
    end

    local free = page:match('free_download_url: "([^"]+)"')
    if not free then
        return usd.setretresult('%No free download?')
    end
    usd.waittime(math.random(1,7))
    local page = usd.get(free)
    debugSaveInc(logpref..'.html', page)

    local _ = page:match('get_file_url_url: "([^"]+)"')
    if not _ then
        return usd.setretresult('%plugindefect')
    end
    local wait = page:match('var download_wait_time = "(%d+)";') or 5000
    usd.waittime(wait/1000+math.random(1,7))
    local page = usd.get(_)
    debugSaveInc(logpref..'.html', page)

    local dirUrl = page
    usd.setretresult(dirUrl, math.random(1,7),1)
    return
end

regDirSuccess( 'getzilla.net/files/', GDL )

