--	http://www.gigabase.com/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0016'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, err, form, timer, dirUrl
	script.tmp={}

	origUrl = origUrl:gsub('//gigabase.', '//www.gigabase.')
	origUrl = origUrl:match('^(.-BB/)[^/]+%.html') or origUrl
	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	if utf8ToAnsi(page):find('>  <',1, true)
		or page:find('id="content">%s*Page Not Found%s*<') then
		return usd.setretresult('%notfound%')
	end

	if origUrl:find('/folder/',1, true) then
		if not usd.getlocation():find('/folder/',1, true) then
			usd.savetolog('Error: folder not found')
			return usd.setretresult('%notfound%')
		end

		local folder = page:match('<ol(.-)<div class="topFiles">')
		if folder then
			folder:gsub('<li><a href="([^"]+)"[^>]+>(.-)</a>(.-)<br/></li>'
			, function(link, name, size)
				usd.savetolog(' + '..name..size)
				usd.savetolog(link); usd.addquery(link)
			end)
			return usd.setretresult('%done%')
		end
		return usd.setretresult('%Folder is empty?')
	end

	script.tmp.newName = page:match('id="fileName"[^>]+>(.-)<')
		or page:match(':</small><br/>%s*(.-)%s*<small>%(%d+')
	script.tmp.newName = utf8ToAnsi(script.tmp.newName)

	form = page:match('<form [^>]-id="startForm".-</form>')
	if form then
		usd.waittime(math.random(1,5))
		page = Form.parse(form):submit()
		debugSaveInc(logpref..'.html', page)
	end
	form = page:match('<form [^>]+timer".-</form>')
	if form then
		usd.waittime(math.random(1,5))
		page = Form.parse(form):submit()
		debugSaveInc(logpref..'.html', page)
	end

	timer = page:match('var timerRest = (%d+);') or 0
	dirUrl = page:match('<a href="([^"]-%.com/fdload/[^"]+)"')
		or page:match('<a href="([^"]-%.com/dfile/[^"]+)"')
	if dirUrl then return usd.setretresult(dirUrl, timer+math.random(1,5),0) end

	if not dirUrl then
		usd.waittime(math.random(1,5))
		page = usd.get(page:match('<a href="([^"]+/free%?step=[^"]+)"')
			or page:match('<a href="([^"]+/link%?step=[^"]+)"'))
		debugSaveInc(logpref..'.html', page)
		err = page:match('class="ipLimit"[^>]*>%s*(.-)<') or nil
		if err then return usd.setretresult('%'..utf8ToAnsi(err:gsub('%s+',' '))) end

		timer = page:match('var timerRest = (%d+);') or 0
		dirUrl = page:match('<a href="([^"]-%.com/fdload/[^"]+)"')
			or page:match('<a href="([^"]-%.com/dfile/[^"]+)"')
		if dirUrl then return usd.setretresult(dirUrl, timer+math.random(1,5),0) end

		usd.waittime(math.random(1,5))
		page = usd.get(page:match('<a href="([^"]+/link%?step=[^"]+)"'))
		debugSaveInc(logpref..'.html', page)
	end

	timer = page:match('var timerRest = (%d+);') or 0
	dirUrl = page:match('<a href="([^"]-%.com/fdload/[^"]+)"')
		or page:match('<a href="([^"]-%.com/dfile/[^"]+)"')
	if dirUrl then return usd.setretresult(dirUrl, timer+math.random(1,5),0) end

	form = page:match('<form id="stepForm".-</form>')
	if not form then
		err = page:match('class="ipLimit"[^>]*>%s*(.-)<')
			or page:match('<div style="font%-size:[^>]+>%s*(.-)</')
		if err then return usd.setretresult('%'..utf8ToAnsi(err:gsub('<br/>',' '):gsub('%s+',' '))) end
		return usd.setretresult('%stepForm not found')
	end
	form = Form.parse(form)
	usd.setretresult(origUrl..'/next?/'..script.tmp.newName, timer+math.random(1,5),0, form:getinputs())
	return
end


function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess( 'gigabase.com/getfile/', GDL, OS)
regDirSuccess( 'gigabase.com/folder/', GDL, OS)

