--	http://livefile.org/get/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0000'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, err, form, cap4a

	if origUrl == oldOrig and dirUrl then
		page = usd.head(dirUrl)
		debugSaveInc(logpref..'.html', page)
		if page:find('^HTTP/%d%.%d 200 OK')
			and tonumber(page:match('Content%-Length: (%d+)')) > 66666
		then
			usd.savetolog('Trying old direct link...')
			return usd.setretresult(dirUrl, 0,1)
		end
	end
	dirUrl = nil;	oldOrig = origUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	err = page:match('<span style="color:red">(.-)<')
	if err then
		usd.savetolog('Error : '..utf8ToAnsi(err))
		return usd.setretresult('%notfound%')
	end

	local _ = page:match('href="([^"]+/free)"')
	if not _ then return usd.setretresult('%No free download?') end
	usd.waittime(math.random(1,7))
	page = usd.get('http://livefile.org'.._)
	debugSaveInc(logpref..'.html', page)

	err = page:match('<h3 class="red">(.-)<')
	if err then return usd.setretresult('%'..utf8ToAnsi(err)) end
	if usd.getlocation():find('/onlyonefree.shtml',1, true) then
		return usd.setretresult("%We found that you've downloaded another file! Parallel downloading is not supported for free mode.")
	end

	local f, dl, wait, name = page:match("FreeDlWait%('([^']+)','([^']+)','([^']+)'.-'([^']+)'%);")
	usd.waittime(wait+math.random(1,7))
	page = usd.get('http://livefile.org/captcha.php?f='..f..'&dl='..dl..'&name='..name..'&ok=true')
	debugSaveInc(logpref..'.html', page)

	form = page:match('<form action="/get/.-</form>')
	if not form then return usd.setretresult('%form not found') end
	cap4a = 'http://livefile.org'..form:match('src="(/capic[^"]+)"')
	form = Form.parse(form)
	form.action = 'http://livefile.org'..form.action
	form.inputs.cpid = queryCaptcha(cap4a)
	usd.relocationmode(0)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	dirUrl = usd.getheaders():match('Location: (http://stor%d+%.[^/]+/dl/[^%c]+)')
	if page:find('>Captcha Error!<',1, true) then return usd.setretresult("%Wrong captcha") end
	if not dirUrl then return usd.setretresult('%dirUrl not found') end
	usd.setretresult(dirUrl, 0,1)
	return
end

regDirSuccess( 'livefile.org/get/', GDL, OS )

