--	http://nekaka.com/d/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0000'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, wait, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	dirUrl = page:match('href="(http://nekaka.com/files/download/.-)" class="b%-btn')

	if not dirUrl then
		err = page:match('<div class="h1.->(.-)<')
		if err then
			usd.savetolog('Error: '..utf8ToAnsi(err))
			return usd.setretresult('%notfound%')
		end
		return usd.setretresult('%download not found')
	end

	wait = page:match('(%d+);%s*function startCountdown') or 20
	usd.waittime(wait+math.random(1,4))

	usd.relocationmode(0)
	page = usd.get(dirUrl)
	debugSaveInc(logpref..'.html', page)
	dirUrl = usd.getheaders():match('Location: ([^%c]+)', 2)
	if not dirUrl then return usd.setretresult('%dirUrl not found') end

	usd.setretresult(dirUrl, 1,1)
	return
end

regDirSuccess( 'nekaka.com/d/', GDL, OS )

