--	http://www.sharebeast.com/*
--	http://www.aieshare.com/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0003'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, err, form, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	form = page:match('<[Ff]orm name="F1".-</[Ff]orm>')

	if not form then
		if page:find('>File Not Found<',1, true) then
			return usd.setretresult('%notfound%')
		end
		return usd.setretresult('%F1 not found')
	end

	form = Form.parse(form)
	usd.waittime(math.random(1,7))
	usd.relocationmode(0)
	page = usd.post(origUrl, form:getinputs())
	debugSaveInc(logpref..'.html', page)

	err = page:match('class="err">(.-)<')
	if err then return usd.setretresult('%Error: '..err) end

	dirUrl = usd.getheaders():match('Location: ([^%c]+)',2)
	if not dirUrl then return usd.setretresult('%dirUrl not found') end
	usd.setretresult(utf8ToAnsi(dirUrl), 0,1)
	return
end

regDirSuccess( 'sharebeast.com/', GDL, OS )
regDirSuccess( '.aieshare.com/', GDL, OS )
regDirSuccess( '//aieshare.com/', GDL, OS )

