--	http://www.spaceha.com/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0000'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, form, err, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	err = page:match('class="err">(.-)<')
	if err then
		usd.savetolog('Error: '..err)
		return usd.setretresult('%notfound%')
	end

	form = page:match('<Form method="POST">.-</Form>')
	if not form then return usd.setretresult('%No free download?') end
	form = Form.parse(form)
	usd.waittime(math.random(1,7))
	page = form:submit('method_free')
	debugSaveInc(logpref..'.html', page)

	form = page:match('<Form name="F1".-</Form>')
	if not form then return usd.setretresult('%F1 not found') end
	form = Form.parse(form)
	usd.waittime(math.random(1,7))
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	err = page:match('class="err">(.-)<')
	if err then return usd.setretresult('%'..err) end

	dirUrl = page:match('<a href="(http://sv%d+%.spaceha%.com/files/[^"]+)"')
	if not dirUrl then return usd.setretresult('%dirUrl not found') end
	usd.setretresult(dirUrl, math.random(1,7),1)
	return
end

regDirSuccess( '.spaceha.com/', GDL, OS )
regDirSuccess( '//spaceha.com/', GDL, OS )

