--	http://webfile.ru/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0012'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, form, err, wait, dirUrl
	script.tmp={}

	origUrl = origUrl:gsub('//webfile%.', '//files.webfile.')

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	local _ = page:match('location%.href="(http://[^"]+)"')
	if _ then
		usd.setcookie(page:match('cookie="([^"]+)"'))
		page = usd.get(_)
		debugSaveInc(logpref..'.html', page)
	end

	err = page:match('<br><h2 align="center">([^<]+)<')
		or page:match('<p><span>([^<]+)</span></p>')
	if err then
		usd.savetolog('Error: '..utf8ToAnsi(err))
		return usd.setretresult('%notfound%')
	end

	form = page:match('<input type="hidden" name="id"[^>]*>')
	if form then form = Form.parse('<form>'..form..'</form>') end

	if page:find("<input id='file_password'",1, true) then
		local default = usd.getoption(script.name,'Default', '')
		local dlg = Dialog.new( {
			{ ' :   '..origUrl }
			, { ' :', {name='password', type='password', default} }
			}, script.name)
		form.inputs.pwd = dlg:show():match("password=(.-)\010")
		usd.waittime(math.random(3,9))
		page = usd.get('/adownload?'..form:getinputs()..'&rand='..math.floor(1000000000*math.random()))
		debugSaveInc(logpref..'.html', page)
	end

	dirUrl = page:match('http://file%d+%.webfile[^"\']+')
		or page:match('<a href="(/download/[^"\']+)')
		or page:match('action="(/download/[^"\']+)')
	if not dirUrl then
		err = page:match('"error" : "([^"]+)"')
		if err then return usd.setretresult('%Error: '..err) end
		return usd.setretresult('%dirUrl not found')
	end
	if not dirUrl:find('^http://') then dirUrl = 'http://'..getHost(origUrl)..dirUrl end

	wait = page:match('id="pre_download_sec"[^>]*>(%d+)<') or 0
	usd.waittime(wait+math.random(1,4))

	script.tmp = getLstInfo()
	script.tmp.newName = utf8ToAnsi(page):match('<p>([^<]+) <span>%([%d%.,]+ ')
	local name = script.tmp.saveto..script.tmp.newName
	page = usd.get(dirUrl..'|'..name)
	debugSaveInc(logpref..'.html', page)

	if page == 'Done' then return usd.setretresult('%done%') end
	return usd.setretresult('%'..page)
end


regDirSuccess( '.webfile.ru/', GDL, OS )
regDirSuccess( '//webfile.ru/', GDL, OS )
regDirSuccess( '@webfile.ru/', GDL, OS )

