--	http://www.westfiles.com/files/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0000'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, err, form, wait, cap4a, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	err = page:match('class="bold center red">(.-)<')
	if err then
		usd.savetolog('Error: '..utf8ToAnsi(err))
		return usd.setretresult('%notfound%')
	end

	usd.waittime(math.random(1,7))
	page = usd.get(origUrl..'#')
	debugSaveInc(logpref..'.html', page)
	form = page:match('<form action="" method="post" class="captcha.-</form>')
	if not form then return usd.setretresult('%No free download?') end
	cap4a = form:match('src="(/kcaptcha/[^"]+)"')
	form = Form.parse(form)
	form.inputs.keystring = queryCaptcha(cap4a)
	if form.action == '' then form.action = origUrl..'#' end
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	local _ = page:match('<a href="(/files/[^"]+)"')
	if not _ then
		err = page:match('class="alert_info[^>]*>(.-)<')
		if err then return usd.setretresult('%'..utf8ToAnsi(err)) end
		return usd.setretresult('%download not found')
	end

	wait = page:match('id="timer">(%d+)<') or 60
	usd.waittime(wait+math.random(1,7))
	usd.relocationmode(0)
	page = usd.get('http://www.westfiles.com'.._)
	debugSaveInc(logpref..'.html', page)

	dirUrl = usd.getheaders():match('Location: ([^%c]+)',2)
	if not dirUrl then
		err = page:match('class="alert_info[^>]*>(.-)</')
		if err then return usd.setretresult('%'..utf8ToAnsi(err)) end
		return usd.setretresult('%dirUrl not found')
	end
	usd.setretresult(dirUrl, 0,1)
	return
end

regDirSuccess( 'westfiles.com/files/', GDL, OS )

