
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v04'
	usd.setstatus(script.name)
	local dirUrl, page, form

	usd.setcookie('language_selection=EN')

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('<h1>Error - File not available</h1>',1,true) then
		usd.setretresult('%notfound%')
		return
	end

	local newName =	page:match('class="addthis.-</td>%s*<td><input type="text" value="[^"]-/([^/"]-)%.html"')
		or page:match('<title>(.-) %- BitShare%.com %-')
		or 'name'..os.time()
	newName = newName:gsub('^Download ',''):gsub('^Listen to ',''):gsub('^Streaming ','')
	newName = filterName(utf8ToAnsi(newName))

	local tmp = page:match("jwplayer%('[^']+'%)%.setup%({.-}%);") or ''
	local audio = tmp:match("'file': '(http://[^']+)',")

	if audio then
		usd.relocationmode(0)
		usd.head(audio)
		local dirUrl = usd.getheaders():match('%sLocation: (%S+)')
		if dirUrl then
			dirUrl = addNewName(dirUrl, newName)
			usd.setretresult(dirUrl,math.random(2,4),1)
			return
		end
	end



	local err

	err = page:match('<div class="quotbox_red".-</div>')
	if err then
		err = err:gsub('<[^>]+>',' '):gsub('%s+',' ')
		usd.setretresult('%'..err)
		return
	end

	local wait = page:match('<span id="blocktimecounter">(%d+) seconds</span>')
	if wait then
		usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
		return
	end

	usd.waittime(2, 2)

	--local wait = page:match('var%s+time%s*=%s*(%d+);')
	local key = page:match('/challenge%?k=([^"]+)') or "6LdtjrwSAAAAACepq37DE6GDMp1TxvdbW5ui0rdE"
	local ajaxid = page:match('var%s+ajaxdl%s*=%s*"([^"]+)"')

	local form = [[<form method="POST"> <input name="request" value="generateID"> </form>]]
	form = Form.parse(form)
	form.action = page:match('function goToDownloadUrl%(%).-%surl:%s*"([^"]+)"')
	form.inputs.ajaxid = ajaxid
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

-- file:60:1
-- ERROR#SESSIOR 2 ERROR!

	local filetype, waitingtime, captcha = page:match('^(%w+):(%d+):(%d+)$')
	captcha = captcha~='0'

	usd.waittime(waitingtime)

	if captcha then
		--for i=1, captchaAttempts do
			form.inputs.request = 'validateCaptcha'
			form.inputs.recaptcha_response_field
				, _, form.inputs.recaptcha_challenge_field
					= queryReCaptcha(key, 0, nil, nil, nil, true)
			page = form:submit()
			debugSaveInc(logpref..'.html', page)
			--if page == 'SUCCESS' then break end
-- SUCCESS
		--end
	end

	form.inputs = {request = 'getDownloadURL', ajaxid = ajaxid}
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

--SUCCESS#http://
--ERROR#Sorry, you cant download more then 1 files at time. <b>Upgrade to Premium</b>

	dirUrl = page:match('SUCCESS#(http%S+)')

	if not dirUrl then
		err = page:match('^ERROR#(.+)$') or page
		usd.setretresult('%'..err)
		return
	end

	dirUrl = addNewName(dirUrl, newName)
	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, newName))
--end


regDirSuccess( '//bitshare.com/', GDL, OS)
regDirSuccess( '.bitshare.com/', GDL, OS)
