
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings[script.name] or { qualityList = {"mp4_720_2600", "mp4_480_2000", "mp4_480_1500", "default"} }
	debugLog(serialize(conf,nil,nil,true))

	page = shitCapsula(origUrl)
	local data = parseJsObject(page:match('var%s+videoUiInfoObject%s*=%s*{.-</script>'))
	debugSaveInc(logpref..'.html', page, serialize(data or "<nil>",nil,true))

	script.tmp.newName = filterName(trim(utf8ToAnsi(page:match('<h1 itemprop="name">.-</h1>'):gsub('<[^>]->',' '))), true)

	local urls = data.player.stream_info.http.paths
	local quality
	for k, v in ipairs(conf.qualityList) do
		if urls[v] then
			quality = v
			break
		end
	end
	if not quality then
		quality = next(urls)
		debugLog('No suitable quality')
	end
	debugLog('quality: '..quality)

	dirUrl = urls[quality]

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end


regDirSuccess( '.brazzers.com/scenes/view/', GDL, OS)
