
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local conf = Settings and Settings[script.name] or {
		direct = false
	}

	uri = URI.parse(origUrl)

	local id = uri.path:match('^/(%w%w+)')
		or uri.path:match('^/s/(%w%w+)')
		or (uri.fragment and uri.fragment:match('^s/(%w%w+)'))

	if conf.direct then
		usd.setreferer('http://copy.com/')
		setHeader('Accept: */*')
		usd.setretresult('http://copy.com/'..id, math.random(2,4), 1)
		return
	end

	--local headers = {"X-Client-Type: API", "X-Api-Version: 1.0"}
	local headers = {"X-Client-Version: 1.0.00", "X-Client-Type: API", "X-Api-Version: 1.0"}

	for k, v in ipairs(headers) do  setHeader(v)  end

    page = usd.get('http://www.copy.com/api/rest/meta/s/'..id, headers)
    local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))

	for k, v in ipairs(headers) do  setHeader(v, true)  end

	script.tmp={}

	script.tmp.newName = utf8ToAnsi(data.children[1].name)

	dirUrl = data.children[1].url:gsub('^https:','http:')

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess( '//copy.com/', GDL, OS)
