
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	uri = URI.parse(origUrl)

	local id = uri.path:match('/(%d+)')

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<h3>(You have to wait[^<]+)')
	if err then
		err = err:gsub('<[^>]+>',' ')
		local h = err:match('%s(%d+) hour') or 0
		local m = err:match('%s(%d+) minute') or 0
		local s = err:match('%s(%d+) second') or 0
		local count = (h*60+m)*60+s
		if count == 0 then
			usd.setretresult('%'..err)
			return
		end
		usd.setretresult('%Server report: You need wait ' .. count .. ' seconds')
		return
	end


	script.tmp={}
	usd.waittime(2, 2)

	local wait = page:match('<span class="wseconds">(%d+)</span>')

	setXHR()
	page = usd.get('http://fileover.net/ax/timereq.flo?'..id)
	debugSaveInc(logpref..'.html', page)
	local hash=page:match('"hash":"([^"]+)"')

	usd.waittime(wait)

	setXHR()
	page = usd.get('http://fileover.net/ax/timepoll.flo?file='..id..'&hash='..hash)
	debugSaveInc(logpref..'.html', page)

	form = page:match('<form.-</form>')
	local key = form:match('/challenge%?k=([^"%s]+)')
	form = Form.parse(form)
	form.action = uri(form.action)()
	form.inputs.recaptcha_response_field
		, timeout
		, form.inputs.recaptcha_challenge_field
		= queryReCaptcha(key, 0, nil, nil, nil, true) -- gooCheck
	setXHR()
	page = form:submit()
	debugSaveInc(logpref..'.html', page)
	setXHR(true)

	dirUrl = page:match('<a href="([^"]+)">Click here to Download</a>')

	usd.setreferer(origUrl)

	usd.setretresult(dirUrl, math.random(2,4), 0)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '//fileover.net/', GDL, OS)
