
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	uri = URI.parse(origUrl)
	local id = uri.fragment or uri.path:match('/(.+)$')

	usd.get('http://0.0.0.0/headers')

	usd.setreferer(origUrl)

	page = usd.post('https://filetea.me/transport/handshake','%simple%{"mechanisms":["long-polling"],"url":"/transport/"}')
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
	local peerId, murl = data["peer-id"], data.mechanisms[1].url

	page = usd.post(murl..'/send?'..peerId, '%simple%N{"method":"getFileSourceInfo","params":["'..id..'"],"id":"1"}')
	data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))

	if data.error then return usd.setretresult('%'..(data.error.code==1 and 'notfound%' or data.error.message))	end

	dirUrl = 'http://filetea.me/'..id..'/dl?'..peerId
	dirUrl = addNewName(dirUrl, data.result[1])

	usd.setretresult(dirUrl, math.random(2,4), 1) -- no resume getResumeFlag(nil, true)
end

--function OS(origUrl, dirUrl, fullName, headers)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
--end


regDirSuccess( '//filetea.me/', GDL, OS)
