
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	script.tmp={}
	local dirUrl

	local ips = plg.resolve('dl.free.fr')
	debugLog('ips = '..serialize(ips))
	local ip = ips[math.random(#ips)]

	local uri = URI.parse(origUrl)
	uri.host = ip

	usd.relocationmode(0)
	local page = usd.get(uri())
	debugSaveInc(logpref..'.html', page)

	local tmp = parseHeaders().LOCATION1
	if tmp then
		uri = URI.parse(tmp)
		uri.host = ip
		page = usd.get(uri())
		debugSaveInc(logpref..'.html', page)
	end

	if page:find('>Fichier inexistant.</h1>') then
		return usd.setretresult('%notfound%')
	end

	script.tmp.newName = filterUtf8(page:match('>Fichier</span>([^<]-) <'))

	usd.waittime(16, 4)

	local id = page:match('name="file" value="([^"]+)"')
	page = usd.post('/_getfile.pl','%simple%file='..id)
	debugSaveInc(logpref..'.html', page)

	uri = URI.parse(parseHeaders().LOCATION1)
	uri.host = ip

	usd.setretresult(uri(), math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( '//dl.free.fr/', GDL, OS)
