
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}
	usd.waittime(2, 2)

	form = page:match( '<form[^>]-name="frm_download".-</form>' )
	form = Form.parse(form)
	form.action = usd.getlocation()
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	local function DMYHM(dd,mm,yyyy,hh,mi)
		if not yyyy then return end
		local months = {Jan=1, Feb=2, Mar=3, Apr=4, May=5, Jun=6, Jul=7, Aug=8, Sep=9, Oct=10, Nov=11, Dec=12}
		return os.time({year=yyyy, month=months[mm] or mm, day=dd, hour=hh, min=mi})
	end

	local err = page:match('<ul class="message%-error">%s*<li>(.-)</li>%s*</ul>')
	if err then
		err = utf8ToAnsi(err)
		local wait = DMYHM(err:match(':  (%d%d)/(%d%d)/(%d%d%d%d) (%d%d):(%d%d)$'))
		if wait then
			local srvtime = DMYHM(usd.getheaders():match('%sDate: %w%w%w, (%d%d) (%w%w%w?) (%d%d%d%d) (%d%d):(%d%d):%d%d GMT'))
			wait = wait - srvtime - 7*60*60 + 60 -- -7h +1m
			usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
			return
		end
		usd.setretresult('%'..err)
		return
	end

	local wait = page:match('var count = (%d+);')
	usd.waittime(wait)

	dirUrl = page:match('<form action="(http://download%d+%.fshare%.vn/download/.-)#download"')


	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '.fshare.vn/file/', GDL, OS)
