
function GDL(origUrl, params) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	params = params or {}
	local conf = Settings[script.name] or {	maxGifSize = 128*1024 }
	debugLog(serialize(conf,nil,nil,true))

	local id = origUrl:match('%.giphy%.com/media/([^/]+)/')
	if id then origUrl = 'http://giphy.com/gifs/'..id end

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if id then usd.modquery(usd.getlocation()) end

	local gif = page:match('data%-image_url="([^"]+)"'):gsub('^https:','http:')
	local mp4 = page:match('data%-mp4_url="([^"]+)"'):gsub('^https:','http:')
	local newName = filterUtf8(page:match('socialShareTitle="([^"]+)"'))

	debugSaveInc(logpref..'.html', usd.head(gif))
	local gifSize = parseHeaders().SIZE
	debugSaveInc(logpref..'.html', usd.head(mp4))
	local mp4Size = parseHeaders().SIZE

	dirUrl = gifSize>conf.maxGifSize and mp4Size<gifSize and mp4 or gif
	dirUrl = addNewName(dirUrl, params.newName or newName, nil, nil, -1)

	usd.setretresult(dirUrl, math.random(2,4), 1)
end

--function OS(origUrl, dirUrl, fullName, headers)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
--end


regDirSuccess( {'//giphy.com/','.giphy.com/','//gph.is/'}, GDL, OS)
