
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v07'
	usd.setstatus(script.name)

	local conf = Settings and Settings[script.name:gsub('_v%d+$','')]
		or { interactive = false, remember = false }

	local tmp = Settings['<misc>'].crutchHttp or 'http://www.google.com/about/'
	usd.get(tmp)
	usd.get(tmp)
	usd.setreferer('')
	usd.setcookie('')

	origUrl = origUrl:match('^([^#]+)')

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local function checkShit()
		if page:find('tracktrk%.net')
			or page:find('illivid')
			or page:find('/go34down.com/')
			or page:find('//allbestnew.com/')
			or page:find('//applicationgrabb.net/')
			then
			local msg = getHost(usd.getlocation())..': Trojan accelerator detected!'
			usd.setstatus(msg)
			usd.savetolog(msg)
		end
	end
	checkShit()

	--The file you tryed to download does not exist or has been removed due to copyright infringement.
	local err = page:match('<div id="main">%s*<!%-%- content of main %-%->%s*<div class="content">%s*<br /><center><b>(.-)</b>')
	if err then
		usd.savetolog(err)
		if err:find('does not exist') then
			usd.setretresult('%notfound%')
		end
		return
	end

	script.tmp={}
	usd.waittime(2,2)

-----------------
	local name, size = page:match( '<center><h3%s*>([^<]-) %(([^)]+)%)<' )

	setXHR()
	page = usd.get(page:match('url:%s*"(/download/gethosts/[^"]+)"'))
	setXHR(true)
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
	checkShit()

	local mirrors = {}
-----------------
	usd.relocationmode(0)
	for k,v in ipairs(data) do
		local url = (v.link or ''):match('>(http:[^<]+)<')
		usd.waittime(1)
		if url and not (url:find('tracktrk') or url:find('/premium')) then
			url = trim(url)
			local tmp = usd.get(url)
			debugSaveInc(logpref..'.html', tmp)
			if not tmp:find('>%s*Error link not available%s*<') then
				url = tmp:match('id="linklist">.-<a href="([^"]+)"')
					or usd.getheaders():match('%s[Ll]ocation: ([^\r\n]+)')
				table.insert(mirrors, trim(url))
			end
		end
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..(name or '<noname>')}, {'Size: '..(size or'<nosize>')} }
	local status, _ = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows=info})
	if status then
		script.tmp.mirror = _
	end

end

regDirSuccess( '//go4up.com/', GDL, OS)	-- '//go4up.com/dl/',  '//go4up.com/link.php'
