
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v05'
	usd.setstatus(script.name)
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('<big>File%s*Not Found')
		or page:find('<font class="err">No such user exist</font>')
		or usd.getheaders():find('HTTP/%d%.%d 404')
		then
		usd.setretresult('%notfound%')
		return
	end

	usd.waittime(2, 2)

	local form = page:match('<Form name="F1".-</Form>')
	form = Form.parse(form)
	page = form:submit(nil, math.random(100), math.random(15))
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2, 2)

	form = page:match('<FORM METHOD="LINK".-</FORM>')
	if form then
		form = Form.parse(form)
		usd.setretresult(form.action..'?'..form:getinputs(), math.random(2,4), 1)
		return
	end

	form = page:match('<FORM name="F1".-</FORM>')
	form = Form.parse(form)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	local wait, dirUrl = page:match('<meta http%-equiv="refresh" content="(%d+);url=(http[^"]+)"')
	wait = wait or math.random(5,10)
	dirUrl = dirUrl or page:match('http://www%d+%.jumbofiles%.com[:%d]*/d/[^"\'%s]+')

	local tmp = usd.head(dirUrl)
	debugSaveInc(logpref..'.html', tmp)
	if not tmp:find('HTTP/1.1 200 OK') then
		return usd.setretresult('%HEAD error')
	end

	usd.setretresult(dirUrl, wait, 1)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, newName))
--end


regDirSuccess( 'jumbofiles.com/', GDL, OS)
