
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl

	local p1 = '^([^#]+)#(.-)$'
	local tmp1, tmp2 = origUrl:match(p1)
	origUrl = tmp1 or origUrl
	local itemNum, itemName = (tmp2 or ''):match(p1)

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	dirUrl = page:match('<a[^>]-"btn%-action btn%-download[^>]-href="(.-)"')
	if dirUrl then
		debugSaveInc(logpref..'.html', usd.head(dirUrl))
		usd.setretresult(usd.getlocation(), 0, 1)
		return
	end

	local data = page:match('var gallerydata = ({.-});%s*var gallery')
	data = parseJsObject(data)
	debugSaveInc(logpref..'.html', serialize(data, nil, true), nil, false)

	script.tmp={}

	if itemNum then
		local v = data.items[tonumber(itemNum)]
		dirUrl = 'http://i.minus.com' .. v.secure_prefix .. '/d' .. v.id .. '/' .. escapeUC(v.name)
		debugSaveInc(logpref..'.html', usd.head(dirUrl))
		usd.setretresult(usd.getlocation(), 0, 1)
		return
	end

	for k, v in ipairs(data.items) do
		local item = origUrl .. '#' .. k .. '#' .. v.name:gsub('[%s\'"]+','_')
		debugLog(item)
		usd.addquery(item)
		usd.setretresult('%done%')
	end
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '//minus.com/', GDL, OS)
