
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	uri = URI.parse(origUrl)
	origUrl = uri()

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2, 2)

	local aid = origUrl:match('/album/(%d+)')
	local tid = origUrl:match('/album/%d+/track/(%d+)')
	local ref = usd.getlocation()

	if aid and not tid then
		page = usd.get('http://music.yandex.ru/api/v2.0/handlers/album/'..aid..'?external-domain=music.yandex.ru&overembed=no&__t='..os.time()..math.random(100,999))
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
		for k, v in ipairs(data.volumes[1]) do
			usd.addquery(('https://music.yandex.ru/album/%s/track/%s#%s'):format(aid, v.id, filterUtf8(v.title)))
		end
		usd.setretresult('%done%')
		return
	end

	usd.setreferer(ref)
	setXHR()
	page = usd.get(('http://music.yandex.ru/api/v2.0/handlers/tracks?tracks[]=%s:%s&external-domain=music.yandex.ru&overembed=no&__t=%s%s'):format(tid,aid,os.time(),math.random(100,999)))
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))

	script.tmp.newName = filterName(utf8ToAnsi(data[1].artists[1].name..'-'..data[1].title),true)

	usd.waittime(2,2)

	usd.setreferer(ref)
	setXHR()
	page = usd.get(('http://music.yandex.ru/api/v2.0/handlers/track/%s:%s/download?external-domain=music.yandex.ru&overembed=no&__t=%s%s'):format(tid,aid,os.time(),math.random(100,999)))
	data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))

	usd.setreferer(ref)
	setXHR()
	page = usd.get((data.src:gsub('^https:','http:')))
	data = {}
	for k, v in page:match('<download%-info>(.-)</download%-info>'):gmatch('<([^>]+)>([^<]+)</%1>') do data[k]=v end
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))

	setXHR(true)

	function makeHash(str)
		local md5 = ltn12ce.digest('md5')
		md5:update('XGRlBW9FXlekgbPrRHuSiA'..str)
		return (md5:finish():gsub('.',function(b) return bit.tohex(b:byte(),2)end))
	end

	dirUrl = ('http://%s/get-mp3/%s/%s%s?track-id=%s&play=false'):format(data.host, makeHash(data.path:sub(2)..data.s), data.ts, data.path, tid )

	usd.setretresult(dirUrl, 1, 1)
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, '.mp3'))
end


regDirSuccess( '//music.yandex.ru/', GDL, OS)
