
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form

	--page = usd.get(origUrl)
	page = shitFlare(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('<div class="name">File Not Found</div>') or page:find('<p>This file can only be downloaded by Premium Members</p>')
	then return usd.setretresult('%notfound%') end

	if page:find('520: Web server is returning an unknown error</title>') then return usd.setretresult('%Bad User-Agent?') end

	local checkError = function(str)
		local err = str:match('<div class="alert alert%-warning.->(.-)</div>')
		if err then
			err = err:gsub('<[^>]+>',' '):gsub('^%s*(.-)%s*$','%1'):gsub('%s%s+',' ')
			local h = err:match('%s(%d+) hour') or 0
			local m = err:match('%s(%d+) minute') or 0
			local s = err:match('%s(%d+) second') or 0
			local count = (h*60+m)*60+s
			if count == 0 then
				usd.setretresult('%'..err)
				return true
			end
			usd.setretresult('%Server report: You need wait ' .. count .. ' seconds')
			return true
		end
	end

	if checkError(page) then return end

	script.tmp={}
	usd.waittime(2, 2)

	local form = page:match( '<form [^<]- name="F22">.-</form>' )
	form = Form.parse(form)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	if checkError(page) then return end

	local wait = page:match('<span id="count".->(%d+)</span>')
	usd.waittime(wait+2,2)

	local key = page:match('challenge%?k=(.-)"')

	form = page:match('<form[^>]-name="F1">.-</form>')
	form = Form.parse(form)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	if checkError(page) then return end

--<div class="alert alert-success-invert">
	dirUrl = (page:match('href="(http://s%d+%.novafile%.com/[^"]+)"'):gsub('%s','_'))

	usd.setretresult(dirUrl, math.random(2,4), 0)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '//novafile.com/', GDL, OS)
