
local tmpDir
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	tmpDir = tmpDir or {}

	local video = tonumber(origUrl:match('#%[(%d+)%]'))
	origUrl = origUrl:match('^[^#]+')

	if video and tmpDir[origUrl] then
		debugSaveInc(logpref..'.html', serialize(tmpDir[origUrl],nil,true),nil,false)
		local dir = tmpDir[origUrl][video]
		debugSaveInc(logpref..'.html', usd.head(dir))
		local h = parseHeaders()
		local lst = getLstInfo()
		if (h.SIZE or -1)>1024*1024 and (lst.size==0 or lst.size==h.SIZE) then
			return usd.setretresult(dir,1,1)
		end
	end

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local flashvars = page:match('name="flashvars" value="([^"]+)')
	flashvars = entityDecode(flashvars)
	flashvars = splitKV(flashvars,'=','&',function(t,i,v) t[unescape(i)]=unescape(v) return t end)

	local keys = {a='05uw6nHoBpNMDRzGVei3mWU7g=',b='cTI4QZvYyXkb8aJd1xLtl2fs9h'}

	if flashvars.file then return usd.setretresult(uppodDecode(flashvars.file, keys), math.random(2,4), 1) end

	page = usd.get(uppodDecode(flashvars.pl, keys))
	debugSaveInc(logpref..'.html', page)

	local data = parseJsObject(uppodDecode(page,keys))
	debugSaveInc(logpref..'.html', serialize(data or '<nil>',nil,true),nil,false)

	tmpDir[origUrl] = {}
	for k, v in ipairs(data.playlist) do
		if v.playlist then
			for kk, vv in ipairs(v.playlist) do
				table.insert(tmpDir[origUrl], uppodDecode(vv.file,keys))
				if not video then usd.addquery(origUrl..'#['..#tmpDir[origUrl]..']-'..filterName(utf8ToAnsi(vv.comment or ''),true)) end
			end
		else
			table.insert(tmpDir[origUrl], uppodDecode(v.file,keys))
			if not video then usd.addquery(origUrl..'#['..#tmpDir[origUrl]..']-'..filterName(utf8ToAnsi(v.comment or ''),true)) end
		end
	end

	if video then return usd.setretresult(tmpDir[origUrl][video],1,1) end

	usd.setretresult('%done%')

end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
--end


regDirSuccess( '//serialu.net/', GDL, OS)
--  regDirSuccess( '.igru-film.net/', GDL, OS)
