
function GDL(origUrl) 	-- GetDirectLink
	usd.setstatus('')
	logpref = script.name .. '_GDL_v01'
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('<br />The selected file was not found.</div>',1,true) then
		return usd.setretresult('%notfound%')
	end

	if page:find('<div class="error">',1,true) then
		local e1, e2 = page:math('<div class="error"><b>([^<]+)</b><br /><div class="error center">([^<]+)</div>')
		e1 = e1 or 'unknown error'
		e2 = e2 or 'unknown error'
		usd.setstatus(e1)
		usd.savetolog(e1)
		usd.savetolog(e2)

		--local wait = e2:match('Please wait more (%d+) minutes')
		--if wait then e1 = 'Server report: You need wait ' .. wait*60 .. ' seconds' end

		usd.setretresult('%'..e1)
		return
	end

	local wait = page:match('var downloadWait = (%d+);')
	usd.waittime(wait + math.random(3))

	local form = page:match('(<form name="download".-</form>)')
	form = Form.parse(form)

	usd.setretresult( form.action..'|1|1|'..form:getinputs() )
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	usd.setretresult(newName)
--	return
--end


regDirSuccess( '.shragle.com/files/', GDL, OS)
