
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	Storage[script.name] = Storage[script.name] or {}
	local st = Storage[script.name]

	local conf = tableCombine({useProxomitron=false, checkRecaptcha=true, freeDelay=60*60}, Settings[script.name] or {})

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<div class="icon_err">%s*<h1>([^<]+)')
	if err then
		if err=='This file is no longer available.' then err = 'deleted%' end
		return usd.setretresult('%'..err)
	end

	script.tmp={}
	usd.waittime(2, 2)

	local url = usd.getlocation()
	local data = {post='%simple%downloadLink=wait', referer=url, headers='X-Requested-With: XMLHttpRequest', https=conf.useProxomitron and 'Proxomitron' or true}
	page = urlGet(url, data)
	debugSaveInc(logpref..'.html', page, 'wait')

	local wait = page:match('"waitTime":(%d+)')

	data.post = '%simple%checkDownload=check'
	page = urlGet(url, data)
	debugSaveInc(logpref..'.html', page, 'check')
	local err = page:match('"fail":"([^"]+)"')
	if err then
		data.post='%simple%checkDownload=showError&errorType='..err
		page = urlGet(url, data)
		debugSaveInc(logpref..'.html', page, 'showError')
		if err=="timeLimit" and conf.freeDelay then
			local lastDownload = st.lastDownload or 0
			local wait = (lastDownload+conf.freeDelay) - os.time()
			usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
			return
		end
		usd.setretresult('%'..err)
		return
	end

	usd.waittime(wait)

	form = Form.make{
		action = (conf.useProxomitron and 'http://https..' or 'https://').."www.uploadable.ch/checkReCaptcha.php"
		, method='POST'
		, inputs={recaptcha_shortencode_field=origUrl:match('/file/(%w+)')}
		, referer=url
	}
	queryReCaptcha({key='6LdlJuwSAAAAAPJbPIoUhyqOJd7-yrah5Nhim5S3', form=form, check=conf.checkRecaptcha, reload=true})
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	if not page:find('"success":1') then return usd.setretresult('%captcha error?') end

	data.post = '%simple%downloadLink=show'
	page = urlGet(url, data)
	debugSaveInc(logpref..'.html', page, 'show')

	usd.waittime(2,2)

	usd.relocationmode(0)
	usd.setreferer(url)
	if conf.useProxomitron then url = url:gsub('^https://', 'http://https..') end
	page = usd.post(url,'%simple%download=normal')
	debugSaveInc(logpref..'.html', page, 'normal')
	dirUrl = usd.getheaders():match('%sLocation: (http://[^\r\n]+)')
	usd.setretresult(dirUrl, 1, 1)

	if conf.freeDelay then st.lastDownload = os.time() end

	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '.uploadable.ch/file/', GDL, OS)
regDirSuccess( '//uploadable.ch/file/', GDL, OS)
