
function GDL(origUrl) 	-- GetDirectLink
	usd.setstatus(script.name)
	local logpref = script.name .. '_GDL_v09'
	local dirUrl
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<div class="error_content.-<div class="content_column">(.-)</div>')
	if err then
		err = utf8ToAnsi(err)
		if err:find('>   <')
			or err:find('>OOPS! Looks like file not found.<')
			then
			usd.setretresult('%notfound%')
			return
		end
		err = err:gsub('<[^>]+>',' '):gsub('^%s*(.-)%s*$', '%1'):gsub('%s+', ' ')
		usd.setretresult('%'..err)
		return
	end

	if page:find('="force_exe"') or page:find('[./%s]ncdownloader%.com')	then
		local msg = getHost(usd.getlocation())..': Trojan accelerator detected!'
		usd.setstatus(msg)
		usd.savetolog(msg)
	end

	usd.waittime(2, 2)

	local code = page:match('%Wcode:%s*"(%w+)"')

	local cn, cv = page:match("cookie.set%('([^']+)'%s*,%s*'([^']+)'")
	local f = cn .. '=' .. cv ..'; '
	usd.setcookie(f .. usd.getcookie(), 1)

	local wait = page:match('"timer_count">(%d+)<') or 60
	local form = Form.make { action = '/files/get/?ajax', method='post', inputs = {code = code, action='second_page'} }

	setXHR()
	page = form:submit()
	debugSaveInc(logpref..'.html', page)
	local tmp = parseJsObject(page)

	usd.waittime((tmp and tmp.answer and tmp.answer.wait_time) or wait)

	--page = usd.post('/files/get/?ajax', '%simple%action=get_link\ncode='..code..'\npass=')
	form.inputs.action = 'get_link'
	form.inputs.pass = 'false'
	form.inputs.force_exe=0
	setXHR()
	page = form:submit()
	debugSaveInc(logpref..'.html', page)
	setXHR(true)

	dirUrl = page:match('"link":"([^"]+)"'):gsub('\\','')

	if dirUrl:find('uploading.com/files/get2/') then
		page = usd.get(dirUrl)
		debugSaveInc(logpref..'.html', page)
		dirUrl = page:match("href='([^']+)'")
	end

	if dirUrl:find('uploading.com/files/thankyou/') then
		page = usd.get(dirUrl)
		debugSaveInc(logpref..'.html', page)
		dirUrl = page:match('http://fs%d+.uploading.com/get_file/[^%s\'"]+')
	end

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return

end

regDirSuccess('//uploading.com/files/', GDL)
