--GDL

local hostsData = {}	-- a, b, hash, getName, getVideo
local external = tableKeys('youtu.be', 'youtube.com')

logpref = script.name .. '_GDL_v01'
function GDL(origUrl) 	-- GetDirectLink
	usd.setstatus(script.name .. ': ' .. getHost(origUrl) )
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2, 2)

	local data
	for k, v in pairs(hostsData) do if origUrl:find(k) then data=v break end end

	video = data:getVideo(page)
	video = uppodDecode(video, data)

	if external[getHost(video)] then
		usd.modquery(video)
		return usd.setretresult('%Restarting...', 5)
	end

	script.tmp.newName = data:getName(page)

	dirUrl = video

	--if data.nn then dirUrl = addNewName(dirUrl, script.tmp.newName) end

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

local default = { __index = {
	getName = function(self, page)
		local tmp = page:match('<meta property="og:title" content="([^"]+)"')
		if not tmp then return end
		tmp = entityDecode(tmp)
		if page:lower():find('content="text/html;%s*charset=utf%-8"') then tmp = utf8ToAnsi(tmp) end
		return tmp
	end
    , getVideo = function(self, page)
    	local tmp = page:match('=%s*new%s*Uppod%s*%(%s*({.-</script>)')
    		or page:match('var%s*flashvars%s*=%s*({.-</script>)')
		tmp = parseJsObject(tmp or '')
		if not tmp then
			tmp = page:match('flashvars="([^"]+)"')
			tmp = splitKV(tmp,'=','&')
		end
		return tmp.file
    end

}}

local function reg(rds, data)
	regDirSuccess( rds, GDL, OS)
	hostsData[rds] = data or {}
	setmetatable(hostsData[rds], default)
end

reg('//kinostok.tv/video/', {a="YWyzpnxMu90Ltwk2GUQBsV81g=",b="Ddaf4bI7i6XeRNZ3ToJcHmlv5E"})
reg('//video.elremont.ru/')
reg('//clipiki.ru/video/')
reg('nomobile.ru/media/', {a="H5Z4kLIQGzXeDwoVM81Ycvu26=", b="mip9aWyxRl3b7tUBT0ndNsJgfh"
	, getVideo=function(self, page)
		local tmp = page:match('&file=(%%2Fmedia%%2F[^%s&"]+)')
		tmp = unescape(tmp)
		return URI.combine(usd.getlocation(), tmp)()
	end
})
