
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings and Settings[script.name]
		or { interactive = false, remember = false }
	debugLog(serialize(conf,nil,nil,true))

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<font class="err">([^<]+)</font>')--directmirror.com
	if err then
		err = err:lower()
		if err=='file not found' then err = 'notfound%' end
		return usd.setretresult('%'..err)
	end

	origUrl = usd.getlocation()
	uri = URI.parse(origUrl)

	usd.waittime(2,2)

-----------------
--[[
<tr><td><b>File:</b> <a href='http://www.uploadmagnet.com/xqwnsbh9uf1j/cmd.zip'>cmd.zip</a></td>
<tr><td><b>Size:</b> 100.09 KB</td><td></td></tr>

<tr><td><b>File:</b> <a href='http://multi.hotshare.biz/rqow7fuk7s55'>cmd.zip</a></td>
<tr><td><b>Size:</b> 100.09 KB</td><td></td></tr>

]]
	local name, size = page:match( "<tr>%s*<td[^>]*>%s*<b>File:</b>.-<a[^>]+>([^>]+)</a>.-<tr>%s*<td>%s*<b>Size:</b>(.-)</tr>" )
	size = trim((size:gsub('<[^>]*>',''):gsub('%s+',' ')))

	local mirrors = {}
-----------------
	local tmp = {}
	usd.relocationmode(0)
	for url in page:gmatch( "<td [^>]-id='stat%d+_%d+'>%s*<a href='([^']+)" ) do
		usd.waittime(1)
		usd.setreferer(origUrl)
		local tmpurl = uri((url:gsub(' ','%%20')))()
		page = usd.get(tmpurl)
		debugSaveInc(logpref..'.html', page, tmpurl)
		local tmp2 = parseHeaders(usd.getheaders()).LOCATION1
		if tmp2 then -- multimirrorupload.com
			table.insert(mirrors, tmp2)
		else
			table.insert(tmp, tmpurl)
		end
	end

	local frame = page:match("<frame src='([^']-counter)'>")
	if frame then
		page = usd.get(frame)
		debugSaveInc(logpref..'.html', page)
		local wait = page:match('var count = (%d+);')
		usd.waittime(wait+2,3)

		for k, v in ipairs(tmp) do
			usd.setreferer(frame)
			usd.relocationmode(0)
			page = usd.get(v,'%simple%')
			debugSaveInc(logpref..'.html', page)
			table.insert(mirrors, parseHeaders(usd.getheaders()).LOCATION1 or '<no_location>')
		end
	elseif #tmp~=0 then
		for i, v in ipairs(tmp) do table.insert(mirrors, v) end
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows=info})
end

regDirSuccess( {
	'.uploadmagnet.com/'
	, '//multi.hotshare.biz/'
    , '//multiupload.biz/'
    , '//multimirrorupload.com/'
	--, '//directmirror.com/', '.directmirror.com/'
}, GDL, OS)

-- xfilemirror
