
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v04'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings[script.name] or {interactive = false, qualityList = {'mp4', '720p', '480p', '240p'}}
	debugLog(serialize(conf,nil,nil,true))

	local fmt = origUrl:match('#fmt=(%w+)')

	uri = URI.parse(origUrl)

	if uri.host=='ep.xhamster.com' then
		debugSaveInc(logpref..'.html', usd.head(origUrl))
		local h = parseHeaders()
		if h.CODE==200 then
			usd.setretresult(origUrl,0,1)
		else
			usd.setretresult(h.CODE==404 and '%notfound%' or '%'..h.REASON)
		end
		return
	end

	uri.host = 'es.xhamster.com'
	origUrl = uri()

	if uri.p[1]=='photos' then
		if uri.p[2]=='gallery' then
			local n = origUrl
			while n do
				page = usd.get(n)
				debugSaveInc(logpref..'.html', page)
				n = page:match('<link rel="next" href="([^"]+)')
				for u in page:match("<table [^>]- class='iListing'>.-</table>"):gmatch("<a href='([^'#]+)") do
					usd.addquery(u)
				end
			end
			return usd.setretresult('%done%')
		end

		page = usd.get(origUrl)
		debugSaveInc(logpref..'.html', page)
		dirUrl = page:match("id='imgSized'[^>]-src='([^']+)")
		script.tmp.newName = filterUtf8(entityDecode(page:match('<title>(.-)</title>'):gsub(' > foto #(%d+)$',function(n)return '-'..pad(n,2)end)))
		usd.setretresult(dirUrl, 0, 1)
		return
	end


	if origUrl:find('/xembed.php') then
		page = usd.get(origUrl)
		debugSaveInc(logpref..'.html', page)
		origUrl = page:match('class="noFlash" href="([^?"]+)')
	end

	page = usd.get(origUrl)
	local data = parseJsObject(page:match('var settings = {.-</script>') or '')
	debugSaveInc(logpref..'.html', page, serialize(data or "<nil>",nil,true))

	local h = parseHeaders()
	if h.CODE~=200 then	return usd.setretresult((h.CODE==404 or h.CODE==410) and '%notfound%' or '%'..h.REASON) end

	usd.waittime(2, 2)

	local videoUrls = data and data.sources or {}
	videoUrls.mp4 = page:match('href="([^"]+)" class="mp4Thumb"')

	origUrl = page:match('rel="canonical" href="([^"]+)')

	local duration = page:match('<div class="item"><span>Duraci..n:</span> ([%d:]+)<') or '--:--'
	local title = utf8ToAnsi(entityDecode(page:match('<h1>([^<]+)') or '<no title>'))
	script.tmp.newName = filterName(title,true)

	if fmt then
		debugSaveInc(logpref..'.html', usd.head(videoUrls[fmt]))
		usd.setretresult(usd.getlocation(), 1, 1)
		return
	end

	if conf.interactive then
		local urls = {}
		local info = {}
		for k, v in ipairs(conf.qualityList) do
			if videoUrls[v] then
				usd.setreferer(origUrl)
				debugSaveInc(logpref..'.html', usd.head(videoUrls[v]), v)
				local h = parseHeaders(usd.getheaders())
				urls[v] = h.LOCATION
				local size = h.SIZE and pad(('%0.2f'):format(h.SIZE / 1024 / 1024), 7, '  ') or ' ??????'
				table.insert(info, ('%s MB - %s'):format(size, v))
			end
		end
		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[tonumber(q)]:match(' %- (%S+)$')
		fmt = q
		usd.modquery(origUrl .. '#fmt='..fmt)
		usd.setretresult(urls[q], 0, 0)
		return
	end

	for k, v in ipairs(conf.qualityList) do
		if videoUrls[v] then
			debugSaveInc(logpref..'.html', usd.head(videoUrls[v]), v)
			usd.modquery(origUrl .. '#fmt='..v)
			usd.setretresult(usd.getlocation(), 0, 0)
			return
		end
	end

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( '//xhamster.com/', GDL, OS)
regDirSuccess( '.xhamster.com/', GDL, OS)
