
function GDL(origUrl)
	logpref = script.name..'_GDL_0000'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, dirUrl
	script.tmp={}

	if not origUrl:find('/download/',1, true) then
		page = utf8ToAnsi(usd.get(origUrl))
		debugSaveInc(logpref..'.html', page)
		dirUrl = page:match('value="(.-)" class="do_button"')

		if not dirUrl then
			err = page:match('class="body"><h1>(.-)<')
			if err then
				usd.savetolog('Error: '..err)
				return usd.setretresult('%notfound%')
			end
			return usd.setretresult('%download not found')
		end

		script.tmp.newName = page:match('<div>: <a .->(.-)<')
	else
		dirUrl = origUrl
	end

	usd.waittime(math.random(1,7))
	usd.relocationmode(0)
	page = usd.get(dirUrl)
	debugSaveInc(logpref..'.html', page)
	dirUrl = usd.getheaders():match('Location: ([^%c]+)', 2)
	if not dirUrl then return usd.setretresult('%dirUrl not found') end
	usd.waittime(2)
	page = usd.get(dirUrl)
	debugSaveInc(logpref..'.html', page)
	dirUrl = usd.getheaders():match('Location: ([^%c]+)', 2)
	if not dirUrl then return usd.setretresult('%dirUrl not found') end

	usd.setretresult(dirUrl, 1,1)
	return
end

function OS(origUrl, dirUrl, fullName)
	if script.tmp.newName then
		usd.setretresult(fileRename(fullName, script.tmp.newName))
	end
	return
end

regDirSuccess( '//7ba.ru/', GDL, OS )
regDirSuccess( '//7ba.org/', GDL, OS )

