--	http://www.fayloobmennik.net/*

function GDL(origUrl)
	usd.setstatus(script.name)
	logpref = script.name..'_GDL_0005'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, badpage, form, err, dirUrl
	script.tmp={}

	page, badpage = tryDl(origUrl, nil,nil, '</[Hh][Tt][Mm][Ll]>')
	debugSaveInc(logpref..'.html', page or badpage)
	if badpage then return usd.setretresult('%Bad page') end
	if page:find('>  !<',1, true) then
		return usd.setretresult('%notfound%')
	end

	form = page:match('<FORM method="POST">.-</FORM>')
	if form then
		form = Form.parse(form)
		form.inputs.file_user_password = origUrl:match("://([^@/]-)@")
		if not form.inputs.file_user_password then
			local default = usd.getoption(script.name,'Default', '')
			local dlg = Dialog.new( {
				{ ' :   '..origUrl }
				, { ' :', {name='password', type='password', default} }
				}, script.name)
			form.inputs.file_user_password = dlg:show():match("password=(.-)\n")
		end
		if origUrl:find('@') then usd.waittime(math.random(3,9)) end
		page = form:submit()
		debugSaveInc(logpref..'.html', page)
	end

	local redirect = page:match('function redirect(.-) onclick="redirect')
	if not redirect then
		err = page:match('<p>([^<]+)</p><div class="block_download_o"')
		if err then return usd.setretresult('%'..err) end
		return usd.setretresult('%redirect not found')
	end
	redirect = string.gsub(redirect,'\\','')
	dirUrl = redirect:match('<A href="([^"]+)"')

	if not dirUrl then return usd.setretresult('%dirUrl not found') end
	if not dirUrl:find('://',1, true) then dirUrl = 'http://'..getHost(origUrl)..'/'..dirUrl end
	script.tmp.newName = page:match('<h3><[^>]+>([^<]+)</h3>')

	usd.setretresult(dirUrl, math.random(1,4),1)
	return
end

function OS(origUrl, dirUrl, fullName)
	usd.waittime(2)
	if script.tmp.newName then
		usd.setretresult(fileRename(fullName, script.tmp.newName))
	end
	return
end

regDirSuccess( 'fayloobmennik.net/', GDL, OS )

