--  http://kickload.com/file/*

function GDL(origUrl)
    logpref = script.name..'_GDL_0001'
    usd.setstatus(logpref:gsub('_GDL_',' '))
    local page = usd.get(origUrl)
    debugSaveInc(logpref..'.html', page)

    local err = page:match('<hr>([^<]+)</div>')
    if err then
        usd.savetolog(page:match('<h2>([^<]+)</h2>'))
        usd.savetolog('Error: '..err)
        return usd.setretresult('%notfound%')
    end

    local form = page:match('<form method="post">.-</form>')
    if not form then
        return usd.setretresult('%No free download?')
    end
    form = Form.parse(form)
    usd.waittime(math.random(1,7))
    page = form:submit()
    debugSaveInc(logpref..'.html', page)

    local wait = page:match('<div id="time2wait" style="display:inline;">([^<]+)</div>') or 0
    form = page:match('(<form method="post".-</form>)')
    form = Form.parse(form)

    usd.setretresult(form.action, wait+math.random(1,7),1, form:getinputs())
    return
end

regDirSuccess( '//kickload.com/file/', GDL )

