--	http://www.mirrorcreator.com/*	--	http://mir.cr/*

function GDL(origUrl)
	usd.setstatus(script.name)
	logpref = script.name..'_GDL_0013'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, err, link, dirUrl
	local conf = Settings and Settings[script.name]
		or { interactive = false }
	script.tmp = {}

	local stat
	local id = origUrl:match('[0-9A-Z]+')
	if id then
		page = usd.get('http://mir.cr/'..id)
		debugSaveInc(logpref..'.html', page)
		stat = page:match('\n%s*ajaxRequest%.open%("GET", "([^"]+)", true')
		if not stat then return usd.setretresult('%stat not found') end
		stat = 'http://www.mirrorcreator.com'..stat
	end
	page, err = tryDl(stat, nil,nil, '<th>Upload status</th>')
	debugSaveInc(logpref..'.html', page or err)
	if not page then return usd.setretresult('%Upload status not found') end

	stat = page
	local mirrors = {}
	local redirecturl
	for m, l in stat:gmatch('alt="([^"]+)"%s*></td>%s*<td class="dl_link"><a href="([^"]+)"') do
		usd.waittime(math.random(1,7))
		page = usd.get(l)
		--debugSaveInc(logpref..'.html', page)
		redirecturl = page:match('class="highlight redirecturl">https?://([^/]+/[^%c<]+)')
		if redirecturl then
			usd.savetolog(' * '..m)
			redirecturl = 'http://'..redirecturl
			usd.savetolog(redirecturl)
			m = m:lower()
			table.insert(mirrors, redirecturl)
		end
	end
	usd.savetolog('mirrors = '..serialize(mirrors))

	if not script.tmp.sites then
		--	       .      USDownloader.ini \ [Plugin_mirrorcreator_com] \ Sites = ...
		script.tmp.sites = usd.getoption(script.name,'Sites', 'RGhost, SendSpace, ShareBeast, SockShare, SolidFiles, OneFichier, PutLocker, RapidShare, BayFiles, CyberLocker, DataFileHost, DepositFiles, GameFront, HipFile, FileApe, FilesFm, JumboFiles, Loadto, MediaFire, Minus, UploadBox, Uptobox, UppIt, UsersCloud, Ziddu, ZShare')
		script.tmp.sites = script.tmp.sites:lower():gsub(' ','')
	end
	usd.savetolog('sites = '..script.tmp.sites)

	for m in script.tmp.sites:gmatch('[^, ]+') do
		script.tmp.sites = script.tmp.sites:match(m..',*([%w,]+)') or ''
		usd.savetolog('Try '..m)
		local mirr = {}
		table.insert(mirr, serialize(mirrors):match('http://[^"]+'..m..'[^"]+'))
		local status, err = getMirror(mirr)
		if status then return end
	end

end

regDirSuccess( '//mir.cr/', GDL, OS)
regDirSuccess( 'mirrorcreator.com/', GDL, OS)

