--	http://rghost.ru/*	http://rghost.net/*

function GDL(origUrl)
	usd.setstatus(script.name)
	logpref = script.name..'_GDL_0019'
	usd.savetolog(': '..logpref:gsub('_GDL_',' '))
	local page, badpage, err, form, dirUrl
	script.tmp={}

	origUrl = origUrl:gsub('://ad%-file%.com', '://rghost.ru')

	page, badpage = tryDl(origUrl, nil,nil, '</head>')
	if badpage then
		usd.get('http://google.com/none')
		page, badpage = tryDl(origUrl, nil,nil, '</head>')
	end
	debugSaveInc(logpref..'.html', page or badpage)
	page = utf8ToAnsi(page)

	script.tmp.newName = page:match("%.filename = '([^']+)'")
		or page:match('<h1>%s*(.-)%s*<small class="nowrap">')
	if script.tmp.newName then
		script.tmp.newName = script.tmp.newName:gsub('<[^>]+>','')
	end

	form = page:match("id=['\"]password_field['\"]>.-(<form .-</form>)")
	if form then
		form = Form.parse(form)
		form.inputs.password = origUrl:match("://([^@/]-)@")
		if not form.inputs.password then
			local default = usd.getoption(script.name,'Default', '')
			local dlg = Dialog.new( {
				{ ' :   '..origUrl }
				, { ' :', {name='password', type='password', default} }
				}, script.name)
			form.inputs.password = dlg:show():match("password=(.-)\010")
		end
		usd.setcookie(usd.getcookie() ..'\r\n'.. 'X-Requested-With: XMLHttpRequest', 1)
		page = usd.post('http://'..getHost(origUrl)..'/'..form.action, '%simple%authenticity_token='..form.inputs.authenticity_token..'\npassword='..plg.recode(CP_ACP, CP_UTF8, form.inputs.password))
		debugSaveInc(logpref..'.html', page)
		page = utf8ToAnsi(page)
	end

	dirUrl = page:match("%.fileurl = '([^']+)'")
		or page:match('href=\\?"([^\\"]+)\\?" class=\\?"btn btn%-primary')
		or page:match('href=\\?"([^\\"]+)\\?" class=\\?"btn large download')

		err = page:match('role="alert">(.-)</')
			or page:match('alert%-error">(.-)</')
			or page:match('GET Error:%s?(.-)%c')

		if err then
			if err == ' ' or err == 'File is deleted' then
				return usd.setretresult('%deleted%')
			end
			if err == 'Not Found' then
				return usd.setretresult('%notfound%')
			end
			if err == 'Forbidden' or
				err == ' ' or err == 'File is unavailable' or
				err == '   ' or err == 'Access to the file is restricted' then
				usd.savetolog('Error: '..err)
				return usd.setretresult('%notfound%')
			end
			return usd.setretresult('%Error: '..err)
		end

	if not dirUrl then
		local help = page:match("class=\\'help%-block\\'>(.-)<\\/")
			or page:match('class=\\"help%-block has%-error\\">(.-)<\\/')
			or page:match('"help%-inline\\">(.-)<')
		if help then return usd.setretresult('%'..help:gsub('\\n',' ')) end
		return usd.setretresult('%dirUrl not found')
	end

	if not dirUrl:find('://',1, true) then dirUrl = 'http://'..getHost(origUrl)..'/'..dirUrl end
	usd.waittime(math.random(1,4))
	usd.relocationmode(0)
	local hdr = 'Range: bytes=0-255'
	setHeader(hdr)
	page = usd.get(dirUrl)
	debugSaveInc(logpref..'.html', page)
	local r = usd.getheaders():match('Location: ([^%c]+)', 2) or dirUrl
	usd.relocationmode(1)
	setHeader(hdr, true)

	if not r:find('/download/',1, true) then
		usd.savetolog('wrong dirUrl :(')
		usd.waittime(30)
		usd.get(origUrl)
		usd.waittime(math.random(1,4))
		page = usd.get(dirUrl)
		debugSaveInc(logpref..'.html', page)
		r = usd.getheaders():match('Location: ([^%c]+)', 2) or dirUrl
	end
	if not r:find('/download/',1, true) then
		usd.get('http://google.com/none')
		return usd.setretresult('%wrong dirUrl')
	end

	dirUrl = r

	return usd.setretresult(dirUrl, 0,1)
end


function OS(origUrl, dirUrl, fullName)
	usd.waittime(2)
	if script.tmp.newName then
		usd.setretresult(fileRename(fullName, script.tmp.newName))
	end
	return
end

regDirSuccess( {'.rghost.ru/', '.rghost.net/'}, GDL, OS)
regDirSuccess( {'//rghost.ru/', '//rghost.net/'}, GDL, OS)
regDirSuccess( {'@rghost.ru/', '@rghost.net/'}, GDL, OS)
regDirSuccess( '//ad-file.com/', GDL, OS)
regDirSuccess( '//rgho.st/', GDL, OS)
regDirSuccess( '@rgho.st/', GDL, OS)
