--	http://upwap.ru/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0000'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, form, err, dirUrl
	script.tmp={}

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	err = page:match('<span class="attention">(.-)<')
	if err then
		usd.savetolog('Error: '..utf8ToAnsi(err))
		return usd.setretresult('%notfound%')
	end

	form = page:match('<form action="http://upwap.ru/.-</form>')
	if form then
		form = Form.parse(form)
		form.inputs.pwd = origUrl:match("://([^@/]-)@")
		if not form.inputs.pwd then
			local default = usd.getoption(script.name,'Default', 'password')
			local dlg = Dialog.new( {
				{ ' :   '..origUrl }
				, { ' :', {name='password', type='password', default} }
				}, script.name)
			form.inputs.pwd = dlg:show():match("password=(.-)\n")
		end
		if origUrl:find('@') then usd.waittime(math.random(3,9)) end
		page = form:submit()
		debugSaveInc(logpref..'.html', page)
	end

	dirUrl = page:match('<a href="(/d/[^"]+)">')
	if not dirUrl then
		err = page:match('<div class="body">([^<]+)<')
		if err then return usd.setretresult('%Error: '..utf8ToAnsi(err)) end
		return usd.setretresult('%dirUrl not found')
	end
	script.tmp.newName = utf8ToAnsi(page):match('class="tp"> &laquo;(.-)&raquo;<')
	usd.setretresult('http://upwap.ru'..dirUrl, math.random(1,7),1)
	return
end

function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess( '//upwap.ru/', GDL, OS )
regDirSuccess( '@upwap.ru/', GDL, OS )

