
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}

	dirUrl = page:match('_url%s*=%s*"(http[^"]+)";')
	if dirUrl then
		dirUrl = unescape(dirUrl)
		debugSaveInc(logpref..'.html', usd.head(dirUrl))
		usd.setretresult(usd.getlocation(), math.random(2,4), 1)
		return
	end

	local tmp = page:match('<div id="streams"><center>.-<div id="downloads">')
	local videos = {}
	local playlist = page:find('<li><a[^>]+>Playlist')
		or page:find('<div id="slink">.-</div>%s*<p align="center">%s*</p>')
	if playlist then debugLog('playlist') end

	local tmp = page:match('<div class="vmargin">.-<div class="chat">') -- animeget.com
		or page:match('<div class="postcontent">.-<div class="wprp_wrapper">')

	for v in tmp:gmatch('<iframe[^>]-src="([^"]+)"') do
		debugLog(v)
		if playlist then
			usd.addquery(v)
		else
			if getMirror({v}) then
				if getLstInfo().url == origUrl then usd.modquery(v) end
				return
			end
			table.insert(videos,v)
		end
	end

	if #videos==0 then
		usd.setretresult('%done%')
		return
	end

	debugLog('---- unsupported:')
	for k, v in ipairs(videos) do
		debugLog(v)
		usd.modquery(v)
	end

	usd.setretresult('%unsupported hostings...', 10)

end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '.animeget.com/', GDL, OS)
regDirSuccess( '//videowing.me/', GDL, OS)
regDirSuccess( '//easyvideo.me/', GDL, OS)
regDirSuccess( '//videozoo.me/', GDL, OS)
