
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, form

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local fname = page:match('<td[^>]+><b>File name:</b></td>%s*<td[^>]+>(.-)</td>')	-- filer.cx
		or 'noname'..os.time()
	fname = utf8ToAnsi(fname)
	if setPusdName(fname) then return end

	script.tmp={}
	usd.waittime(2, 2)

	for i=1, captchaAttempts do
		form = page:match( '<form name="?myform"?.-</form>' )
		local captcha = form:match('<img id=dynimg[^>]-src="(.-)">')
		form = Form.parse(form)
		form.inputs.captchacode = queryCaptcha(captcha)
		page = form:submit()
		debugSaveInc(logpref..'.html', page)
		dirUrl = page:match('http://[^/]+/getfile%.php%?[^\'"%s]+')
		if dirUrl then break end
	end

	local wait = page:match("var timeout='(%d+)';")
	usd.waittime(wait+2, 2)

	local host = getHost(origUrl):gsub('([-.])','%%%1')
	script.tmp.newName = utf8ToAnsi(unescape(dirUrl:match('&name=([^&]+)'):gsub('^'..host..'%-','')))
	--dirUrl = addNewName(dirUrl, name) --  

	usd.setretresult(dirUrl, math.random(2,4), 0)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( {'//axifile.com/', '.axifile.com/'}, GDL, OS)
regDirSuccess( {'//filer.cx/', '.filer.cx/'}, GDL, OS)
regDirSuccess( {'//uploadilcloud.com/', '.uploadilcloud.com/'}, GDL, OS)
