
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form
	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local wait = page:match('<a id="downloadLink"[^>]->(.-)</a>'):gsub('<.->',''):gsub('^%s*(.-)%s*$','%1'):gsub('%s%s+',' ')
	local wait1, wait2 = wait:match('Wait (%d+):(%d+) Mins')
	if wait1 then
		usd.setretresult('%Server report: You need wait ' .. (wait1 * 60 + wait2) .. ' seconds')
		return
	end

	script.tmp={}
	usd.waittime(2, 2)

	local downsess = page:match('var downsess = "(.-)"')
	local f_id = page:match("var f_id='(.-)'")

	local key = page:match('script%?k=([^\'"%s]+)')

	form = Form.make { action='http://bytesbox.com/ajax.solvcaptcha.php', method='post', inputs = {downsess=downsess} }
	form.inputs.adcopy_response
		, _
		, form.inputs.adcopy_challenge
		= querySolvemedia(key, nil, nil, nil, nil, true)
	setXHR()
	page = form:submit()
	debugSaveInc(logpref..'.html', page)
	local data = parseJsObject(page)
	if data.status:upper() ~= 'SUCCESS' then
		usd.setretresult('%Bad captcha?')
		return
	end

	form.action = 'http://bytesbox.com/getdownlink.php'
	form.inputs = {down_sess=downsess, file=f_id}
	setXHR()
	page = form:submit()
	setXHR(true)
	debugSaveInc(logpref..'.html', page)

	data = parseJsObject(page)

	usd.setretresult(data.link, math.random(2,4), 1)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '//bytesbox.com/!/', GDL, OS)
