
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v05'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form
	script.tmp={}

	local id = origUrl:match('[?&]i=(%w+)') or origUrl:match('/d/(%w+)')
	if id then origUrl = 'http://www.datafile.com/d/'..id end

	local function fixCookies()
		local c = splitKV(usd.getcookie(),'=',';')
		for k, v in pairs(c) do if v=='deleted' then c[k]=nil end end
		usd.setcookie(tableConcat(c,'=','; '))
	end

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	fixCookies()

	local shit = page:match("counter.contdownTimer%('(%d+)'")

	local err = page:match('<div class="error%-msg">%s*(.-)%s*</div>')
		or page:match('<span class="error%-text" >(.-)%s*<')
		or page:match('<div>This file can be downloaded only by users with<br />Premium account!</div>')
	if err then
		if err:find('file was deleted') or err:find('only by users with<br />Premium') then
			err='deleted%'
		end
		usd.setretresult('%'..err)
		return
	end

	origUrl = usd.getlocation()

	script.tmp={}
	local newName = utf8ToAnsi(page:match('<div class="file%-name">([^<]+)</div>'))

	form = Form.make{action='http://www.datafile.com/files/ajax.html', method='post', inputs = {doaction='validateCaptcha', fileid = id}, referer=origUrl}
	queryReCaptcha {form=form, key='6LdWgNgSAAAAACXqFKE69ttVU-CfV-IruHtDKCUf', check=true}

	usd.setreferer(origUrl)
	setXHR()
	page = form:submit()
	local data = parseJsObject(page) or {}
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
	setXHR(true)
	fixCookies()

	local function checkError(data)
		local err = data.errorMessage
			or data.success==0 and (data.msg or '<no msg>')
			or data.link and data.link:match('/download/error.html')
		if err then
			usd.setretresult('%'..err)
			return true
		end
	end

	if checkError(data) then return end

	usd.waittime(math.min(shit or 90, 90))

	--form.inputs.fileid = id
	form.inputs.token = data.token
	form.inputs.doaction='getFileDownloadLink'
	usd.setreferer(origUrl)
	setXHR()
	page = form:submit()
	data = parseJsObject(page) or {}
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
	setXHR(true)
	fixCookies()

	if checkError(data) then return end

	if data.success == 1 then
		dirUrl = addNewName(data.link ,newName)
		usd.setretresult(dirUrl, 0, 0)
		return
	end

	usd.setretresult('%plugindefect')
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

function OC(dirUrl, fullName, headers, currStatus)
	script.tmp.newName = filterName(utf8ToAnsi(parseHeaders(headers).FILENAME), true)
end


regDirSuccess( 'datafile.com/d', GDL, OS)

regCheckError( '.datafile.com/', OC)
