
function GDL(origUrl) 	-- GetDirectLink

--[[
usdLua_settings.lua:

Settings['exoshare_com'] = { interactive = false, remember = false  }

interactive -    
remember -  ,  m.lua

]]

	local conf = Settings and Settings[script.name]
	if not conf then
		conf = { interactive = false, remember = false }
	end

	logpref = script.name .. '_GDL_v05'
	usd.setstatus(script.name)

	origUrl = origUrl:match('^([^#]+)')

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2)

	local name, size = page:match('<div align="left">%s*<p>%s*<strong>.-:</strong>%s*([^<]+)<br />%s*<strong>.-:</strong>%s*([^<]+)<br />')
	if not name then name, size = page:match('<div align="center">%s*<p>%s*Name : ([^<]+)<br />%s*Size : ([^<]+)<') end				-- exoshare
	if not name then name, size = page:match('<div align="center">%s*<p>%s*<h1>([^<(]-) %(([^<]+)%)</h1>') end				-- exoshare
	local status = page:match('function ajaxFunction%(%){.-ajaxRequest%.open%("GET", "([^"]+)"')
	page = usd.get(status)
	debugSaveInc(logpref..'.html', page)

	local mirrors = {}
	local pref = origUrl:match('^[^/]+//[^/]+')
	for url in page:gmatch('</img></td><td><a href="?([^\'"%s>]+)') do
		if url:find('^/') then url = pref..url end
		debugSaveInc(logpref..'.html', usd.head(url))
		table.insert(mirrors, usd.getlocation())
	end

	script.tmp={}

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows=info})
	if status then
		script.tmp.mirror = _
	end

	return
end

function OS(origUrl, dirUrl, fullName)
	if not (script.tmp and script.tmp.mirror) then
		return
	end
	local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	if OShandler then
		if h then debugLog('substring: '..h) end
		OShandler(script.tmp.mirror, dirUrl, fullName)
		return
	end
	debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end


regDirSuccess( '//exoshare.com/download.', GDL, OS)
regDirSuccess( '//multi.la/', GDL, OS)

-- /status.php?uid=
