
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}
	usd.waittime(2, 2)

	local newName = page:match('<b>File Details:</b>%s*<br>%s*Filename:%s*(.-)%s*<br>')
	if newName:find('[^%w.%s-]') or newName:find('&%w+;') then newName = 'noname'..os.time() end

	form = page:match( '<form name="myform".-</form>' )
	local captcha = form:match('<img id="img" src="(.-)"')
	form = Form.parse(form)
	form.inputs.code = queryCaptcha(captcha)

	usd.setretresult(
		addNewName(URI.combine(origUrl, form.action)(), newName)
		, math.random(2,4)
		, 1
		, form:getinputs()
	)
	return
end

function OE(dirUrl, errMsg, data)
	--'Connection aborted on request'
	--if errMsg == 'Not Found' then -- ࠢ쭮 
		usd.setretresult(1)	-- '1' - cPart
		script.tmp.status=1
	--end
end

function OC(dirUrl, fullName, headers, currStatus)
	if script.tmp.status then
		usd.setretresult(script.tmp.status)	-- '1' - cPart
	end
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	if not script.tmp.status then
		local newName = utf8ToAnsi(fullName:match('\\([^\\]+)$'))
		return usd.setretresult(fileRename(fullName, newName))
	end
end



regDirSuccess( '.filedropper.com/', GDL, OS)
regCheckError( '.filedropper.com/', OC, OE)
