
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if not page:find('<[Ff]orm') and page:find('</[hH][tT][mM][lL]>') and (
			page:find('id="foot')
			or page:lower():find('premium')
			or page:lower():find('dmca')
		)
		or page:find('>File Not Found<')
		or usd.getheaders():find('404 Not Found',1,true)
		or page:find('>The file was removed')
		or page:find('>The file was deleted',1,true)
		or page:find('<div class="content">%s*Reason for deletion :')	-- secureupload.eu
		or page:find('<h2 class="file">File: <span> </span>[]</h2>',1,true) -- lumfile
		then
		usd.setretresult('%notfound%')
		return
	end

	local checkError = function(str)

		if str:find('storebox%d*%.info') then
			local msg = getHost(usd.getlocation())..': Trojan accelerator detected!'
			usd.setstatus(msg)
			usd.savetolog(msg)
		end

		local _, err = str:match('<(%a+) class="err"[^>]->(.-)</%1>')
		err = err or str:match('>Error</td></tr>%s*<tr><td align=center>%s*<font style="color:#d33;">(.-)</font>')	-- sinhro.net
		err = err
			or str:match('<div class="alert alert%-error">(.-)</div>')		-- megaload.it
			or str:match('<span style="color:#666666;">Reason:%s*([^<]+)')	-- filemates.com
			or str:match('>%s*(You need to upgrade to Premium to download this file)') -- filemates.com
		if err and not err:find('^%s*$') then
			err = err:gsub('<[^>]+>',' ')
			debugLog('err: '..err)
			local h = err:match('%s(%d+) hour') or 0
			local m = err:match('%s(%d+) minute') or 0
			local s = err:match('%s(%d+) second') or 0
			local count = (h*60+m)*60+s
			if count > 0 then
				usd.setretresult('%Server report: You need wait ' .. count .. ' seconds')
				--return err ~= 'Wrong captcha'
				return true
			end

			if err:find('File Not Found')
				or err:find('Content copyright restriction')
				or err:find('No such file with this filename')
				then
				usd.setretresult('%notfound%')
				return true
			end

			usd.setretresult('%'..err)
			return not err:lower():find('captcha')
		end
	end

	if checkError(page) then return end


	script.tmp={}
	usd.waittime(3, 3)

	local dform = '<[Ff]orm[^>]-class="download%d+_form".-</[Ff]orm>'
	form = page:match( dform )
	form = Form.parse(form)
	page = form:submit("method_free")
	debugSaveInc(logpref..'.html', page)

	if checkError(page) then return end

	script.tmp.newName = utf8ToAnsi(form.inputs.fname)

	local wait = page:match( '<div class="wait%-txt"><span[^>]+>(%d+)<' )
	usd.waittime(wait+3, 3)

	form = page:match( dform )
	form = Form.parse(form)
	page = form:submit("method_free")
	debugSaveInc(logpref..'.html', page)

	local tmp = page:match("eval%(unescape%('(%%66.-)'")
	tmp = unescape(tmp)
	dirUrl = tmp:match('href="(http://[^/]+/d/[^"]+)"')

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( {'//filerio.in/', '.filerio.in/', 'filekeen.com/'}, GDL, OS)
