
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	uri = URI.parse(origUrl)

	local folderId = uri.path:match('^/u/(%w+)')

	if folderId then
		page = usd.get('http://api.files.fm/api/get_file_list_for_upload.php?hash='..folderId)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data,nil,true))

		local urls = {}
		for k, v in ipairs(data) do
			table.insert(urls, ('http://files.fm/down.php?i=%s&n=%s#%0.2fMB'):format(v.hash, filterName(utf8ToAnsi(v.name), true), v.Size/1024/1024))
		end

		if #urls~=1 then
			for k, v in ipairs(urls) do usd.addquery(v) end
			return usd.setretresult('%done%')
		end
		uri = URI.parse(urls[1])
	end

	if uri.path=='/down.php' then
		local newName = uri.query:match('n=([^&]+)')
		if setPusdName(newName) then return end
		return usd.setretresult(uri(),1,1) --fragment
	end

end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
--end


regDirSuccess( '//files.fm/', GDL, OS)
regDirSuccess( '.files.fm/', GDL, OS)
