
function GDL(origUrl, params) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}
	params = params or {}

	local conf = Settings[script.name] or {	maxGifSize = 128*1024 }
	debugLog(serialize(conf,nil,nil,true))

	--origUrl = 'http://gfycat.com/'..origUrl:match('^[^/]+//[^/]+/(%w+)')
	local id = origUrl:match('^[^/]+//[^/]+/(%w+)')

	page = usd.get('http://gfycat.com/cajax/get/'..id)
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>', nil, true))

	if data.error then
		err = data.error:find('^%w+ does not exist%.$') and 'notfound%' or data.error
		usd.setretresult('%'..err)
		return
	end

	data = data.gfyItem

	dirUrl = data.gifUrl
	if data.gifSize > conf.maxGifSize then dirUrl = data.mp4Url end

	if params.newName then dirUrl =	addNewName(dirUrl, params.newName, nil, nil, -1) end

	dirUrl = dirUrl:gsub('^https:','http:')

	usd.setretresult(dirUrl, math.random(2,4), 1)
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
--end


regDirSuccess( {'//gfycat.com/','.gfycat.com/'}, GDL, OS)
