
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)

	local conf = Settings and Settings[script.name]
		or { interactive = false, remember = false }

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}
	usd.waittime(2,2)

-----------------
	--local name, size = page:match('>Name : (.-)</h3>%s*<[^>]+>%s*Size : (.-)<')
	local name, size = page:gsub('<!%-%-.-%-%->',' '):match('<div align="center"[^>]*>%s*<h3[^>]*>Name :%s*(.-)</h3>%s*<p>%s*<[^>]+>%s*Size : (.-)<')

	local status = page:match('function ajaxFunction%(%){.-ajaxRequest%.open%("GET", "([^"]+)"')
	page = usd.get(status)
	debugSaveInc(logpref..'.html', page)

	local mirrors = {}
	local wait
-----------------
	for rurl in page:gmatch('href="?(/redirect/[^"%s]+)[^>]->%s*<img src="?/images/click.') do
		usd.setreferer(origUrl)
		local page = usd.get(rurl)
		debugSaveInc(logpref..'.html', page)
		if not wait then
			wait = page:match('show_url%((%d+)%)');
			usd.waittime(wait+2,2)
		end
		page = usd.get(page:match('href="(/down/[^"]+)"'))
		debugSaveInc(logpref..'.html', page)
		local url = page:match('<frame name="main" src="([^"]-)%s*"')
		if url then table.insert(mirrors, url) end
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows=info})
	if status then
		script.tmp.mirror = _
	end

	return
end

function OS(origUrl, dirUrl, fullName)
	if not (script.tmp and script.tmp.mirror) then
		return
	end
	local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	if OShandler then
		if h then debugLog('substring: '..h) end
		OShandler(script.tmp.mirror, dirUrl, fullName)
		return
	end
	debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end


regDirSuccess( 'gigamirror.com/download', GDL, OS)
