
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, form

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('>Download error</h2>%s*<div[^>]->%s*<p[^>]->%s*<strong>(.-)<')
	if err then
		if err:find('^This file %( .- %) has been removed')
			or err:find('The file you are looking for is not available')
			then
			usd.setretresult('%deleted%')
		else
			usd.setretresult('%'..err)
		end
		return
	end

	script.tmp={}
	usd.waittime(2, 2)

	script.tmp.newName = utf8ToAnsi(page:match('<div class="fileInfo">%s*<h4>.-<strong title="(.-)">'))

	form = page:match( '<form[^>]-id="downloadForm">.-</form>' )
	local adsurl = form:match('http://api.adscaptcha.com/[^\'"%s]-%.aspx[^\'"%s]+')
	form = Form.parse(form)
	form.action = URI.combine(origUrl, form.action)()

	form.inputs.adscaptcha_response_field
		, _, form.inputs.adscaptcha_challenge_field
		= queryAdsCaptcha(adsurl)

	page = form:submit()
	debugSaveInc(logpref..'.html', page)
	--{"status":1}

	usd.waittime(30)

	page = usd.get('/formtoken')
	debugSaveInc(logpref..'.html', page)

	form.inputs.token = page
	form.inputs.rnd = math.random(1e8) .. math.random(1e8)
	form.inputs.adscaptcha_response_field, form.inputs.adscaptcha_challenge_field = nil
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	usd.waittime(3,3)
	local data = parseJsObject(page)

	usd.relocationmode(0)
	debugSaveInc(logpref..'.html', usd.get(data.redirect))
	dirUrl = usd.getheaders():match('%sLocation: (http[^%s]+)')
	dirUrl = addNewName(dirUrl, script.tmp.newName)

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( 'gigasize.com/get/', GDL, OS)
