local S = Settings['<rtmpgw>']
local player = 'http://player.grabnetworks.com/swf/GrabOSMFPlayer.swf'
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page

	local conf = Settings[script.name] or { tryHttp = true }

	if not S then
		local err = "%Settings['<rtmpgw>'] is not found in "..plg.plgname.."_settings.lua"
		usd.setstatus(err)
		usd.savetolog(err)
		if not conf.tryHttp then
			usd.setretresult(err)
			return
		end
	end

	if S then
		debugSaveInc(logpref..'.html', usd.get(S.gateway), 'Checking rtmpgw')
		if not usd.getheaders():find('Server: HTTP-RTMP Stream Server',1,true) then
			plg.exec(S.gatewayCmd, false, S.gatewayCmdFlags)
			usd.waittime(S.gatewayCmdPause)
			debugSaveInc(logpref..'.html', usd.get(S.gateway))
			if not conf.tryHttp and not usd.getheaders():find('Server: HTTP-RTMP Stream Server',1,true) then
				return usd.setretresult('%rtmpgw not found')
			end
		end
	end

--http://player.grabnetworks.com/swf/GrabOSMFPlayer.swf?id=1234567&content=v8888888888888888888888888888888888888888

	local id = origUrl:match('[?&]id=(%d+)')
	local content = { origUrl:match('[?&]content=(%w)(%x+)') }

	if not id or #content==0 then
		page = usd.get(origUrl)
		debugSaveInc(logpref..'.html', page)
		local tmp = page:match('"http://player.grabnetworks.com/swf/.-"')
		if tmp then
			id = tmp:match('[?&]id=(%d+)')
			content = { tmp:match('[?&]content=(%w)(%x+)') }
		end
		if not id or #content==0 then
			local key = page:match('<div class="playerMain">.-"key":"(.-)"')
			page = usd.get((page:match('<script id="grab%-vcl%-video%-player%-script" type="text/javascript" src=\'(.-)\'></script>')))
			debugSaveInc(logpref..'.html', page)
			page = usd.get((page:match('} else {%s* document.write%(%s*\'<script type="text/javascript" src=\\\'(.-)\\\'><\\/script>')))
			debugSaveInc(logpref..'.html', page)
			id = page:match("'parade%-vcl%-demo%-player',%s*'(%d+)'")
			page = usd.get('http://content.grabnetworks.com/options/'..id..'.json')
			debugSaveInc(logpref..'.html', page)
			local data = parseJsObject(page)
			debugSaveInc(logpref..'.html', serialize(data, nil, true), nil, false)
			content={data.grabnetworks.content:match('(%w)(%x+)')}
		end
	end

-- v - video

-- p - playlist
-- http://publisher.grabnetworks.com/video/watch?grabnetworks_video_id=47

	page = usd.get( ('http://content.grabnetworks.com/%s/%s?from=http://publisher.grabnetworks.com/'):format( content[1], content[2] ) )
	debugSaveInc(logpref..'.html', page)

	script.tmp={}

	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', serialize(data, nil, true), nil, false)

	if data.videos then	-- playlist
		for k, v in ipairs(data.videos) do
			usd.addquery('http://publisher.grabnetworks.com/video?video_id='..v.video.id)
		end
		usd.setretresult('%done%')
		return
	end

	script.tmp.newName = utf8ToAnsi(data.video.title)
	script.tmp.newExt = '.flv'
	local stream = data.video.media.stream.low

	if conf.tryHttp then
		dirUrl = 'http://mobile-video.grab-media.com/' .. stream.url:match('/cfx/st/[^:]-:?([^:]+)$')
		local tmp = usd.head(dirUrl)
		debugSaveInc(logpref..'.html', tmp)
		if tmp:find('HTTP/%d%.%d 200 ')
			and tmp:find('Content-Type: binary/octet-stream',1,true)
			and tmp:find('Content-Length:',1,true)
			then
			usd.setretresult(dirUrl, 0, 1)
			return
		end
	end

	dirUrl = ('%s?W=%s&r=%s'):format(S.gateway, escapeUC(player), escapeUC(stream.url) )

	usd.setretresult(dirUrl, 0, 0)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, script.tmp.newExt))
end

function OE(dirUrl, errMsg, data)
	--if errMsg == 'Connection aborted on request' then
		script.tmp.status = 1	-- '1' - cPart
		--usd.setretresult(script.tmpstatus, 5)
	--	return
	--end
end

function OC(dirUrl, fullName, headers, currStatus)
	if script.tmp.status then
		usd.setretresult(script.tmp.status, 5)
	end
	if currStatus == 1 then
		local e = 'Download error - press stop!'
		usd.savetolog(e)
		usd.setstatus(e)
		usd.waittime(60)
	end
end


regDirSuccess( '.grabnetworks.com/swf/', GDL, OS)
regDirSuccess( '.grabnetworks.com/video', GDL, OS)

if S then
	regCheckError( S.gateway .. '?W='..escapeUC(player), OC, OE)

	regDestroy(function()
		if S.gatewayKillCmd then
			plg.exec(S.gatewayKillCmd, true, S.gatewayKillCmdFlags or SW_SHOWMINNOACTIVE)
		end
	end)

end
