
function GDL(origUrl) 	-- GetDirectLink
	usd.setstatus(script.name)
	logpref = script.name .. '_GDL_v10'
	usd.head(origUrl)
	local dirUrl
	script.tmp={}

	local pDir = '//cdn%d+%.'

	local tmp = usd.getlocation()
	if tmp:find(pDir) then
		usd.setretresult(tmp, 1, 1)
		return
	elseif tmp:find('/404.php')	then
		usd.setretresult('%notfound%')
		return
	end

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('<h2>File no longer available!</h2>',1,true)
		or page:find('<h2>Error</h2>%s*<div class="contentPageIn">%s*<b>Invalid user.</b>')
		or page:find('<h2>This file has been subject to a DMCA')
	then
		usd.setretresult('%deleted%')
		return
	end

	--local newName = page:match('<title>(.-) %- Hulk Share %-  Music Distribution Platform</title>')
	local newName = page:match('<meta property="og:title" content="([^"]+)" />')
	script.tmp.newName = utf8ToAnsi(newName)

	usd.waittime(2, 2)

	dirUrl = page:match('<a class="rebLink" href="(http://www.hulkshare.com/dl/[^"]+)"')
		or page:match('<a href="([^"]+)"[^>]-bigDownloadBtn')
	local tmp = usd.head(dirUrl)
	debugSaveInc(logpref..'.html', '')

    if not usd.getlocation():find(pDir)
    	or not tmp:find('Content-disposition: attachment',1,true)
    	and tmp:find(' 200 OK')
    	then
    	page = usd.get(dirUrl)
		debugSaveInc(logpref..'.html', page)
    	dirUrl = page:match('href="([^"]+)"[^>]-class="regDown"')
    	usd.waittime(2, 2)
    	usd.head(dirUrl)
    end


	usd.setretresult(usd.getlocation(),1,1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	if script.tmp.newName then
		usd.setretresult(fileRename(fullName, script.tmp.newName))
		return
	end
end

regDirSuccess( '//hulkshare.com/', GDL, OS)
regDirSuccess( '.hulkshare.com/', GDL, OS)
regDirSuccess( '//hu.lk/', GDL, OS)
