
function GDL(origUrl, params) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	origUrl = origUrl:gsub('#.*$','')

	script.tmp.newName = (params or {}).newName

	if origUrl:find('//%d+%.imagebam%.com/download/') then return usd.setretresult(origUrl,0,1)	end

	if origUrl:find('/gallery/',1,true) then
		local nextPage = origUrl
		while nextPage do
			page = usd.get(nextPage)
			debugSaveInc(logpref..'.html', page)
			local title = page:match("<fieldset>%s*<legend><img src='/img/icons/photos.png'[^>]*>([^<]+)")
			title = filterName(utf8ToAnsi(trim(title or '')), true)
			if #title>0 then title='#'..title end
			for u in page:gmatch('%[URL=(http://www.imagebam.com/image/%x+)%]') do usd.addquery(u..title) end
			nextPage = page:match('"pagination_current">%d+</a> <a href=\'([^\']+)\' class="pagination_link"')
		end
		usd.setretresult('%done%')
		return
	end

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find("<BODY>%s*<img[^>]-/imagebam_logo_small.gif'[^<]+<div[^>]+>The image has been deleted") then
		usd.setretresult('%deleted%')
		return
	end

	dirUrl = page:match('<meta property="og:image" content="([^"]+)"')

	usd.setretresult(dirUrl, 0, 1)
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end

regDirSuccess('.imagebam.com/', GDL, OS)
