
function GDL(origUrl) 	-- GetDirectLink

	logpref = script.name .. '_GDL_v05'
	usd.setstatus(script.name)
	script.tmp={}

	local conf = Settings and Settings[script.name]
	if not conf then
		conf = { interactive = false, remember = false }
	end

	usd.setcookie('jlanguage=en-US')
	local id = origUrl:match('^[^/]+//[^/]+/[^/]+/([^/]+)')
	origUrl = 'http://jheberg.net/download/'..id..'/'

	local page = usd.get('http://jheberg.net/api/verify/file/?id='..id)
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))

	usd.setreferer('')
	usd.waittime(2,2)
	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2,2)

	page = usd.get(page:match('<a href="(/mirrors/[^"]+)"'))
	debugSaveInc(logpref..'.html', page)

-----------------
	local name, size = data.fileName, ('%0.2fMB'):format(data.fileSize / 1024 / 1024)

	local mirrors = {}
-----------------
	usd.waittime(2,2)

	local ref = usd.getlocation()
	local uri = URI.parse(ref)
	local redirect = page:match("redirect_url%s*=%s*'(.-)';")

	usd.relocationmode(0)
	for s,h in page:gmatch( 'href="/redirect/([^"/]+)/([^"/]+)' ) do
		usd.waittime(4)
		usd.setreferer(ref)
		setXHR()
		local tmp = usd.post('http://www.jheberg.net/get/link/','%simple%slug='..s..'&hoster='..h)
		setXHR(true)
		debugSaveInc(logpref..'.html', tmp)
		local url = tmp:match('"url": "([^"]+)"')
		if url then
			table.insert(mirrors, url)
		end
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows=info})
end

regDirSuccess( '.jheberg.net/', GDL, OS)
regDirSuccess( '//jheberg.net/', GDL, OS)
