
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local tmp = ('%s%s-%s-%s.tmp'):format(usd.workdir, script.name, plg.plgname, plg.exename)
	usd.get(origUrl..'|'..tmp)
	page = fileRead(tmp)
	if page:find('^\31\139\8%z') then
		debugLog('gzipped')
		page = zlib.decompress(page,31)
	end
	if page then os.remove(tmp) end
	debugSaveInc(logpref..'.html', page)

	if usd.getheaders():find('%sHTTP/%d%.%d 404') then
		usd.setretresult('%notfound%')
		return
	end

	script.tmp={}
	usd.waittime(2, 2)

	script.tmp.newName = utf8ToAnsi(page:match('class="fileName">([^<]+)'))

	dirUrl = base64.dec(page:match("onclick=\"download_file%('([^']+)"))
	dirUrl = addNewName(dirUrl, script.tmp.newName)

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( '//limelinx.com/', GDL, OS)
