
function GDL(origUrl) 	-- GetDirectLink
	usd.setstatus(script.name)
	logpref = script.name .. '_GDL_v05'

--[[
usdLua_settings.lua:

Settings['multi_up_com'] = { interactive = false }

interactive -    

]]

	local conf = Settings and Settings[script.name]
		or { interactive = false }

	script.tmp={}

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	page = utf8ToAnsi(page)
	page = page:match('<div id="content">.-<div id="sidebar">')

	local name = page:match(':%s+([^\r\n]+)')
	local size = page:match(':%s+([^\r\n]+)')

	local mirrors = {}		--  - ,  - 
	for url, h in page:gmatch('<li><a href="([^"]+)"[^>]+>([^<]+)</a>') do
		table.insert(mirrors, url)
	end

	if not next(mirrors) then return usd.setretresult('%notfound%') end	--  

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows=info})

	if status then script.tmp.mirror = _ end --  OnSuccess

	return
end

function OS(origUrl, dirUrl, fullName)
	if not script.tmp.mirror then return end
	local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	if OShandler then
		if h then debugLog('substring: '..h) end
		OShandler(script.tmp.mirror, dirUrl, fullName)
		return
	end
	debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end

regDirSuccess( '//multi-up.com/', GDL, OS)
