
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('<h3>The file was removed by administrator</h3>',1,true)
		or page:find('<li>The file was deleted by its owner',1,true)
		then
		usd.setretresult('%deleted%')
		return
	end

-- <p class="err">Wrong captcha</p>
-- <p class="err">You have to wait 1 minute, 32 seconds till next download<br><br>Download files instantly with <a href='http://www.multishare.org/?op=payments'>Premium-account</a></p>
	local err = page:match('<p class="err">.-</p>')
	if err then
		err = err:gsub('<[^>]+>',' ')
		local h = err:match('%s(%d+) hour') or 0
		local m = err:match('%s(%d+) minute') or 0
		local s = err:match('%s(%d+) second') or 0
		local count = (h*60+m)*60+s
		if count == 0 then
			usd.setretresult('%'..err)
			return
		end
		usd.setretresult('%Server report: You need wait ' .. count .. ' seconds')
		return
	end

	usd.waittime(2, 2)

	--local dir = 'http://serve%d+%.multishare%.org:%d+/d/[^\r\n\'"]+'
	local dir = 'http://serve%d+%.multishare%.org:?%d-/d/[^\r\n\'"]+'

	local dirUrl = page:match(dir)
	if dirUrl then return usd.setretresult(dirUrl, 1, 1) end

	usd.relocationmode(0)

	local form = page:match('<Form name="F1".-</Form>')
	if form.action == '' then form.action = origUrl end
	form = Form.parse(form)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2, 2)

	dirUrl = (usd.getheaders() .. page):match(dir)

	if not dirUrl then

		for i=1, captchaAttempts do
			form = page:match('<Form name="F1".-</Form>')
			local key = form:match('%?k=([^"]+)')
			form = Form.parse(form)
			if form.action == '' then form.action = origUrl end
			form.inputs.recaptcha_response_field
				, _, form.inputs.recaptcha_challenge_field
					= queryReCaptcha(key)
			page = form:submit()
			debugSaveInc(logpref..'.html', page)
			dirUrl = usd.getheaders():match(dir)
			if dirUrl then break end
		end
	end

	if not dirUrl then
		err = page:match('<p class="err">.-</p>') or 'plugindefect'
		usd.setretresult('%'..err)
		return
	end

	usd.setretresult(dirUrl, 1, 1)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, newName))
--end


regDirSuccess( 'multishare.org/file/', GDL, OS)
