
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings[script.name] or {qualityList = {'low','lowest','mobile'}}
	debugLog('conf='..serialize(conf,nil,nil,true))

	local fmt = origUrl:match('#fmt=(%w+)')
	origUrl = origUrl:gsub('#fmt=.*$','')

	uri = URI.parse(origUrl)

	page = usd.get(origUrl)
	local data = entityDecode(page:match('data%-options="([^"]+)"') or '')
	data = parseJsObject(data)
	if data and data.flashvars and data.flashvars.metadata then data.flashvars.metadata = parseJsObject(data.flashvars.metadata) end
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))

	data = data.flashvars.metadata

	script.tmp.newName = filterUtf8(data.movie.title)

	local videos = {}
	for k, v in ipairs(data.videos) do videos[v.name] = v.url end

	if fmt then return usd.setretresult(videos[fmt],1,1) end

	for k, v in ipairs(conf.qualityList) do
		if videos[v] then
			usd.modquery(origUrl..'#fmt='..v)
			usd.setretresult(videos[v],1,1)
			return
		end
	end

	fmt, dirUrl = next(videos)
	usd.modquery(origUrl..'#fmt='..fmt)
	usd.setretresult(dirUrl,1,1)
end

function OS(origUrl, dirUrl, fullName, headers)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, getProperExt(fullName)))
end


regDirSuccess( '//ok.ru/video/', GDL, OS)
