
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local id = origUrl:match('/tracks/(%w+)')
	if id then
		setXHR()
		page = usd.get('http://pleer.com/tracks/'..id)
		setXHR(true)
		debugSaveInc(logpref..'.html', page)
		script.tmp.newName = filterName(utf8ToAnsi(page:match('<h1>([^<]+)</h1>')) ,true)
		page = usd.get('http://pleer.com/site_api/files/get_url?action=download&id='..id)
		debugSaveInc(logpref..'.html', page)
		dirUrl = addNewName(page:match('"track_link":"(http[^"]+)'), script.tmp.newName)
		usd.setretresult(dirUrl, math.random(2,4), 1)
		return
	end

	id = origUrl:match('[?&]id=(%w+)')
	if id then
		page = usd.get('http://embed.pleer.com/track_content?id='..id)
		debugSaveInc(logpref..'.html', page)
		local err = page:match('error="([^"]+)')
		if err then
			err = utf8ToAnsi(err)
			if err == '    ' then err ='notfound%' end
			return usd.setretresult('%'..err)
		end
		script.tmp.newName = filterName(utf8ToAnsi(page:match('name="([^"]+)')) ,true)
		dirUrl = unescape(page:match('[?&]url=(http%%[^&"]+)'))
		dirUrl = addNewName(dirUrl, script.tmp.newName)
		usd.setretresult(dirUrl, math.random(2,4), 1)
		return
	end

	usd.setretresult('%plugindefect')

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end


regDirSuccess( '//pleer.com/', GDL, OS)
regDirSuccess( '.pleer.com/', GDL, OS)
