
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings[script.name] or {interactive = false, qualityList = {'mp4', '720p', '480p', '240p'}}
	debugLog(serialize(conf,nil,nil,true))

	local fmt = origUrl:match('#fmt=(%w+)')

	local id = origUrl:match('viewkey=(%w+)') or origUrl:match('/embed/(%w+)')
	origUrl = 'http://www.pornhub.com/view_video.php?viewkey='..id

	page = usd.get(origUrl)
	local videoUrls = {}
	for q, u in page:gmatch("var player_quality_(%w+) = '([^']+)'") do videoUrls[q]=URI.combine('http://',u)() end
	debugSaveInc(logpref..'.html', page, serialize(videoUrls or '<nil>', nil, true))

	local title = utf8ToAnsi(page:match('data%-video%-title="([^"]+)"'))
	local duration = page:match('"video_duration":"(%d+)"')
	duration = duration and s2hms(tonumber(duration)) or '--:--:--'

	script.tmp.newName = filterName(title, true)

	if fmt then
		debugSaveInc(logpref..'.html', usd.head(videoUrls[fmt]))
		usd.setretresult(usd.getlocation(), 1, 1)
		return
	end

	if conf.interactive then
		local urls = {}
		local info = {}
		for k, v in ipairs(conf.qualityList) do
			if videoUrls[v] then
				usd.setreferer(origUrl)
				debugSaveInc(logpref..'.html', usd.head(videoUrls[v]), v)
				local h = parseHeaders(usd.getheaders())
				urls[v] = h.LOCATION
				local size = h.SIZE and pad(('%0.2f'):format(h.SIZE / 1024 / 1024), 7, '  ') or ' ??????'
				table.insert(info, ('%s MB - %s'):format(size, v))
			end
		end
		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[tonumber(q)]:match(' %- (%S+)$')
		fmt = q
		usd.modquery(origUrl .. '#fmt='..fmt)
		usd.setretresult(urls[q], 0, 0)
		return
	end

	for k, v in ipairs(conf.qualityList) do
		if videoUrls[v] then
			debugSaveInc(logpref..'.html', usd.head(videoUrls[v]), v)
			usd.modquery(origUrl .. '#fmt='..v)
			usd.setretresult(usd.getlocation(), 0, 0)
			return
		end
	end

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, '.mp4'))
end


regDirSuccess( '.pornhub.com/', GDL, OS)
