
function GDL(origUrl) 	-- GetDirectLink

--[[
usdLua_settings.lua:

Settings['uploadmirrors_com'] = { interactive = false, remember = false  }

interactive -    
remember -  ,  m.lua

]]

	local conf = Settings and Settings[script.name]
	if not conf then
		conf = { interactive = false, remember = false }
	end

	logpref = script.name .. '_GDL_v05'
	usd.setstatus(script.name)
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

-- <p>This file has been deleted by it's owner or blocked due to copyright violations</p>

	usd.waittime(2)

	local name, size = page:match('<div id="upload" align="center">%s*<p>%s*File Name : ([^<]+)<br />%s*File Size : ([^<]+)<br />')	-- uploadmirrors
	if not name then name, size = page:match('>File Name :<.-<strong>([^<]+)<.->Size:</font> <font size="2">([^<]+)<') end			-- shrta
	if not name then name, size = page:match('>File Name :<.-<b>([^<]+)<.->File Size :<.-<b>([^<]+)<') end							-- directmirror
	if not name then name, size = page:match('<p>%s*Name : ([^<]-)<br />%s*Size : ([^<]-)<br />') end								-- full2mirror
	if not name then name, size = page:match('>Download:</font> ([^<]+)</h3>.->File Size</font>: <[^>]+>([^<]+)<') end				-- calabox
	local status = page:match('function ajaxFunction%(%){.-ajaxRequest%.open%("GET", "([^"]+)"')
	page = usd.get(status)
	debugSaveInc(logpref..'.html', page)

	local mirrors = {}

-- <a href=/redirect/4QBTJVUW/2 target=_blank><img src="/images/click.gif" border='0' /></a>				-- directmirror

	for rurl in page:gmatch('href="?(/redirect/[^"%s]+)[^>]->%s*<img src="?/images/click.') do
		local page = usd.get(rurl)
		debugSaveInc(logpref..'.html', page)
		local url = page:match('<frame name="main" src="([^"]-)%s*"')
		if (url or ''):find('mediafire.com/%?$') then url = nil end
		if url then table.insert(mirrors, url) end
	end

	script.tmp={}

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows=info})
	if status then
		script.tmp.mirror = _
	end

	return
end

function OS(origUrl, dirUrl, fullName)
	if not (script.tmp and script.tmp.mirror) then
		return
	end
	local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	if OShandler then
		if h then debugLog('substring: '..h) end
		OShandler(script.tmp.mirror, dirUrl, fullName)
		return
	end
	debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end


regDirSuccess( 'uploadmirrors.com/download/', GDL, OS)
regDirSuccess( 'shrta.com/files/', GDL, OS)
--regDirSuccess( 'directmirror.com/files/', GDL, OS)
--regDirSuccess( '//full2mirror.com/files/', GDL, OS)
regDirSuccess( '//calabox.com/files/', GDL, OS)

-- /status.php?uid=
-- uberuploader?
