
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	script.tmp = {}
	local dirUrl, page, badpage, form

	local cacheKey = origUrl

	local uri = URI.parse(origUrl)
	local host = getHost(uri)

	local tmp = Cache.get(cacheKey)
	if tmp then
		script.tmp.newName = tmp.newName
		return
	end

	local checkDir = function(str)
		--local skiphead = {} -- {'free-uploading.com','potload.com'}
		--local noNewName = tableKeys('verzend.be')
		--local forceNewName = tableKeys('zshares.net','zshare.ma')
		local checkRefresh = {} --tableKeys('fiberupload.com')
		local checkHead = tableKeys('hugefiles.net')

		if getHost(uri)=='billionuploads.com' then
			str = str:gsub('<object.-</object>','')
		end

		dirUrl = str:match('"direct_link":"(http[^"]+)"')
			or str:match('<a id="lnk_download" href="(http://[^"]+)"')						-- 180upload.com
			or str:match('http://[^/]+/file_download/[^<\r\n\'"]+')
			or str:match('http://[%w.-]+:%d+/[d%d]/[^<\r\n\'"]+')
			or str:match('http://[%w.-]+:?%d-/files/%d/[^<\r\n\'"]+')
			or str:match('http://[%w.-]+:?%d-/cgi%-bin/dl.cgi[^<\r\n\'"]+')
			or str:match('http://[%w.-]+:?%d-/free_p/cgi%-bin/%w+/cgi%-bin/uploads/[^<\r\n\'"]+')
			or str:match("<div id='mp3player'>.-so%.addVariable%('file','([^']+)'")			-- cramit.in
			or str:match('http://[%w.-]+:?%d-/files/dl/[^<\r\n\'"]+') -- ryushare
			or str:match('http://[%w.-]+:?%d-/dl?/[^<\r\n\'"]+')		-- hostingbulk.com -- ryushare
			or str:match('%sLocation: (http://[^/]+/~s%d+filemac/files/%w+/%w+/[^\r\n]+)')	-- filemac.com

		dirUrl = dirUrl and not dirUrl:find('googlecode%.com/') and dirUrl


		if dirUrl then
			dirUrl = URI.recode(dirUrl)
			dirUrl = URI.combine(usd.getlocation(), dirUrl)()

			local dontCache = false
			local referer = usd.getlocation()

			if not dirUrl:find('/cgi-bin/dl.cgi',1,true) and checkRefresh[host] then
				for i=1, 6 do
					debugLog('refresh check '..i)
					dirUrl = URI.combine(usd.getlocation(), dirUrl)()
					local hdr = usd.head(dirUrl)
			  		debugSaveInc(logpref..'.html', hdr, 'html?')
			  		if hdr=='HEAD Error: Timeout' or hdr=='HEAD Error: Cannot Connect' then
			  			usd.setretresult('%'..hdr)
			  			return true
			  		end
					hdr = hdr:lower()
					if hdr:find('http/%d%.%d 502') then 	dontCache=true	break 	end
					if not hdr:find('content-type:',1,true) then debugLog('No answer?') break end
					if hdr:find('content%-type: [^\r\n]-stream') or hdr:find('content%-length:') then break end
					page = usd.get(dirUrl)
			  		debugSaveInc(logpref..'.html', page or badpage, 'refresh')
--<meta http-equiv="refresh" content="3;url=/d/
			  		dirUrl = page:match(dir) or page:match('"refresh" content="%d+;url=(/d/[^\r\n"]+)')
		  			wait = page:match('"refresh" content="(%d+)')
		  			usd.waittime(wait)
			  		dirUrl = dirUrl or usd.getlocation()
	  			end

				debugSaveInc(logpref..'.html', usd.head(dirUrl), 'checkDir')
				if usd.getheaders():lower():find('content-type: text/html',1,true) then return false end
				dirUrl = usd.getlocation()
			end
			local tmp = str:match('<input type="hidden" name="fname" value="([^"]+)"')
				or str:match('<b>Filename:</b></td><td[^>]+>([^<]+)')
				or str:match(' property="og:title" content="([^"]+)"')
				or str:match('<b>Filename:</b></td><td nowrap>([^<]+)</td></tr>')
				or str:match('<img src="../images/download.jpg" align="absbottom" />([^<]-)%s*<')
			script.tmp.newName = script.tmp.newName or (tmp and utf8ToAnsi(tmp))
			if script.tmp.newName then
				--and (not dirUrl:find('/cgi-bin/dl.cgi',1,true) or forceNewName[getHost(uri)])
				--and not dirUrl:find('/cgi-bin/dl.cgi',1,true)
				--and not noNewName[getHost(uri)]
				script.tmp.newName = filterName(script.tmp.newName, true)
				if not dirUrl:find('/cgi-bin/dl.cgi',1,true) then dirUrl = addNewName(dirUrl, script.tmp.newName) end
			end

			dontCache = dontCache or dirUrl:find('/cgi-bin/dl.cgi',1,true)
			if not dontCache then
				if checkHead[host] then
					debugSaveInc(logpref..'.html', usd.head(dirUrl), 'checkHead')
					if parseHeaders(usd.getheaders()).CODE~=200 then
						usd.setretresult('%HEAD check error')
						return true
					end
				end
				Cache.set(cacheKey, {dirUrl=dirUrl, cookie=usd.getcookie(), referer=referer, newName=script.tmp.newName})
			end

			usd.setretresult(dirUrl, math.random(2,4), 1)
			return true
		end
	end -- checkDir


	local wrongIP = 0
	local wrongCaptcha = 0

	local checkError = function(str)

		if str:find('storebox%d*%.info')
			or str:find('[./%s]ncdownloader%.com')
			or str:find('[./%s]down1oads%.com')
			or str:find('/91.205.157.43/',1,true)
			or str:find('1clickmoviedownloader',1,true)
			or str:find('smarterdownloader.com',1,true)
			or str:find('sharebeast_downloader')
			or str:find('applicationgrabb.net/')
			or str:find('.downloadboutique.com/')
			then
			local msg = getHost(usd.getlocation())..': Trojan accelerator detected!'
			usd.setstatus(msg)
			usd.savetolog(msg)
		end

		str = str:gsub('<font style="visibility:hidden">.-</font>','')	-- kingfiles.net

		local _, err = str:match('<(%a+) class="err"[^>]->(.-)</%1>')
		err = str:match('<a id="details"></a>Reason for deletion.:') and 'deleted%' or err
		err = err or str:match('>Error</td></tr>%s*<tr><td align=center>%s*<font style="color:#d33;">(.-)</font>')	-- sinhro.net
			or str:match('<div class="alert alert%-error">(.-)</div>')		-- megaload.it
			or str:match('<span style="color:#666666;">Reason:%s*([^<]+)')	-- filemates.com
			or str:match('>%s*(You need to upgrade to Premium to download this file)') -- filemates.com
			or str:match('<Center><b>(This file is available for Premium Users only.)</b>') -- cloudnes.com
			or str:match('<Center><b>(Due the high load.-)</b>')	-- fireget.com
			or str:match('<div class="templates">%s*<br><br>%s*<h1><b>(.-)</b></h1><br><br>') -- billionuploads.com
			or str:match('>File Not Found<')
			or str:match('>The file was removed')
			or str:match('>The file was deleted')
			or str:match('>No such file with this filename<')					-- oteupload
			or str:match('<span[^>]-class="premiumonlyfile">.-</span>')			-- oteupload
			or str:match('<div class="content">%s*Reason for deletion :')		-- secureupload.eu
			or str:match('<h2 class="file">File: <span> </span>[]</h2>',1,true) -- lumfile
			or str:match('You have to wait %d+ minutes?, %d+ seconds? till')
			or str:match('You have to wait %d+ seconds? till')
			or str:match('<div[^>]-id="not%-found"[^>]+>([^<]+)')
			or str:match('>This file is available for Premium users only.<')
			or str:match('class="alert alert%-danger"[^>]->([^<]+)')
		debugLog('err: '..(err or '<no err>') )
		if not err or trim(err)=='' then return end
		err = err:gsub('<[^>]+>',' '):gsub('^%s*(.-)%s*$','%1'):gsub('%s+',' '):lower()

		if err:find('wrong ip address') and wrongIP < 2 then	-- junocloud.me
			wrongIP = wrongIP + 1
			return
		end

		if (err:find('captcha') or err:find('wrong answer'))
			and wrongCaptcha < captchaAttempts
			then
			wrongCaptcha = wrongCaptcha + 1
			return
		end

		debugLog('err: '..err)
		local h = err:match('%s(%d+) hour') or 0
		local m = err:match('%s(%d+) minute') or 0
		local s = err:match('%s(%d+) second') or 0
		local count = (h*60+m)*60+s
		if count > 0 then
			usd.setretresult('%Server report: You need wait ' .. count .. ' seconds')
			--return err ~= 'Wrong captcha'
			return true
		end

		if err:find('file not found')
			or err:find('file is not found')
			or err:find('file was deleted')
			or err:find('file was removed')
			or err:find('reason for deletion')
			or err:find('file: []',1,true)					-- lumfile
			or err:find('content copyright restriction')
			or err:find('no such file with this filename')
			or err:find('premium to download')
			or err:find('for premium users only')
			or err:find('only for premium')
			or err:find('uploader set max file size for free use can download')
			then
			usd.setretresult('%notfound%')
			return true
		end

		if err:find('register or login for faster download') then -- hulkfile.eu
			return false
		end

		usd.setretresult('%'..err)
		return true
	end -- checkError


	local function getForm(page)
		local form
		local forms = {}
		for f in page:gmatch('<[Ff]orm.-</[Ff]orm>') do table.insert(forms, f) end

		for f in page:gmatch('<[Ff]orm.-</[Ff]orm>') do if f:find('download1') or f:find('method_isfree') then form = f; break end end

		if form then
			form = form:gsub("''\"","''")
			form = Form.parse(form)
			if form.inputs.id=='' then
				usd.setretresult('%notfound%')
				return
			end

			form.action = URI.combine(origUrl, form.action or '')()
			form.submits.method_premium = nil

			if page:find('?accounttype=free',1,true) then -- host=='filespace.com' then
				form.action = form.action..'?accounttype=free'
			end

			local fname = page:match("%$%('input%[name=\"fname\"%]'%).attr%('value',%s*'(.-)'%)")
			if fname then form.inputs.fname = fname end -- glumbouploads
			script.tmp.newName = form.inputs.fname and utf8ToAnsi(form.inputs.fname) or script.tmp.newName
		end

		return form
	end


	local function getCaptcha(form, page)
		local RCkey = page:match('/recaptcha/api/challenge%?k=([^"]+)')
		local SMkey = page:match('//api.solvemedia.com/papi/challenge.[no]-script%?k=([^"]+)')
		local code = form.html:match("<div style='width:80px;.-(<span.-)</div>")
		local captcha = form.html:match('src="([^"]-captcha[^"]+)"')
		captcha = captcha and not captcha:find('/recaptcha/') and captcha

		if SMkey then
			querySolvemedia({key=SMkey, check=true, form=form})
			wrongCaptcha = wrongCaptcha+captchaAttempts
		elseif RCkey then
			queryReCaptcha({key=RCkey, check=true, form=form})
			wrongCaptcha = wrongCaptcha+captchaAttempts
		elseif captcha then
			form.inputs.code = queryCaptcha(captcha)
		elseif code then
			local tmp = {}
			code:gsub("<span.-left:(%d+).->&#(%d+);</span>", function(l,n) tmp[tonumber(l)]=string.char(n) end)
			for j=0, table.maxn(tmp) do
				if tmp[j] then
					form.inputs.code = form.inputs.code .. tmp[j]
				end
			end
			usd.waittime(3,2)
		end

	end

-------------------------------------------------------------------------------------------------------------------

    usd.setcookie('lang=english') -- mlfat4arab.com
    origUrl = URI.recode(origUrl, CP_ACP)

	--local page = usd.get(origUrl)
	local page, badpage = tryDl(origUrl, nil, 2, '</[Hh][Tt][Mm][Ll]>')
	debugSaveInc(logpref..'.html', page or badpage, 'p1')
	if badpage then return usd.setretresult('%Bad page?') end
	origUrl = usd.getlocation()
	uri = URI.parse(origUrl)
	host = getHost(uri)

	page = page:gsub('<!%-%-[^-].-%-%->','')	-- megacache.net
	page = page:gsub('<h3[^>]*>.-</h3>','')

	if not page:find('<[Ff]orm') and page:find('</[hH][tT][mM][lL]>')
		and (page:find('id="foot') 	or page:lower():find('premium') or page:lower():find('dmca') )
		or usd.getheaders():find('404 Not Found',1,true)
		then
		usd.setretresult('%notfound%')
		return
	end

	for npage=1, 6 do
		if wrongCaptcha > captchaAttempts then return usd.setretresult('%bad captcha?') end
		if checkError(page) then return end

		local wait = page:find('setTimeout') and (
			page:match('id="countdown_str".->%s*(%d+)%s*<')
			or page:match('>%s*seconds%s*=%s*(%d+);')
			)
			or (page:match('<div id="countdownContainer">.-</div>') or ''):match('<span[^>]+>(%d+)</span>')
			or 1
		usd.waittime(wait+3, 3)

		if checkDir(usd.getheaders() .. page) then  return  usd.waittime(wait+3, 3)  end

		form = getForm(page)
		if not form then return usd.setretresult('%plugindefect: no form') end

		getCaptcha(form, page)

		usd.relocationmode(0)
		page = form:submit(form.submits.method_isfree and 'method_isfree' or nil)
		debugSaveInc(logpref..'.html', page, 'p2-'..npage)
		page = page:gsub('<!%-%-[^-].-%-%->','')	-- megacache.net
		page = page:gsub('<h3[^>]*>.-</h3>','')
	end

	local err = page:match('"msg":"([^"]+)"') or page:match('class="err">([^<]+)<') or 'plugindefect'
	return usd.setretresult('%'..err)

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	Cache.del(origUrl)
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

--function OE(dirUrl, errMsg, data)
--	if data == 'No file' then usd.setretresult(0) end
--end
--regCheckError('zshare.ma/cgi-bin/dl.cgi', nil, OE)

regDirSuccess( '//uploadrocket.net/', GDL, OS)
