
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v04'
	usd.setstatus(script.name)
	local dirUrl

	local conf = Settings and Settings[script.name] or {lowspeed = false}

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)


	function checkError()
		local tmp = utf8ToAnsi(page)
		local err = tmp:match('<span class="error">(.-)</span>')
			or tmp:match('<h2 class="error">(.-)</h2>')	-- <h2 class="error">    </h2>
			or tmp:match('<h2>(      )</h2>')
		if not err then return end
		if err == '     '
			or (conf.lowspeed and err == '    ')
			then
			return
		elseif err:find('  ') then
			usd.setretresult('%deleted%')
			return true
		end
		local wait = err:match(' (%d+) ')
		if wait then
			usd.setretresult('%Server report: You need wait ' .. wait*60 .. ' seconds')
		else
			usd.setretresult('%'..err)
		end
		return true
	end

	if checkError() then return end

	script.tmp={}
	usd.waittime(2, 2)

	local form = page:match( '<form action="".-</form>' )
	form = Form.parse(form)
	form.action = usd.getlocation()
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	if checkError() then return end

	if conf.lowspeed then
		-- 5Kb/s!
		--form = page:match('id="downloadAnyway".->%s*(<form.-</form>)')
		--if form then
		--	usd.waittime(2, 2)
		--	form = Form.parse(form)
		--	page = form:submit()
		--	debugSaveInc(logpref..'.html', page, 'downloadAnyway')
		--end
		usd.waittime(2,2)
		form.submits = {free = plg.recode(CP_ACP, CP_UTF8, '   ')}
		form.inputs.recaptcha_response_field = 'fuck'
		form.inputs.recaptcha_challenge_field = 'fuck'
		page = form:submit()
		debugSaveInc(logpref..'.html', page, 'lowspeed')
	end

	form = page:match( '<form action="".-</form>' )
	form = Form.parse(form)
	form.action = usd.getlocation()
	local wait = page:match('var%s+sec%s*=%s*(%d+)')
	usd.waittime(wait)

	local key = page:match("Recaptcha.create%('(.-)'")

	form.inputs.recaptcha_response_field
		, _, form.inputs.recaptcha_challenge_field
			= queryReCaptcha(key, 0, nil, nil, nil, true)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)
	dirUrl = page:match('href="(http://d%d+.upsto.re/[^"]+)"')
	if checkError() then return end

	usd.setretresult(dirUrl, math.random(2,4), 0)	-- no resume
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '//upsto.re/', GDL, OS)
regDirSuccess( '//upstore.net/', GDL, OS)
