
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v04'
	usd.setstatus(script.name)
	local dirUrl

	local uri = URI.parse(origUrl)

	usd.setcookie('ya_vss=adult=1.live=0', 1)

	origUrl = origUrl:match('^[^#]+')
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}

	if page:find('<li class="movie"><dl class="b-movie"><dt class="name">',1,true) then
		debugLog('list')
		local nextpage = true
		while nextpage do
			debugLog(tostring(nextpage))
			for u in page:gmatch('<i class="b%-frame"><a href="([^"]+)"') do
				debugLog(u)
				usd.addquery(uri(u)())
			end
			nextpage = page:match('<a id="next_page" href="([^"]+)"')
			if nextpage then
				usd.waittime(3,4)
				page = usd.get(uri(nextpage:gsub('&amp;','&'))())
				debugSaveInc(logpref..'.html', page)
			end
		end
		usd.setretresult('%done%')
		return
	end


	local newName = page:match('<title>(.-)</title>')
	newName = utf8ToAnsi(newName)
	newName = newName:gsub('[ -]*.$','')
	--usd.waittime(2, 2)

	if newName == '   ' then
		usd.savetolog(newName)
		usd.setretresult('%notfound%')
		return
	end

	if origUrl:find('^http://video.yandex.ru/external/') then
		local external = page:match('<p class="b%-external">[^<]+<br><a href="([^"]+)"')
		usd.modquery(external)
		if getLstInfo().url == origUrl then
			usd.setretresult('%Unsupported: '..external)
			return
		end
		usd.setretresult('%Restarting...',5)
		return
	end

	if not origUrl:find('/iframe/') then
		local ifr = page:match('src="(http://video.yandex.ru/iframe/[^"]+)"')
		page = usd.get(ifr)
		debugSaveInc(logpref..'.html', page)
	end

	local id = usd.getlocation():match('http://video.yandex.ru/iframe/([^?&#]+)')

	local data = page:match('onclick="return {\'b%-embed\':({name:\'b%-embed\',.-)}"'):gsub('&quot;','"')
	data = parseJsObject(data)

	debugSaveInc(logpref..'.html', serialize(data,nil,true), nil, false)

	local vname, vext, vbitrate
	vbitrate = 0
	for ext, extdata in pairs(data.html5) do
		for name, namedata in pairs(extdata.bitrate) do
			if namedata.bitrate > vbitrate then
				vbitrate = namedata.bitrate
				vname = namedata.file
				vext = ext
			end
		end
	end

	local token = data.url.token
	token = usd.get(uri(token..'?callback=ct')())
	debugSaveInc(logpref..'.html', token)
	token = token:match('"token"%s*:%s*"([^"]+)"')

	vname = vname or 'm450x334'
	vext = vext or 'flv'

	page = usd.get('http://streaming.video.yandex.ru/get-location/'..id..vname..'.'..vext..'?token='..token)
	debugSaveInc(logpref..'.html', page)

	dirUrl = page:match('<video%-location>(.-)</video%-location>'):gsub('&amp;','&')
	dirUrl = addNewName(dirUrl, newName)

	usd.setretresult(dirUrl, 1, 1)
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '//video.yandex.ru/', GDL, OS)

