
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2, 2)

	local form = page:match('<form[^>]-name="dfrm".-</form>')
	form = Form.parse(form)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	local tmp = page:lower()
	if tmp:find('ziddu accelerator') or tmp:find('="accelerator"') or tmp:find('storebox%d%.info') then
		local msg = 'Trojan accelerator detected!'
		usd.setstatus(msg)
		usd.savetolog(msg)
	end

	form = page:match('<form name="securefrm".-</form>')
	local captcha = form:match('<img src="(/CaptchaSecurityImages%.[^"]+)"')
	form = Form.parse(form)
	form.action = usd.getlocation():match('^[^/]+//[^/]+') .. form.action
	form.inputs.Keyword='Ok';
	form.inputs.accelerator = nil
	form.inputs.securitycode = queryCaptcha(captcha)

	usd.waittime(4, 2)

	usd.setretresult(form.action, 0, 1, form:getinputs())
	return
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, newName))
--end


regDirSuccess( '.ziddu.com/download/', GDL, OS)
